<?php
// BlackBoard - PHP Internet Newsboard System
// Copyright 2003-4 by Yves Goergen
// Homepage: http://blackboard.unclassified.de
// See docs/LICENSE.txt for distribution/license details
//
// css.php
// CSS definition file
//
// Design name: NearText Gray
// Author:      Yves Goergen
// Last edit:   20040531

header('Content-Type: text/css');
header('Expires: ' . gmdate('D, d M Y H:i:s GMT', time() + 3600 * 24));   // 1 day
include('../../bb_lib/ua.inc.php');
?>

/*--------------------  GLOBAL ELEMENTS  --------------------*/

body
{
	font: 12px/16px Arial,sans-serif;
	margin: 0px;
	background: #FFFFFF;
}
body.simple
{
	margin: 0px;
	background: #FFFFFF;
}
td.head
{
}
td.head td.logo
{
	padding: 10px 0px 12px 40px;
}
td.head td.time
{
	font-size: 10px;
	color: #339933;
	padding: 5px 10px;
}
td.navi
{
	border-top: solid 1px #E8E8E8;
	border-bottom: solid 1px #E8E8E8;
	padding: 0px 10px;
}
table.navlinks
{
}
table.navlinks td
{
	padding: 1px 5px;
}
table.navlinks td.sel
{
	background: #EFEFEF;
}
table.navlinks td.sep
{
}
td.navi span.sep
{
	border-left: solid 1px #E8E8E8;
	margin: -2px 0px;
	padding: 2px 0px 4px 0px;
}
td.loginctl
{
	padding: 0px 0px;
}
td.content
{
	padding: 10px 10px 20px 10px;
}
td.foot
{
	font: 10px Arial,sans-serif;
	color: #AAAAAA;
	padding: 3px 10px;
}

a
{
	color: #0051F6;
	text-decoration: none;
}
a:hover
{
	/*border-bottom: solid 1px #4D86FB;*/
	text-decoration: underline;
	/*color: #FF9000;*/
}
a.admin
{
	color: #168816;
}
a.foot
{
	color: #AAAAAA;
}

p, td, li, div
{
	font: 12px/16px Arial,helvetica,sans-serif;
}

.online_users
{
	font-size: 10px;
	color: #808080;
	margin-top: 3px;
}

.path
{
	margin-bottom: 8px;
}
.path .sep
{
	color: #FF4000;
}
.path .thread
{
	margin-top: 4px;
	font-size: 19px;
	line-height: 26px;
}
.path .desc
{
	font-size: 11px;
	color: #909090;
}

.actiontable
{
	margin: 3px 0px;
}
.actionbar_l, .actionbar_r
{
	color: #404040;
	padding: 2px 5px;
	margin: 3px 0px;
}

.error, .info
{
	font-weight: bold;
	color: #B00000;
	background: #FAFAFA;
	border: solid 1px #808080;
	padding: 3px;
}

.info
{
	color: #00B000;
}

input.text, textarea.text
{
	border: solid 1px #BBCDDD;
	background: #FAFAFA;
	color: #202020;
	font: 12px Arial,sans-serif;
	<?php if ($host_browser == "MOZ" || $host_browser == "FB") { ?>
	margin-top: 2px;
	<?php } ?>
}
textarea.text
{
	<?php if ($host_browser == 'IE' || $host_browser == 'KON') { ?>
	scrollbar-arrow-color: #666666;
	scrollbar-base-color: #FFFFFF;
	scrollbar-darkshadow-color: #CCCCCC;
	scrollbar-face-color: #E8E8E8;
	scrollbar-highlight-color: #F0F0F0;
	scrollbar-shadow-color: #E0E0E0;
	scrollbar-track-color: #FFFFFF;
	<?php } ?>
}
input.radio
{
	<?php if ($host_browser == "IE") { ?>
	margin-top: -2px;
	position: relative;
	top: 1px;
	margin-left: -2px;
	margin-right: 2px;
	<?php } ?>
	<?php if ($host_browser == "MOZ" || $host_browser == "FB") { ?>
	margin-top: 0px;
	position: relative;
	top: 3px;
	<?php } ?>
}
input.button
{
	<?php if ($host_browser != "OP" || $host_bver < 7) { ?>
	background: #E8E8E8 url(img/button_back_18.png);
	border: solid 1px #B0B0C0;
	<?php } ?>
	font: 12px Arial;
}
input.transparent
{
	font: 12px Arial;
	border: 0px;
	background: transparent;
	color: #202020;
	margin-bottom: 1px;
}

form
{
	margin: 0px;
}

small
{
	font-size: 10px;
	line-height: 13px;
	color: #707070;
}

.codelink
{
	font-size: 10px;
	line-height: 10px;
	color: #7070B0;
	<?php if($host_browser == 'IE' && $host_bver < '6.0') { ?>
	cursor: hand;
	<?php } else { ?>
	cursor: pointer;
	<?php } ?>
}

.highlight
{
	background: #FFA080;
}

option.forum
{
	color: #000000;
	background: #FFFFFF;
}
option.category
{
	color: #000000;
	background: #EEEEEE;
}
option.current
{
	color: #FFFFFF;
	background: #5080A0;
}

a img
{
	border: 0px;
}
.abbc a img
{
	border: 1px solid #0051F6;
}


/*--------------------  LIST VIEWS: MESSAGE  --------------------*/

.messagelist
{
	margin-top: 10px;
}

.list_message_warn_head_0,
.list_message_warn_head_left,
.list_message_warn_head_right
{
	background: #808080;
	color: #FFFFFF;
	font-weight: bold;
	padding: 2px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.list_message_warn_head_left
{
}
.list_message_warn_head_right
{
}

.list_message
{
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #E8E8E8;
}

.list_message_warn
{
	background: #F6F6F6;
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #E8E8E8;
}

.list_message .date,
.list_message_warn .date
{
	color: #707070;
	font-size: 10px;
}


/*--------------------  LIST VIEWS: FORUM, CATEGORY  --------------------*/

.list_forum_head_0,
.list_forum_head_left,
.list_forum_head_right
{
	background: #D8D8D8;
	color: #404040;
	font-weight: bold;
	padding: 2px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.list_forum_head_left
{
}
.list_forum_head_right
{
}

.list_weblink
{
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #E8E8E8;
}
.list_weblink .name
{
	font-size: 13px;
	font-weight: bold;
}
.list_weblink .desc
{
	margin-top: 2px;
	color: #808080;
}

.list_category
{
	background: #E8E8E8;
	color: #404040;
	padding: 3px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.list_category .name
{
	font-size: 13px;
	font-weight: bold;
}
.list_category .desc
{
	margin-top: 2px;
	color: #505050;
}

.list_category a
{
	color: #0051F6;
}
.list_category a:hover
{
}
.list_category a.admin
{
	color: #168816;
}

.list_forum,
.list_forum_0
{
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #E8E8E8;
}
.list_forum .name
{
	font-size: 13px;
	font-weight: bold;
}
.list_forum .desc
{
	margin-top: 2px;
	color: #808080;
}

.list_editforum
{
	background: #EDDCA3;
	color: #000000;
	padding: 2px 5px;
	border-bottom: solid 1px #FFFFFF;
}

.list_forum_more,
.list_forum_1,
.list_forum_2,
.list_forum_3,
.list_forum_4,
.list_forum_5
{
	background: #E8E8E8;
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #FFFFFF;
}

.list_forum_2
{
	background: #D8D8D8;
}
.list_forum_3
{
	background: #C8C8C8;
}
.list_forum_4
{
	background: #B8B8B8;
}
.list_forum_5
{
	background: #A8A8A8;
}


/*--------------------  LIST VIEWS: THREAD  --------------------*/

.list_thread_head_0,
.list_thread_head_left,
.list_thread_head_right
{
	background: #D8D8D8;
	color: #404040;
	font-weight: bold;
	padding: 2px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.list_thread_head_left
{
}
.list_thread_head_right
{
}

.list_thread,
.list_thread_important
{
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #E8E8E8;
}
.list_thread .desc,
.list_thread_important .desc
{
	margin-top: 2px;
	font-size: 10px;
	color: #808080;
}
.list_thread_important
{
	background: #F6F6F6;
}


/*--------------------  LIST VIEWS: POST  --------------------*/

.list_post_head_0,
.list_post_head_left,
.list_post_head_right
{
	background: #D8D8D8;
	color: #404040;
	font-weight: bold;
	padding: 2px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.list_post_head_left
{
}
.list_post_head_right
{
}

/* --- old layout --- */
.list_post_old_uname_0,
.list_post_old_datesubject_0,
.list_post_old_contactaction_0,
.list_post_old_avataruinfo_0,
.list_post_old_message_0,
.list_post_old_notes_0,
.list_post_old_thread_0
{
}
.list_post_old_uname_1,
.list_post_old_datesubject_1,
.list_post_old_contactaction_1,
.list_post_old_avataruinfo_1,
.list_post_old_message_1,
.list_post_old_notes_1,
.list_post_old_thread_1
{
}

.list_post_old_uname_0,
.list_post_old_uname_1
{
	color: #000000;
	padding: 3px 5px;
}
.list_post_old_datesubject_0,
.list_post_old_datesubject_1
{
	padding: 3px 5px;
	border-bottom: solid 1px #E8E8E8;
	color: #707070;
	font-size: 9px;
}
.list_post_old_contactaction_0,
.list_post_old_contactaction_1
{
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #E8E8E8;
}
.list_post_old_avataruinfo_0,
.list_post_old_avataruinfo_1
{
	padding: 0px 5px 3px 5px;
	border-bottom: solid 1px #E8E8E8;
	color: #808080;
	font-size: 10px;
	line-height: 13px;
}
.list_post_old_message_0,
.list_post_old_message_1
{
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #E8E8E8;
}
.list_post_old_notes_0,
.list_post_old_notes_1
{
	padding: 3px 5px;
	border-bottom: solid 1px #E8E8E8;
	color: #808080;
	font-size: 10px;
	line-height: 13px;
}
.list_post_old_thread_0,
.list_post_old_thread_1
{
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #E8E8E8;
}

.list_post_old_delimiter
{
	height: 4px;
	background: #E8E8E8;
}
.list_post_old_readline
{
	height: 4px;
	background: #909090;
}
.list_post_old_users
{
	/* background: #F4F4F4; */
}

/* --- new layout --- */
.list_post_new_avatar_0,
.list_post_new_unameinfo_0,
.list_post_new_date_0
{
	background: #F0F0F0;
}
.list_post_new_subject_0,
.list_post_new_message_0,
.list_post_new_notes_0,
.list_post_new_thread_0
{
}
.list_post_new_avatar_1,
.list_post_new_unameinfo_1,
.list_post_new_date_1
{
	background: #F0F0F0;
}
.list_post_new_subject_1,
.list_post_new_message_1,
.list_post_new_notes_1,
.list_post_new_thread_1
{
}

.list_post_new_unameinfo_0,
.list_post_new_unameinfo_1
{
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #E8E8E8;
}
.list_post_new_date_0,
.list_post_new_date_1
{
	padding: 3px 5px;
	border-bottom: solid 1px #E8E8E8;
	color: #707070;
	font-size: 10px;
}
.list_post_new_subject_0,
.list_post_new_subject_1
{
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #E8E8E8;
}
.list_post_new_message_0,
.list_post_new_message_1
{
	color: #000000;
	padding: 3px 5px;
}
.list_post_new_notes_0,
.list_post_new_notes_1
{
	padding: 3px 5px;
	border-top: solid 1px #E8E8E8;
	color: #808080;
	font-size: 10px;
	line-height: 13px;
}
.list_post_new_thread_0,
.list_post_new_thread_1
{
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #E8E8E8;
}

.list_post_new_delimiter
{
	height: 4px;
}
.list_post_new_endline
{
	height: 1px;
}
.list_post_new_topline
{
	height: 1px;
}
.list_post_new_readline
{
	height: 4px;
	background: #909090;
}
.list_post_new_users
{
	background: #F0F0F0;
	border-top: solid 1px #E8E8E8;
	padding: 0px 5px;
}

/* end */

.list_post_votes
{
	color: #000000;
	padding: 3px 5px;
}

.signature
{
	/*width: 65%;*/
	color: #707070;
	/*margin-top: 4px;*/
	border-top: solid 1px #E8E8E8;
	padding-top: 2px;
	padding-bottom: 1px;
}

.poll_table
{
	margin-bottom: 3px;
}

.list_post_question_0,
.list_post_question_left,
.list_post_question_right
{
	background: #808080;
	color: #FFFFFF;
	padding: 2px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.list_post_question_left
{
}
.list_post_question_right
{
}

.graph1
{
	font-size: 1px;
	height: 10px;
	background: #00C000;
	border-right: solid 2px #007000;
}
.graph0
{
	font-size: 1px;
	height: 10px;
	background: #D0D0D0;
}


/*--------------------  LIST VIEWS: USER  --------------------*/

.list_user_head_0,
.list_user_head_left,
.list_user_head_right
{
	background: #D8D8D8;
	color: #404040;
	font-weight: bold;
	padding: 2px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.list_user_head_left
{
}
.list_user_head_right
{
}

.list_user
{
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #E8E8E8;
}

.list_edituser
{
	background: #EDDCA3;
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #F8F8F8;
}


/*--------------------  LIST VIEWS: PROFILE  --------------------*/

.username
{
	font-weight: bold;
	font-size: 14pt;
}

.list_cp_head_0,
.list_cp_head_left,
.list_cp_head_right
{
	background: #D8D8D8;
	color: #404040;
	font-weight: bold;
	padding: 2px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.list_cp_head_left
{
}
.list_cp_head_right
{
}

.list_cp_n,
.list_cp_l,
.list_cp_x,
.list_cp_d
{
	color: #000000;
	padding: 3px 5px;
}
.list_cp_l,
.list_cp_d
{
	border-bottom: solid 1px #E8E8E8;
}
.list_cp_x
{
	border-left: solid 1px #E8E8E8;
}
.list_cp_d
{
	background: #FBFBFB;
	font-weight: bold;
}
.list_cp_e    /* extra fields */
{
	color: #000000;
	padding: 3px 0px;
}

.img_trans_back
{
	border: solid 1px #DDDDDD;
	background: url(img/trans_back.png);
}

table.cp_pages td.list_cp_l
{
	padding: 3px 1px;
}
.cp_nonselpage,
.cp_selpage
{
	padding: 0px 4px;
}


/*--------------------  EDIT POST  --------------------*/

.edit_post_head_0,
.edit_post_head_left,
.edit_post_head_right
{
	background: #D8D8D8;
	color: #404040;
	font-weight: bold;
	padding: 2px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.edit_post_head_left
{
}
.edit_post_head_right
{
}

.edit_post
{
	color: #000000;
	padding: 3px 5px;
	border-bottom: solid 1px #E8E8E8;
}


/*--------------------  SMILEYS  --------------------*/

.smiley_table
{
}

.smiley_cell_0,
.smiley_cell_1
{
	text-align: center;
}

.special_char
{
	font-size: 13px;
	cursor: default;
}


/*--------------------  LIST VIEWS: CONFIG  --------------------*/

.list_config_head_0,
.list_config_head_left,
.list_config_head_right
{
	background: #D8D8D8;
	color: #404040;
	font-weight: bold;
	padding: 2px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.list_config_head_left
{
}
.list_config_head_right
{
}

.list_config_n,    /* no line */
.list_config_l,    /* line, horizontal */
.list_config_en,   /* editing, no h-line*/
.list_config_el,   /* editing, h-line */
.list_config_dn,   /* dark, no line */
.list_config_dl,   /* dark, h-line */
.list_config_vn,   /* vertical line, no h-line */
.list_config_vl,   /* v-line, h-line */
.list_config_vdn,  /* v-line, dark, no h-line */
.list_config_vdl   /* v-line, dark, h-line */
{
	color: #000000;
	padding: 3px 5px;
}
.list_config_l,
.list_config_dl,
.list_config_vl,
.list_config_vdl
{
	border-bottom: solid 1px #E8E8E8;
}
.list_config_en,
.list_config_el
{
	background: #EDDCA3;
}
.list_config_el
{
	border-bottom: solid 1px #FFFFFF;
}
.list_config_dn,
.list_config_dl,
.list_config_vdn,
.list_config_vdl
{
	background: #EFEFEF;
}
.list_config_vn,
.list_config_vl,
.list_config_vdn,
.list_config_vdl
{
	border-left: solid 1px #E8E8E8;
}

.yes
{
	font-weight: bold;
	color: #00A000;
}
.no
{
	font-weight: bold;
	color: #C00000;
}
.more_detailed
{
	color: #C07000;
}

.tr_hover .list_config_l
{
	background: #E4E4E4;
}


/*--------------------  HELP  --------------------*/

.help_entry
{
	margin-top: 10px;
	border: solid 1px #CCCCCC;
	padding: 2px 4px;
}

.help_entry .keyword
{
	font-weight: bold;
	color: #0030A0;
}

.help_entry .content
{
	color: #404040;
	padding-left: 20px;
}


/*--------------------  SEARCH  --------------------*/

.search_head_0,
.search_head_left,
.search_head_right
{
	background: #D8D8D8;
	color: #404040;
	font-weight: bold;
	padding: 2px 5px;
	border-bottom: solid 1px #FFFFFF;
}
.search_head_left
{
}
.search_head_right
{
}

.search
{
	color: #000000;
	padding: 3px 5px;
}


/*--------------------  ABBC TAGS  --------------------*/

.abbc, .abbc .p, .abbc li
{
	font: 12px/16px Arial,sans-serif;
}
.abbc .qname
{
	font: italic 12px/14px Arial,sans-serif;
}

.abbc tt, .abbc .code
{
	font: 12px/16px Courier New,monospace;
}

.abbc .code
{
	background: #EEEEEE;
}
