<?php
// AdvancedBBCode 1.2
// http://software.unclassified.de/abbc
// Copyright 2003-4 by Yves Goergen
//
// Configuration File

$abbc_cfg = array(

// target frame and derefer script for auto-links
'target' => !$LoginUserID || $LoginUser->GetFlags() & 128 ? '_blank' : false,
'derefer' => $MODULE['derefer'] . PD . 'url=',

// activated subsets
'subsets' => ABBC_ALL & ~(ABBC_PARAGRAPH | ABBC_HTML),

// automatically close tags that are left open at the end of the text? default: false
'auto_close_tags' => false,

// embed the text output in <div> tags
// 0: disabled | 1: <div> | 2: <span>
'output_div' => 1,

// automatically make URLs clickable
'find_urls' => true,

// smiley images path (with trailing /)
'smilepath' => $design_path . '_smile/',

// this character is used to find ABBC_SPECIAL syntax bold text
// normally this is '' (bold text), but for UTF-8 we need to change this
// ISO-8859-1: 
// UTF-8     : °
'bold_char' => '°',

// base and monospace fonts
'basefont' => '11px/16px Verdana,Arial,sans-serif',
'monofont' => '12px/16px Andale Mono,Courier New,monospace',
'qnamefont' => 'italic 11px/13px Verdana,Arial,sans-serif',

// some tag's parameters, see abbc_css() for details
'custom_a' => false,
'a_color' => '#0040FF',
'a_decor' => 'none',
'a_color_hover' => '#0040FF',
'a_decor_hover' => 'none',
'm_color' => '#009000',
'code_color' => '#900000',
'code_back' => '#DEDEDE',
'code_padding' => '3px 2px 3px 2px',
'code_margin' => '3px 0px',
'quote_borderl' => 'solid 2px #606060',
'quote_borderl2' => 'solid 2px #888888',
'quote_borderl3' => 'solid 2px #B0B0B0',
'quote_colorl1' => '#000090',
'quote_colorl2' => '#800000',
'quote_colorl3' => '#007000',
'quote_padding' => '0px 0px 0px 10px',
'quote_margin' => '3px 0px',
'qname_color' => '#A0A000',
'par_margin' => '10px 0px',

// here are the custom colors for PHP syntax highlighting
'use_custom_php' => true,
'php_comment' => '#808080',
'php_default' => '#000000',
'php_html' => '#006000',
'php_keyword' => '#0000D0',
'php_string' => '#900000'
);

// Tag Definitions

// Following information is necessary for a BBCode tag:
//   tag          how the [tag] is named
//   htmlopen     what it's to be translated into (parameters used by $1, $2...)
//   htmlcont     new content inside the HTML tags, normally something like $1, $2...
//   htmlclose    closing HTML tag (optional)
//   htmlblock    this defines its own block, new-lines around it are removed
//   maxparam     number of parameters for BBCode tag
//   openclose    has a closing tag, $htmlclose is needed
//   nocase       case-insensitive tagname (default, recommended)
//   nested       may this tag be nested? ex. [b]...[b]...[/b]...[/b]
//   proccont     process the tag's content? if no, nested is ignored
//   subset       what subset this tag belongs to

// Maximum parameter count is currently set to 3. You might want to change this.
// Relevant code locations are marked with MAXPARAM.

$abbc_tags = array(

'#' => array(
'htmlopen0'  => '',
'htmlcont0'  => '$1',
'htmlclose0' => '',
'textcont0'  => '$1',
'htmlblock'  => false,
'minparam'   => 0,
'maxparam'   => 0,
'openclose'  => true,
'nocase'     => true,
'nested'     => false,
'proccont'   => false,
'subset'     => ABBC_DONTINT
),

'rem' => array(
'htmlopen0'  => '',
'htmlcont0'  => '',
'htmlclose0' => '',
'textcont0'  => '',
'htmlblock'  => true,
'minparam'   => 0,
'maxparam'   => 0,
'openclose'  => true,
'nocase'     => true,
'nested'     => false,
'proccont'   => false,
'subset'     => ABBC_DONTINT
),

'code' => array(
'htmlopen0'  => '~\'<div class="code">\'.',
'htmlcont0'  => "abbc_line_numbers(abbc_mask_specials(str_replace('\\\"','\"',rtrim('$1')),1)).",
'htmlclose0' => "\"</div>\".(!abbc_on_tagstack('quote') && strlen(\"$1\")>800 && \$GLOBALS['SHOWHIDECODE'] ?\"<div style='text-align:right;'><span class=\\\"codelink\\\" onclick='cblk(this,1)'>\".\$GLOBALS['T']['hide_code'].\" <img \".\$GLOBALS['IMG']['code_close'].\" /></span></div>\":'')",
'textcont0'  => '$1',
'htmlopen1'  => '~\'<div class="code">\'.',
'htmlcont1'  => "abbc_line_numbers(abbc_mask_specials(str_replace('\\\"','\"',rtrim('$2')),\"$1\")).",
'htmlclose1' => "\"</div>\".(!abbc_on_tagstack('quote') && strlen(\"$1\")>800 && \$GLOBALS['SHOWHIDECODE'] ?\"<div style='text-align:right;'><span class=\\\"codelink\\\" onclick='cblk(this,1)'>\".\$GLOBALS['T']['hide_code'].\" <img \".\$GLOBALS['IMG']['code_close'].\" /></span></div>\":'')",
'textcont1'  => '$2',
'htmlblock'  => true,
'minparam'   => 0,
'maxparam'   => 1,
'openclose'  => true,
'nocase'     => true,
'nested'     => false,
'proccont'   => false,
'subset'     => ABBC_CODE
),

'quote' => array(
'htmlopen0'  => '~\'<div class="quote">\'.',
'htmlcont0'  => "trim(str_replace('\\\"','\"','\$1')).",
'htmlclose0' => "\"</div>\".(\$abbc_tags[\$tagname]['level']==0 && strlen(\"\$1\")>800 && \$GLOBALS['SHOWHIDECODE'] ?\"<div style='text-align:right;'><span class=\\\"codelink\\\" onclick='cblk(this,2)'>\".\$GLOBALS['T']['hide_quote'].\" <img \".\$GLOBALS['IMG']['code_close'].\" /></span></div>\":'')",
'textcont0'  => "--- \".\$GLOBALS['T']['quote'].\":\n\$1\n---",
'htmlopen1'  => "~\"<div class=\\\"qname\\\">\".\$GLOBALS['T']['quote'].(trim(\"\$1\")==''?':':\" \".\$GLOBALS['T']['by'].\" \".t2h(trim(stripslashes(\"\$1\"))).\":\").\"</div><div class=\\\"quote\\\">\".",
'htmlcont1'  => "trim(str_replace('\\\"','\"','\$2')).",
'htmlclose1' => "\"</div>\".(\$abbc_tags[\$tagname]['level']==0 && strlen(\"\$2\")>800 && \$GLOBALS['SHOWHIDECODE'] ?\"<div style='text-align:right;'><span class=\\\"codelink\\\" onclick='cblk(this,2)'>\".\$GLOBALS['T']['hide_quote'].\" <img \".\$GLOBALS['IMG']['code_close'].\" /></span></div>\":'')",
'textcont1'  => "--- \".\$GLOBALS['T']['quote'].(trim(\"\$1\")==''?'':\" \".\$GLOBALS['T']['by'].\" \$1\").\":\n\$2\n---",
'htmlopen2'  => "~\"<div class=\\\"qname\\\">\".\$GLOBALS['T']['quote'].(trim(\"\$1\")==''?':':\" \".\$GLOBALS['T']['by'].\" \".t2h(trim(stripslashes(\"\$1\"))).\" \".\$GLOBALS['T']['on'].\" \".FormatTime(\$2,3).\":\").\"</div><div class=\\\"quote\\\">\".",
'htmlcont2'  => "trim(str_replace('\\\"','\"','\$3')).",
'htmlclose2' => "\"</div>\".(\$abbc_tags[\$tagname]['level']==0 && strlen(\"\$3\")>800 && \$GLOBALS['SHOWHIDECODE'] ?\"<div style='text-align:right;'><span class=\\\"codelink\\\" onclick='cblk(this,2)'>\".\$GLOBALS['T']['hide_quote'].\" <img \".\$GLOBALS['IMG']['code_close'].\" /></span></div>\":'')",
'textcont2'  => "--- \".\$GLOBALS['T']['quote'].(trim(\"\$1\")==''?'':\" \".\$GLOBALS['T']['by'].\" \$1 \".\$GLOBALS['T']['on'].\" \".FormatTime(\$2,3)).\":\n\$3\n---",
'htmlblock'  => true,
'minparam'   => 0,
'maxparam'   => 2,
'openclose'  => true,
'nocase'     => true,
'nested'     => true,
'proccont'   => true,
'subset'     => ABBC_QUOTE
),

'b' => array(
'htmlopen0'  => '<b>',
'htmlcont0'  => '$1',
'htmlclose0' => '</b>',
'textcont0'  => '$1',
'htmlblock'  => false,
'minparam'   => 0,
'maxparam'   => 0,
'openclose'  => true,
'nocase'     => true,
'nested'     => true,
'proccont'   => true,
'subset'     => ABBC_SIMPLE
),

'i' => array(
'htmlopen0'  => '<i>',
'htmlcont0'  => '$1',
'htmlclose0' => '</i>',
'textcont0'  => '$1',
'htmlblock'  => false,
'minparam'   => 0,
'maxparam'   => 0,
'openclose'  => true,
'nocase'     => true,
'nested'     => true,
'proccont'   => true,
'subset'     => ABBC_SIMPLE
),

'u' => array(
'htmlopen0'  => '<u>',
'htmlcont0'  => '$1',
'htmlclose0' => '</u>',
'textcont0'  => '$1',
'htmlblock'  => false,
'minparam'   => 0,
'maxparam'   => 0,
'openclose'  => true,
'nocase'     => true,
'nested'     => true,
'proccont'   => true,
'subset'     => ABBC_SIMPLE
),

's' => array(
'htmlopen0'  => '<s>',
'htmlcont0'  => '$1',
'htmlclose0' => '</s>',
'textcont0'  => '$1',
'htmlblock'  => false,
'minparam'   => 0,
'maxparam'   => 0,
'openclose'  => true,
'nocase'     => true,
'nested'     => true,
'proccont'   => true,
'subset'     => ABBC_SIMPLE
),

'o' => array(
'htmlopen0'  => '<span style="border-top:1px solid black;margin-top:1px;">',
'htmlcont0'  => '$1',
'htmlclose0' => '</span>',
'textcont0'  => '$1',
'htmlopen1'  => '<span style="border-top:1px solid $1;margin-top:1px;">',
'htmlcont1'  => '$2',
'htmlclose1' => '</span>',
'textcont1'  => '$1',
'htmlblock'  => false,
'minparam'   => 0,
'maxparam'   => 1,
'openclose'  => true,
'nocase'     => true,
'nested'     => true,
'proccont'   => true,
'subset'     => ABBC_SIMPLE
),

'm' => array(
'htmlopen0'  => '<tt>',
'htmlcont0'  => '$1',
'htmlclose0' => '</tt>',
'textcont0'  => '$1',
'htmlblock'  => false,
'minparam'   => 0,
'maxparam'   => 0,
'openclose'  => true,
'nocase'     => true,
'nested'     => true,
'proccont'   => true,
'subset'     => ABBC_SIMPLE
),

'url' => array(
'htmlopen0'  => "~\"<a href=\\\"\\x04\".\$GLOBALS['MODULE']['derefer'].\"" . PD . "url=\".urlencode(stripslashes(\"$1\")).\"\\\"\". (\$GLOBALS['abbc_cfg']['target']?\" target=\\\"\".\$GLOBALS['abbc_cfg']['target']:'') .\"\\\" title=\\\"\".stripslashes(\"$1\").\"\\\">\".",
'htmlcont0'  => "\"\\x04\".abbc_mask_specials(str_limit_url(stripslashes(\"\$1\"),60),1).",
'htmlclose0' => "\"</a>\"",
'textcont0'  => "\$1",
'htmlopen1'  => "~\"<a href=\\\"\\x04\".\$GLOBALS['MODULE']['derefer'].\"" . PD . "url=\".urlencode(stripslashes(\"$1\")).\"\\\"\". (\$GLOBALS['abbc_cfg']['target']?\" target=\\\"\".\$GLOBALS['abbc_cfg']['target']:'') .\"\\\" title=\\\"\".stripslashes(\"$1\").\"\\\">\".",
'htmlcont1'  => "\"\\x04\".abbc_mask_specials(stripslashes(\"\$2\"),1).",
'htmlclose1' => "\"</a>\"",
'textcont1'  => '$2 [$1]',
/*
'htmlopen0'  => "<a href=\"$1\" target=\"_blank\">",
'htmlcont0'  => "\$1",
'htmlclose0' => "</a>",
'htmlopen1'  => "<a href=\"$1\" target=\"_blank\">",
'htmlcont1'  => "\$2",
'htmlclose1' => "</a>",
*/
'htmlblock'  => false,
'minparam'   => 0,
'maxparam'   => 1,
'openclose'  => true,
'nocase'     => true,
'nested'     => false,
'proccont'   => true,
'subset'     => ABBC_URL
),

'mail' => array(
'htmlopen0'  => "<a href=\"mailto:\x04\$1\">",
'htmlcont0'  => "\x04\$1",
'htmlclose0' => '</a>',
'textcont0'  => '$1',
'htmlopen1'  => "<a href=\"mailto:\x04\$1\">",
'htmlcont1'  => "\x04\$2",
'textcont0'  => '$2 [$1]',
'htmlclose1' => '</a>',
'htmlblock'  => false,
'minparam'   => 0,
'maxparam'   => 1,
'openclose'  => true,
'nocase'     => true,
'nested'     => false,
'proccont'   => true,
'subset'     => ABBC_URL
),

'img' => array(
'htmlopen0'  => '~',
'htmlcont0'  => "\"<img src=\\\"\x04\$1\\\" title=\\\"\x04\$1\\\" alt=\\\"\x04\$1\\\" />\"",
'htmlclose0' => '',
'textcont0'  => "\"(\".\$GLOBALS['T']['image'].\": \$1)\"",
'htmlopen1'  => '~',
'htmlcont1'  => "\"<img src=\\\"\x04\$2\\\" align=\\\"\$1\\\" title=\\\"\x04\$2\\\" alt=\\\"\x04\$2\\\" />\"",
'htmlclose1' => '',
'textcont1'  => "\"(\".\$GLOBALS['T']['image'].\": \$2)\"",
'htmlblock'  => false,
'minparam'   => 0,
'maxparam'   => 1,
'openclose'  => true,
'nocase'     => true,
'nested'     => false,
'proccont'   => false,
'subset'     => ABBC_IMG
),

'br' => array(
'htmlopen0'  => '<br clear="all" />',
'htmlcont0'  => '',
'htmlclose0' => '',
'textcont0'  => "\n",
'htmlblock'  => false,
'minparam'   => 0,
'maxparam'   => 0,
'openclose'  => false,
'nocase'     => true,
'nested'     => false,
'proccont'   => false,
'subset'     => ABBC_SIMPLE
),

'color' => array(
'htmlopen1'  => '<span style="color:$1">',
'htmlcont1'  => '$2',
'htmlclose1' => '</span>',
'textcont0'  => '$2',
'htmlblock'  => false,
'minparam'   => 1,
'maxparam'   => 1,
'openclose'  => true,
'nocase'     => true,
'nested'     => true,
'proccont'   => true,
'subset'     => ABBC_FONT
),

'font' => array(
'htmlopen1'  => '<span style="font-family:$1">',
'htmlcont1'  => '$2',
'htmlclose1' => '</span>',
'textcont1'  => '$2',
'htmlopen2'  => '<span style="font-family:$1; font-size:$2px; line-height:120%">',
'htmlcont2'  => '$3',
'htmlclose2' => '</span>',
'textcont2'  => '$3',
'htmlopen3'  => '<span style=\"font-family:$1; font-size:$2px; line-height:$3px">',
'htmlcont3'  => '$4',
'htmlclose3' => '</span>',
'textcont3'  => '$4',
'htmlblock'  => false,
'minparam'   => 1,
'maxparam'   => 3,
'openclose'  => true,
'nocase'     => true,
'nested'     => true,
'proccont'   => true,
'subset'     => ABBC_FONT
),

'size' => array(
'htmlopen1'  => '<span style="font-size:$1px; line-height:120%">',
'htmlcont1'  => '$2',
'htmlclose1' => '</span>',
'textcont1'  => '$2',
'htmlopen2'  => '<span style="font-size:$1px; line-height:$2px">',
'htmlcont2'  => '$3',
'htmlclose2' => '</span>',
'textcont2'  => '$3',
'htmlblock'  => false,
'minparam'   => 1,
'maxparam'   => 2,
'openclose'  => true,
'nocase'     => true,
'nested'     => true,
'proccont'   => true,
'subset'     => ABBC_FONT
),

'sup' => array(
'htmlopen0'  => '<sup>',
'htmlcont0'  => '$1',
'htmlclose0' => '</sup>',
'textcont0'  => '$1',
'htmlblock'  => false,
'minparam'   => 0,
'maxparam'   => 0,
'openclose'  => true,
'nocase'     => true,
'nested'     => true,
'proccont'   => true,
'subset'     => ABBC_FONT
),

'sub' => array(
'htmlopen0'  => '<sub>',
'htmlcont0'  => '$1',
'htmlclose0' => '</sub>',
'textcont0'  => '$1',
'htmlblock'  => false,
'minparam'   => 0,
'maxparam'   => 0,
'openclose'  => true,
'nocase'     => true,
'nested'     => true,
'proccont'   => true,
'subset'     => ABBC_FONT
),

'mark' => array(
'htmlopen1'  => '<span style="background-color:$1">',
'htmlcont1'  => '$2',
'htmlclose1' => '</span>',
'textcont1'  => '$2',
'htmlblock'  => false,
'minparam'   => 1,
'maxparam'   => 1,
'openclose'  => true,
'nocase'     => true,
'nested'     => true,
'proccont'   => true,
'subset'     => ABBC_FONT
),

'align' => array(
'htmlopen1'  => '<div style="text-align:$1">',
'htmlcont1'  => '$2',
'htmlclose1' => '</div>',
'textcont1'  => '$2',
'htmlblock'  => true,
'minparam'   => 1,
'maxparam'   => 1,
'openclose'  => true,
'nocase'     => true,
'nested'     => true,
'proccont'   => true,
'subset'     => ABBC_FONT
),

'line' => array(
'htmlopen0'  => '<br /><div style="border-top:1px solid #000000; margin:8 0;"></div>',
'htmlcont0'  => '',
'htmlclose0' => '',
'textcont0'  => '----------',
'htmlopen1'  => '<br /><div style="border-top:1px solid $1; margin:4 0;"></div>',
'htmlcont1'  => '',
'htmlclose1' => '',
'textcont1'  => '----------',
'htmlopen2'  => '<br /><div style="border-top:$2px solid $1; margin:8 0;"></div>',
'htmlcont2'  => '',
'htmlclose2' => '',
'textcont2'  => '----------',
'htmlblock'  => true,
'minparam'   => 0,
'maxparam'   => 2,
'openclose'  => false,
'nocase'     => true,
'nested'     => false,
'proccont'   => false,
'subset'     => ABBC_SIMPLE
),

'list' => array(
'htmlopen0'  => '<ul>',
'htmlcont0'  => '$1',
'htmlclose0' => '</ul>',
'textcont0'  => '$1',
'htmlopen1'  => "~abbc_begin_list(\"\$1\").",
'htmlcont1'  => "\"\$2\".",
'htmlclose1' => "abbc_end_list(\"\$1\")",
'textcont1'  => '$2',
'htmlblock'  => true,
'minparam'   => 0,
'maxparam'   => 1,
'openclose'  => true,
'nocase'     => true,
'nested'     => true,
'proccont'   => true,
'subset'     => ABBC_LIST
),

'*' => array(
'htmlopen0'  => '<li>',
'htmlcont0'  => '',
'htmlclose0' => '',
'textcont0'  => "\n* ",
'htmlblock'  => false,
'minparam'   => 0,
'maxparam'   => 0,
'openclose'  => false,
'nocase'     => true,
'nested'     => false,
'proccont'   => false,
'subset'     => ABBC_LIST
),

'indent' => array(
'htmlopen0'  => '<div style="margin-left:20px">',
'htmlcont0'  => '$1',
'htmlclose0' => '</div>',
'textcont0'  => '$1',
'htmlopen1'  => '<div style="margin-left:$1px">',
'htmlcont1'  => '$2',
'htmlclose1' => '</div>',
'textcont1'  => '$2',
'htmlblock'  => true,
'minparam'   => 0,
'maxparam'   => 1,
'openclose'  => true,
'nocase'     => true,
'nested'     => true,
'proccont'   => true,
'subset'     => ABBC_FONT
),

'table' => array(
'htmlopen0'  => '<table cellspacing="0" cellpadding="1">',
'htmlcont0'  => '$1',
'htmlclose0' => '</table>',
'textcont0'  => '$1',
'htmlopen1'  => '<table cellspacing="0" cellpadding="1" border="$1">',
'htmlcont1'  => '$2',
'htmlclose1' => '</table>',
'textcont1'  => '$2',
'htmlblock'  => true,
'minparam'   => 0,
'maxparam'   => 1,
'openclose'  => true,
'nocase'     => true,
'nested'     => true,
'proccont'   => true,
'subset'     => ABBC_TABLE
),

'row' => array(
'htmlopen0'  => '<tr valign="top">',
'htmlcont0'  => '$1',
'htmlclose0' => '</tr>',
'textcont0'  => "\$1\n",
'htmlblock'  => true,
'minparam'   => 0,
'maxparam'   => 0,
'openclose'  => true,
'nocase'     => true,
'nested'     => true,
'proccont'   => true,
'subset'     => ABBC_TABLE
),

'col' => array(
'htmlopen0'  => '<td style="padding-right:8px;">',
'htmlcont0'  => '$1',
'htmlclose0' => '</td>',
'textcont0'  => '$1  ',
'htmlopen1'  => '<td colspan="$1" style="padding-right:8px;">',
'htmlcont1'  => '$2',
'htmlclose1' => '</td>',
'textcont1'  => '$2 | ',
'htmlopen2'  => '<td colspan="$1" rowspan="$1" style="padding-right:8px;">',
'htmlcont2'  => '$2',
'htmlclose2' => '</td>',
'textcont2'  => '$2 | ',
'htmlblock'  => true,
'minparam'   => 0,
'maxparam'   => 2,
'openclose'  => true,
'nocase'     => true,
'nested'     => true,
'proccont'   => true,
'subset'     => ABBC_TABLE
),

'html' => array(
'htmlopen0'  => '~',
'htmlcont0'  => "h2t(\"\$1\")",
'htmlclose0' => '',
'textcont0'  => '$1',
'htmlblock'  => false,
'minparam'   => 0,
'maxparam'   => 0,
'openclose'  => true,
'nocase'     => true,
'nested'     => false,
'proccont'   => false,
'subset'     => ABBC_HTML
)
);


// Smiley Definitions

// Following information is necessary for a smiley:
//   code    the smiley's code -- NO "< > & [ ]" here!
//   img     image to be displayed
//   nocase  case-insensitive code (default, recommended) -- this is currently ignored: smileys ARE case-sensitive!
//   align   how to align the smiley <img>

// Note: For maximum performance with smileys, you should sort the smileys
//       in order of usage. So the most used smiley is defined first, aso.

$alpha = ($host_browser != 'IE');

$abbc_smileys = array(

array(
'code'   => ':-)',
'img'    => ($alpha ? 'smile_a.png' : 'smile.gif'),
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ';-)',
'img'    => ($alpha ? 'wink_a.png' : 'wink.gif'),
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':cheesy:',
'img'    => ($alpha ? 'cheesy_a.png' : 'cheesy.gif'),
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':-D',
'img'    => ($alpha ? 'grins_a.png' : 'grins.gif'),
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':-p',
'img'    => ($alpha ? 'razz_a.png' : 'razz.png'),
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':red:',
'img'    => ($alpha ? 'redface_a.png' : 'redface.gif'),
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':-/',
'img'    => ($alpha ? 'slash_a.png' : 'slash.gif'),
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':-(',
'img'    => ($alpha ? 'sad_a.png' : 'sad.gif'),
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':\'(',
'img'    => ($alpha ? 'cry_a.png' : 'cry.png'),
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':cool:',
'img'    => ($alpha ? 'cool_a.png' : 'cool.gif'),
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':motz:',
'img'    => 'motz.gif',
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':finger:',
'img'    => 'finger.gif',
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':#:',
'img'    => 'confuse.gif',
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':*)',
'img'    => ($alpha ? 'clown_a.png' : 'clown.gif'),
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':zzz:',
'img'    => 'sleep.gif',
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':heart:',
'img'    => ($alpha ? 'heart_a.png' : 'heart.gif'),
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':moody:',
'img'    => 'moody.gif',
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':gun:',
'img'    => ($alpha ? 'gun_a.png' : 'gun.gif'),
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':anx:',
'img'    => 'uhoh.gif',
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':-O',
'img'    => 'gaehn.gif',
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':rolleyes:',
'img'    => 'rolleyes.gif',
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => '8-(',
'img'    => ($alpha ? 'shocked_a.png' : 'shocked.gif'),
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':ohr:',
'img'    => ($alpha ? 'ohren_a.png' : 'ohren.png'),
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':wand:',
'img'    => 'wand.gif',
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':vogel:',
'img'    => 'vogel.gif',
'nocase' => true,
'align'  => 'middle'
),

// 25 smilies...

array(
'code'   => ':)',
'img'    => ($alpha ? 'smile_a.png' : 'smile.gif'),
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ';)',
'img'    => ($alpha ? 'wink_a.png' : 'wink.gif'),
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':(',
'img'    => ($alpha ? 'sad_a.png' : 'sad.gif'),
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':/',
'img'    => ($alpha ? 'slash_a.png' : 'slash.gif'),
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':\'-(',
'img'    => ($alpha ? 'cry_a.png' : 'cry.png'),
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':flash:',
'img'    => 'flash.gif',
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':kotz:',
'img'    => 'kotz.gif',
'nocase' => true,
'align'  => 'middle'
),

array(
'code'   => ':o)',
'img'    => ($alpha ? 'clown_a.png' : 'clown.gif'),
'nocase' => true,
'align'  => 'middle'
)
);

?>