<?php
// BlackBoard - PHP Internet Newsboard System
// Copyright 2003-4 by Yves Goergen
// Homepage: http://blackboard.unclassified.de
// See docs/LICENSE.txt for distribution/license details
//
// forum.lib.php
// Forum Library, provides the IForum interface

require_once($libpath . 'thread.lib.php');


class IForum
{

// ------------------------------------------------------------ PUBLIC VARIABLES

// ------------------------------------------------------------ PRIVATE VARIABLES
var $db;

var $ID = 0;
var $Sort = 0;
var $Parent = 0;
var $Name = '';
var $Flags = 0;
	//	1	Category
	//	2	Web-Link
var $Description = '';
var $Link = '';


// ------------------------------------------------------------ CONSTRUCTOR

function IForum()
{
	global $db;
	if (PHP5)
		$this->db = $db->__clone();
	else
		$this->db = $db;
}

function Reset()
{
	$this->ID = 0;
	$this->Sort = 0;
	$this->Parent = 0;
	$this->Name = '';
	$this->Flags = 0;
	$this->Description = '';
	$this->Link = '';
}

// ------------------------------------------------------------ FIND

function GetChild($id)
{
	$record = $this->db->FastQuery('Forums', '*', 'Parent=' . $id, 'Sort');
	return $this->LoadFromRecord($record);
}

function GetNextChild()
{
	$record = $this->db->GetRecord();
	return $this->LoadFromRecord($record);
}

// Returns all child forums of <id> in Array(ID, ...) form
function GetChildA($id)
{
	$pre = $this->db->tblprefix;

	if (!$this->db->Exec("SELECT f1.*, COUNT(f2.ID) AS ChildCount " .
		"FROM {$pre}Forums AS f1 LEFT JOIN {$pre}Forums AS f2 ON f2.Parent = f1.ID " .
		"WHERE f1.Parent=$id " .
		"GROUP BY f1.ID " .
		"ORDER BY f1.Parent, Sort")) return false;
	$arr = array();
	while ($record = @mysql_fetch_array($this->db->result))
	{
		array_push($arr, $record);
	}
	return $arr;

	#return $this->db->FastQueryArray('Forums', '*', "Parent=$id", 'Sort');
}

// Get an array(ID) of ForumIDs matching the query
//
function GetListArray($where = '', $order = '', $limit = '')
{
	return $this->db->FastQuery1stArray('Forums', 'ID', $where, $order, $limit);
}


// ------------------------------------------------------------ READ ACCESS

function Load($id)
{
	global $forum_cache;

	if (array_key_exists($id, $forum_cache))
	{
		$record = $forum_cache[$id];
		$add = false;
	}
	else
	{
		$record = $this->db->FastQuery('Forums', '*', 'ID=' . $id);
		$add = true;
	}

	return $this->LoadFromRecord($record, $add);
}

function LoadFromRecord($record, $add = false)
{
	global $forum_cache;

	if ($record)
	{
		$this->ID = intval($record['ID']);
		$this->Sort = intval($record['Sort']);
		$this->Parent = intval($record['Parent']);
		$this->Name = $record['Name'];
		$this->Flags = intval($record['Flags']);
		$this->Description = $record['Description'];
		$this->Link = $record['Link'];

		if ($add) $forum_cache[$this->ID] = $record;

		return true;
	}
	else
	{
		$this->Reset();
		return false;
	}
}


function GetID()
{
	return $this->ID;
}

function GetSort($id = 0)
{
	if ($id != 0) if (!$this->Load($id)) return false;

	return $this->Sort;
}

function GetParent($id = 0)
{
	if ($id != 0) if (!$this->Load($id)) return false;

	return $this->Parent;
}

function GetName($id = 0)
{
	if ($id != 0) if (!$this->Load($id)) return false;

	return $this->Name;
}

function IsCategory($id = 0)
{
	if ($id != 0) if (!$this->Load($id)) return false;

	return $this->Flags & 1;
}

function IsLink($id = 0)
{
	if ($id != 0) if (!$this->Load($id)) return false;

	return $this->Flags & 2;
}

function GetDescription($id = 0)
{
	if ($id != 0) if (!$this->Load($id)) return false;

	return $this->Description;
}

function GetLink($id = 0)
{
	if ($id != 0) if (!$this->Load($id)) return false;

	return $this->Link;
}


function Count($where = '')
{
	return $this->db->FastQuery1st('Forums', 'COUNT(*)', $where);
}


// ------------------------------------------------------------ WRITE ACCESS

function Add($Sort, $Parent, $Name, $Flags, $Description, $Link = '')
{
	$max = intval($this->db->FastQuery1st('Forums', 'MAX(ID)'));

	$this->ID = $max + 1;
	$this->Sort = intval($Sort);
	$this->Parent = intval($Parent);
	$this->Name = trim($Name);
	$this->Flags = intval($Flags);
	$this->Description = trim($Description);
	$this->Link = trim($Link);

	return $this->db->AddRecord(array(
			'ID' => $this->ID,
			'Sort' => $this->Sort,
			'Parent' => $this->Parent,
			'Name' => $this->Name,
			'Flags' => $this->Flags,
			'Description' => $this->Description,
			'Link' => $this->Link
		), 'Forums');
}


function SetSort($newsort, $updateall = false)
{
	$oldsort = $this->Sort;

	if ($oldsort < $newsort)
	{
		$pre = $this->db->tblprefix;
		if ($updateall) $this->db->Exec("UPDATE {$pre}Forums SET Sort=Sort-1 WHERE Parent=" . $this->Parent . " AND Sort>$oldsort AND Sort<=$newsort");
		$this->db->Exec("UPDATE {$pre}Forums SET Sort=$newsort WHERE ID=" . $this->ID);
	}
	else
	{
		$pre = $this->db->tblprefix;
		if ($updateall) $this->db->Exec("UPDATE {$pre}Forums SET Sort=Sort+1 WHERE Parent=" . $this->Parent . " AND Sort<$oldsort AND Sort>=$newsort");
		$this->db->Exec("UPDATE {$pre}Forums SET Sort=$newsort WHERE ID=" . $this->ID);
	}
}

function SetParent($Parent, $id = 0)
{
	global $forum_cache;

	if (!$id)
	{
		$id = $this->ID;
		$this->Parent = intval($Parent);
	}
	unset($forum_cache[$id]);
	return $this->db->ChangeRecord(array('Parent' => $Parent), 'ID=' . $id, 'Forums');
}

function SetCategory($Cat, $id = 0)
{
	global $forum_cache;

	if (!$id)
	{
		$id = $this->ID;
		$this->Cat = intval($Cat);
	}
	unset($forum_cache[$id]);
	return $this->db->ChangeRecord(array('IsCategory' => $Cat), 'ID=' . $id, 'Forums');
}

function SetName($Name, $id = 0)
{
	global $forum_cache;

	$Name = trim($Name);

	if (!$id)
	{
		$id = $this->ID;
		$this->Name = $Name;
	}
	unset($forum_cache[$id]);
	return $this->db->ChangeRecord(array('Name' => $Name), 'ID=' . $id, 'Forums');
}


function Change($ID, $Sort, $Parent, $Name, $Flags, $Description, $Link = '')
{
	global $forum_cache;

	if (!$this->Load($ID)) return false;

	$this->Sort = intval($Sort);
	$this->Parent = intval($Parent);
	$this->Name = trim($Name);
	$this->Flags = intval($Flags);
	$this->Description = trim($Description);
	$this->Link = trim($Link);

	unset($forum_cache[$ID]);
	return $this->db->ChangeRecord(array(
			'Sort' => $this->Sort,
			'Parent' => $this->Parent,
			'Name' => $this->Name,
			'Flags' => $this->Flags,
			'Description' => $this->Description,
			'Link' => $this->Link
		), 'ID=' . $ID, 'Forums');
}


// Remove a forum with all subforums and related content
// (threads, posts, polls, category states, votes, notifications)
//
// This function will accept any parameter type and convert it into an integer
// id = Forum ID to remove | 0 for currently loaded forum
//
function Remove($id = 0)
{
	global $forum_cache;

	if (!$id) $id = $this->ID;
	$id = intval($id);   // important for thread.FindArray
	if ($id <= 0) return false;

	// remove all child forums
	if ($forums = $this->GetChildA($id)) foreach ($forums as $rec)
	{
		if (!$this->Remove($rec['ID'])) return false;
	}

	// remove all threads in this forum
	$thread = new IThread;
	if ($threads = $thread->FindArray($id)) foreach ($threads as $rec)
	{
		if (!$thread->RemoveAllPosts($rec['ID'])) return false;
	}

	$this->RemoveAllForumStates($id);

	unset($forum_cache[$id]);
	return $this->db->RemoveRecord('ID=' . $id, 'Forums');
}


// ------------------------------------------------------------ CATEGORY STATES

// Set category state for current user
// $id is optional, default is currently loaded forum
//
// State = 0: Collapsed, 1: Expanded
//
function SetCatState($State, $id = 0)
{
	global $LoginUserID;
	if (!$LoginUserID) return false;

	if (!$id) $id = $this->ID;
	if (!$this->db->FastQuery1st('UserCategoryState', 'COUNT(*)', 'Forum=' . $id . ' AND User=' . $LoginUserID))
	{
		return $this->db->AddRecord(array('Forum' => $id, 'User' => $LoginUserID, 'State' => $State), 'UserCategoryState');
	}
	else
	{
		return $this->db->ChangeRecord(array('State' => $State), 'Forum=' . $id . ' AND User=' . $LoginUserID, 'UserCategoryState');
	}
}

// Returns category state for current user
// $id is optional, default is currently loaded forum
//
function GetCatState($id = 0)
{
	global $LoginUserID;
	if (!$LoginUserID) return 1;

	if (!$id) $id = $this->ID;
	$state = $this->db->FastQuery1st('UserCategoryState', 'State', 'Forum=' . $id . ' AND User=' . $LoginUserID);
	if ($state === false) return 1;
	return $state;
}

// Removes any UserCategoryStates for (this) forum
// $id is optional, default is currently loaded forum
//
function RemoveAllForumStates($id = 0)
{
	if (!$id) $id = $this->ID;
	return $this->db->RemoveRecord('Forum=' . $id, 'UserCategoryState');
}

// Removes any UserCategoryStates for (current) user
// $id is optional, default is current user
//
function RemoveAllUserStates($id = 0)
{
	global $LoginUserID;
	if (!$LoginUserID) return false;
	if (!$id) $id = $LoginUserID;
	return $this->db->RemoveRecord('User=' . $id, 'UserCategoryState');
}


function IsNew($id = 0)
{
	global $LoginUserID, $NewForums;
	if (!$LoginUserID) return false;

	if (!$id) $id = $this->ID;
	return ($NewForums[$id] > 0);
}


// ------------------------------------------------------------ FORUM WATCHING

// Set watching mode for current user
// $id is optional, default is currently loaded forum
// Mode = 1: E-Mail, 2: ICQ  (both is possible)
// Flags = 1: recursive
//
function SetWatched($Mode = 1, $id = 0, $Flags = 0)
{
	global $LoginUserID;
	if (!$LoginUserID) return false;

	if (!$id) $id = $this->ID;
	$current_a = $this->db->FastQuery('ForumWatch', 'Mode, Flags', 'Forum=' . $id . ' AND User=' . $LoginUserID);
	if ($current_a === false && $Mode)
	{
		return $this->db->AddRecord(array('Forum' => $id, 'User' => $LoginUserID, 'Mode' => $Mode, 'Flags' => $Flags), 'ForumWatch');
	}
	else
	{
		if ($current_a['Mode'] != $Mode || $current_a['Flags'] != $Flags)
		{
			return $this->db->ChangeRecord(array('Mode' => $Mode, 'Flags' => $Flags), 'User=' . $LoginUserID . ' AND Forum=' . $id, 'ForumWatch');
		}
		else
		{
			return true;
		}
	}
}

// Returns watching mode for current user
// $id is optional, default is currently loaded forum
//
function IsWatched($id = 0)
{
	global $LoginUserID;
	if (!$LoginUserID) return false;

	if (!$id) $id = $this->ID;
	return ($this->db->FastQuery1st('ForumWatch', 'Mode', 'Forum=' . $id . ' AND User=' . $LoginUserID));
}

// Returns number of users that have a ForumWatch line for this Forum
// $id is optional, default is currently loaded forum
//
function CountUsers($id = 0)
{
	global $LoginUserID;
	if (!$LoginUserID) return false;

	if (!$id) $id = $this->ID;
	return ($this->db->FastQuery1st('ForumWatch', 'COUNT(*)', 'Forum=' . $id));
}

// Removes any ForumWatch data for (this) forum
// $id is optional, default is currently loaded forum
//
function RemoveAllForumWatchs($id = 0)
{
	if (!$id) $id = $this->ID;
	return $this->db->RemoveRecord('Forum=' . $id, 'ForumWatch');
}

// Removes any ForumWatch data for (current) user
// $id is optional, default is current user
//
function RemoveAllUserWatchs($id = 0)
{
	global $LoginUserID;
	if (!$LoginUserID) return false;
	if (!$id) $id = $LoginUserID;
	return $this->db->RemoveRecord('User=' . $id, 'ForumWatch');
}


// ------------------------------------------------------------ USER NOTIFY TIMESTAMP

// Set last-notify time for current user
// $id is optional, default is currently loaded forum
// $userid is optional, default is currently logged in user
//
function SetLastNotify($Date, $id = 0, $userid = 0)
{
	global $LoginUserID;
	if (!$userid) $userid = $LoginUserID;
	if (!$userid) return false;

	if (!$id) $id = $this->ID;
	$current = $this->db->FastQuery1st('ForumWatch', 'LastNotify', 'Forum=' . $id . ' AND User=' . $userid);
	if ($current === false)
	{
		return $this->db->AddRecord(array('Forum' => $id, 'User' => $userid, 'LastNotify' => $Date), 'ForumWatch');
	}
	elseif ($current < $Date)
	{
		return $this->db->ChangeRecord(array('LastNotify' => $Date), 'Forum=' . $id . ' AND User=' . $userid, 'ForumWatch');
	}
}

// Returns last notify time for current user
// $id is optional, default is currently loaded forum
// $userid is optional, default is currently logged in user
//
function GetLastNotify($id = 0, $userid = 0)
{
	global $LoginUserID;
	if (!$userid) $userid = $LoginUserID;
	if (!$userid) return 1;

	if (!$id) $id = $this->ID;
	$db = $this->db;
	return $db->FastQuery1st('ForumWatch', 'LastNotify', 'Forum=' . $id . ' AND User=' . $userid);
}

}  // class

?>