<?php
// BlackBoard - PHP Internet Newsboard System
// Copyright 2003-4 by Yves Goergen
// Homepage: http://blackboard.unclassified.de
// See docs/LICENSE.txt for distribution/license details
//
// mail.lib.php
// E-Mail and ICQ functions

require_once($libpath . 'user.lib.php');
require_once($libpath . 'mime-create.lib.php');
require_once($libpath . 'smtp.lib.php');
require_once($libpath . 'class.jabber.php');

// Send a message to one or more users
//
// users = a single numeric user ID or an array containing all user IDs
// method = 1: E-Mail, 2: ICQ, 4: Jabber (do not sum them!)
// message may contain the following user-dependant variables:
//   %name% -> User's name
//
// Returns the number of successful deliveries
//
function NotifyUser($users, $method, $subject_key, $subject_data, $msg_key, $msg_data, $from = false)
{
	global $LoginUserID, $CHARSET, $libpath, $LANG, $DEFLANG, $CFG, $mail_error;

	if ($users === false) return true;
	if (is_array($users))
	{
		if (!sizeof($users)) return true;
	}
	else
	{
		$users = array($users);
	}
	$user = new IUser();
	$count = 0;

	if ($method == 1)
	{
		// prepare data for E-Mail transport
		$mime = new mime_create_class;
		$mime->set_from(rc('smtp_sender'), rc('forum_title'), $CHARSET);
		if ($from) $mime->set_reply($from);

		$smtp = new smtp_class;
		$mail_error = '';
		if (!$smtp->connect(rc('smtp_server'), rc('smtp_user'), base64_decode(rc('smtp_pass'))))
		{
			$mail_error = $smtp->error;
		}
		else
		{
			foreach ($users as $userid)
			{
				//if ($userid == $LoginUserID) continue;   // don't send a notification to the poster itself
				// this is now handled by the calling function
				if (!$user->Load($userid)) continue;
				if ($user->GetEMail() == '') continue;

				$lang = $user->GetLanguage();
				if ($lang == '') $lang = $DEFLANG;
				elseif (!in_array($lang, $CFG['languages'])) $lang = $LANG;
				require($libpath . 'lang/' . $lang . '_more.php');

				$subject = $T[$subject_key];
				foreach ($subject_data as $varname => $value) $subject = str_replace($varname, $value, $subject);
				$mime->set_subject($subject, $CHARSET);

				$message = $T[$msg_key];
				foreach ($msg_data as $varname => $value) $message = str_replace($varname, $value, $message);
				$message2 = str_replace("%name%", $user->GetName(), $message);
				$mime->set_msg_text($message2, $CHARSET);
				$mime->build_msg();

				$mime->reset_rcpts();
				$mime->add_to($user->GetEMail(), $user->GetName());
				$mime->build();

				$smtp->reset_data();
				if (!$smtp->set_from(rc('smtp_sender'))) continue;
				if (!$smtp->add_to($user->GetEMail())) continue;
				if (!$smtp->sendmail($mime->body))
				{
					$mail_error = $smtp->error;
					continue;
				}
				$count++;
			}
		}

		if ($mail_error) errorlog('SMTP error: ' . $mail_error);

		$smtp->end();
	}

	if ($method == 2)
	{
		foreach ($users as $userid)
		{
			//if ($userid == $LoginUserID) continue;   // don't send a notification to the poster itself
			// this is now handled by the calling function
			if (!$user->Load($userid)) continue;
			if ($user->GetICQ() == '') continue;

			$lang = $user->GetLanguage();
			if ($lang == '') $lang = $DEFLANG;
			elseif (!in_array($lang, $CFG['languages'])) $lang = $LANG;
			require($libpath . 'lang/' . $lang . '_more.php');

			$message = $T[$msg_key];
			foreach ($msg_data as $varname => $value) $message = str_replace($varname, $value, $message);
			$message2 = str_replace('%name%', $user->GetName(), $message);
			page_icq($user->GetICQ(), trim($message2));
			$count++;
		}
	}

	if ($method == 4)
	{
		$msgs = array();

		foreach ($users as $userid)
		{
			if (!$user->Load($userid)) continue;
			if ($user->GetJabber() == '') continue;

			$lang = $user->GetLanguage();
			if ($lang == '') $lang = $DEFLANG;
			elseif (!in_array($lang, $CFG['languages'])) $lang = $LANG;
			require($libpath . 'lang/' . $lang . '_more.php');

			$subject = $T[$subject_key];
			foreach ($subject_data as $varname => $value) $subject = str_replace($varname, $value, $subject);

			$message = $T[$msg_key];
			foreach ($msg_data as $varname => $value) $message = str_replace($varname, $value, $message);
			$message2 = str_replace('%name%', $user->GetName(), $message);

			$msgs[] = array(
				'to' => $user->GetJabber(),
				'subject' => $subject,
				'body' => $message2
				);

			$count++;
		}

		$n = JabberSendMessage($msgs);
		if ($n < 0) errorlog('Jabber error: ' . $n);
	}
	return $count;
}


function page_icq($num, $msg)
{
	// WARNING: ICQ has introduced ___ so this simple GET schript won't work anymore.
	// But the ICQ notification mechanism remains fully functional, you only need to
	// provide another paging function. Maybe similar to the Jabber class...
	// See http://www.algonet.se/~henisak/icq/icqv5.html for information about the ICQ protocol.
	return false;

	$from = 'BlackBoard';
	$fromemail = urlencode(rc('smtp_sender'));
	$msg = urlencode($msg);
	@file("http://icq.com/scripts/WWPMsg.dll?to=$num&from=$from&fromemail=$fromemail&body=$msg");
	#@file("http://donnergurgler.lanrules.de/fopref/div/uniforum_icq.php?num=$num&from=$from&fromemail=$fromemail&msg=$msg");
	#@file("http://web.icq.com/whitepages/page_me/1,,,00.html?to=$num&from=$from&fromemail=$fromemail&body=$msg");
}


// Send a message to one or more Jabber receipients with the Class.Jabber.PHP class
//
// to = array:
//   array(to, subject, body) with all messages to be sent
// to = string: single receipient's JID
// subject = single subject
// body = single message body. pass these as text/plain, the'll be htmlspecialchar'ed.
//
function JabberSendMessage($to, $subject = '', $body = '')
{
	global $CHARSET;

	$j = new Jabber;

	#$j->enable_logging = true;
	#$j->log_filename = 'jabber.log';
	#$j->log_filehandler = true;

	list($j->server, $j->port) = explode(':', rc('jabber_server'));
	if (!$j->port) $j->port = 5222;
	$j->username = rc('jabber_user');
	$j->password = base64_decode(rc('jabber_pass'));
	$j->resource = 'BlackBoard';
	$j->charset = 'UTF-8';   // anything else won't work

	$icq_transport = rc('jabber_icq');
	$icq_online = false;   // ICQ connection established?

	//dp();
	if (!$j->Connect()) return -1;   //'Cannot connect to Jabber'
	//dp("connect");
	//dp();
	if (!$j->SendAuth()) return -2;   //'Cannot auth to Jabber'
	//dp("auth");

	// [Disabled ICQ transport]
	//$j->SendPresence();

	//dp();
	if (is_array($to))
	{
		foreach ($to as $msg)
		{
			if ($CHARSET !== 'UTF-8')
			{
				$msg['subject'] = utf8_encode($msg['subject']);
				$msg['body'] = utf8_encode($msg['body']);
			}

			// [Disabled ICQ transport]
			/*
			if (substr($msg['to'], 0, 4) == 'uin:')
			{
				if (!$icq_transport) continue;
				if (!$icq_online)
				{
					$loopcount = 0;
					do
					{
						sleep(1);
						$j->Listen();
						$packet = $j->GetFromQueueByAttr('presence', 'from', $icq_transport, true);
						$loopcount++;
					} while ($packet === false && $loopcount < 5);

					if ($packet === false) $icq_transport = '';   // ICQ won't come online in time, so ignore it for this run
					else
					{
						$icq_online = true;
						sleep(1);
					}
				}
				if (!$icq_transport) continue;
				$msg['to'] = substr($msg['to'], 4) . '@' . $icq_transport;
			}
			*/

			if (!$j->SendMessage($msg['to'], 'normal', null, array('subject' => $msg['subject'], 'body' => $msg['body'])))
				return -3;   //'Cannot send message'
		}
	}
	else
	{
		if ($CHARSET !== 'UTF-8')
		{
			$subject = utf8_encode($subject);
			$body = utf8_encode($body);
		}

		// [Disabled ICQ transport]
		/*
		if (substr($to, 0, 4) == 'uin:')
		{
			if (!$icq_transport) return false;
			if (!$icq_online)
			{
				$loopcount = 0;
				do
				{
					sleep(1);
					$j->Listen();
					$packet = $j->GetFromQueueByAttr('presence', 'from', $icq_transport, true);
					$loopcount++;
				} while ($packet === false && $loopcount < 5);

				if ($packet === false) $icq_transport = '';   // ICQ won't come online in time, so ignore it for this run
				else $icq_online = true;
			}
			if (!$icq_transport) continue;
			$to = substr($to, 4) . '@' . $icq_transport;
		}
		*/

		if (!$j->SendMessage($to, 'normal', null, array('subject' => $subject, 'body' => $msg)))
			return -4;   //'Cannot send message'
	}
	//dp("connect");

	/*$j->Listen();
	while ($packet = $j->GetFirstFromQueue())
	{
		echo "packet:<br /><pre>";
		print_r($packet);
		echo "</pre>";
	}

	echo "<hr />";

	sleep(3);

	$j->Listen();
	while ($packet = $j->GetFirstFromQueue())
	{
		echo "packet:<br /><pre>";
		print_r($packet);
		echo "</pre>";
	}*/

	$j->Disconnect();
	#exit();
	return 0;
}

?>
