<?php
// BlackBoard - PHP Internet Newsboard System
// Copyright 2003-4 by Yves Goergen
// Homepage: http://blackboard.unclassified.de
// See docs/LICENSE.txt for distribution/license details
//
// post.lib.php
// Post Library, provides the IPost interface


class IPost
{

// ------------------------------------------------------------ PUBLIC VARIABLES

// ------------------------------------------------------------ PRIVATE VARIABLES
var $db;

var $ID = 0;
var $Thread = 0;
var $ReplyTo = 0;
var $Date = 0;
var $EditUser = 0;
var $EditDate = 0;
var $EditCount = 0;
var $User = 0;
var $UserName = '';
var $Subject = '';
var $Msg = '';
var $Options = 0;   // 1: NoSmileys, 2: NoSpecialABBC
var $AttachFile = '';
var $AttachFileName = '';
var $AttachDLCount = 0;
var $IP = '';
var $Hostname = '';
var $SpamRating = 0;


// ------------------------------------------------------------ CONSTRUCTOR

function IPost()
{
	global $db;
	if (PHP5)
		$this->db = $db->__clone();
	else
		$this->db = $db;
}

function Reset()
{
	$this->ID = 0;
	$this->Thread = 0;
	$this->ReplyTo = 0;
	$this->Date = 0;
	$this->EditUser = 0;
	$this->EditDate = 0;
	$this->EditCount = 0;
	$this->User = 0;
	$this->UserName = '';
	$this->Subject = '';
	$this->Msg = '';
	$this->Options = 0;
	$this->AttachFile = '';
	$this->AttachFileName = '';
	$this->AttachDLCount = 0;
	$this->IP = '';
	$this->Hostname = '';
	$this->SpamRating = 0;
}

// ------------------------------------------------------------ FIND

function Find($where = '', $order = '', $limit = '', $group = '')
{
	$record = $this->db->FastQuery('Posts', '*', $where, $order, $limit, $group);
	return $this->LoadFromRecord($record);
}

function FindNext()
{
	$record = $this->db->GetRecord();
	return $this->LoadFromRecord($record);
}


// ------------------------------------------------------------ READ ACCESS

function Load($id)
{
	$record = $this->db->FastQuery('Posts', '*', 'ID=' . $id);
	return $this->LoadFromRecord($record);
}

function LoadFromRecord($record)
{
	if ($record)
	{
		$this->ID = intval($record['ID']);
		$this->Thread = intval($record['Thread']);
		$this->ReplyTo = intval($record['ReplyTo']);
		$this->Date = intval($record['Date']);
		$this->EditUser = intval($record['EditUser']);
		$this->EditDate = intval($record['EditDate']);
		$this->EditCount = intval($record['EditCount']);
		$this->User = intval($record['User']);
		$this->UserName = $record['UserName'];
		$this->Subject = $record['Subject'];
		$this->Msg = $record['Msg'];
		$this->Options = intval($record['Options']);
		$this->AttachFile = $record['AttachFile'];
		$this->AttachFileName = $record['AttachFileName'];
		$this->AttachDLCount = intval($record['AttachDLCount']);
		$this->IP = $record['IP'];
		$this->Hostname = $record['Hostname'];
		$this->SpamRating = intval($record['SpamRating']);
		return true;
	}
	else
	{
		$this->Reset();
		return false;
	}
}


function GetID()
{
	return $this->ID;
}

function GetThread($id = 0)
{
	if ($id != 0) if (!$this->Load($id)) return false;
	return $this->Thread;
}

function GetReplyTo($id = 0)
{
	if ($id != 0) if (!$this->Load($id)) return false;
	return $this->ReplyTo;
}

function GetDate($id = 0)
{
	if ($id != 0) if (!$this->Load($id)) return false;
	return $this->Date;
}

function GetEditUser($id = 0)
{
	if ($id != 0) if (!$this->Load($id)) return false;
	return $this->EditUser;
}

function GetEditDate($id = 0)
{
	if ($id != 0) if (!$this->Load($id)) return false;
	return $this->EditDate;
}

function GetEditCount($id = 0)
{
	if ($id != 0) if (!$this->Load($id)) return false;
	return $this->EditCount;
}

function GetUser($id = 0)
{
	if ($id != 0) if (!$this->Load($id)) return false;
	return $this->User;
}

function GetUserName($id = 0)
{
	if ($id != 0) if (!$this->Load($id)) return false;
	return $this->UserName;
}

function GetSubject($id = 0)
{
	if ($id != 0) if (!$this->Load($id)) return false;
	return $this->Subject;
}

function GetMsg($id = 0)
{
	if ($id != 0) if (!$this->Load($id)) return false;
	return $this->Msg;
}

function GetOptions($id = 0)
{
	if ($id != 0) if (!$this->Load($id)) return false;
	return $this->Options;
}

function GetAttachFile($id = 0)
{
	if ($id != 0) if (!$this->Load($id)) return false;
	return $this->AttachFile;
}

function GetAttachFileName($id = 0)
{
	if ($id != 0) if (!$this->Load($id)) return false;
	return $this->AttachFileName;
}

function GetAttachDLCount($id = 0)
{
	if ($id != 0) if (!$this->Load($id)) return false;
	return $this->AttachDLCount;
}

function GetIP($id = 0)
{
	if ($id != 0) if (!$this->Load($id)) return false;
	return $this->IP;
}

function GetHostname($id = 0)
{
	if ($id != 0) if (!$this->Load($id)) return false;
	return $this->Hostname;
}

function GetSpamRating($id = 0)
{
	if ($id != 0) if (!$this->Load($id)) return false;
	return $this->SpamRating;
}


function Count($where = '')
{
	return $this->db->FastQuery1st('Posts', 'COUNT(ID)', $where);
}


// ------------------------------------------------------------ WRITE ACCESS

function Add($Thread, $ReplyTo, $UserName, $Subject, $Msg, $Options, $SpamRating)
{
	global $LoginUserID;

	$max = intval($this->db->FastQuery1st('Posts', 'MAX(ID)'));

	$this->ID = $max + 1;
	$this->Thread = intval($Thread);
	$this->ReplyTo = intval($ReplyTo);
	$this->Date = time();
	$this->EditUser = 0;
	$this->EditDate = 0;
	$this->EditCount = 0;
	$this->User = $LoginUserID;
	$this->UserName = trim($UserName);
	$this->Subject = trim($Subject);
	$this->Msg = trim($Msg);
	$this->Options = intval($Options);
	$this->AttachFile = '';
	$this->AttachFileName = '';
	$this->AttachDLCount = 0;
	$this->IP = $_SERVER['REMOTE_ADDR'];
	$this->Hostname = gethostbyaddr($_SERVER['REMOTE_ADDR']);
	$this->SpamRating = intval($SpamRating);

	$ok = $this->db->AddRecord(array(
			'ID' => $this->ID,
			'Thread' => $this->Thread,
			'ReplyTo' => $this->ReplyTo,
			'Date' => $this->Date,
			'EditUser' => $this->EditUser,
			'EditDate' => $this->EditDate,
			'EditCount' => $this->EditCount,
			'User' => $this->User,
			'UserName' => $this->UserName,
			'Subject' => $this->Subject,
			'Msg' => $this->Msg,
			'Options' => $this->Options,
			'AttachFile' => $this->AttachFile,
			'AttachFileName' => $this->AttachFileName,
			'AttachDLCount' => $this->AttachDLCount,
			'IP' => $this->IP,
			'Hostname' => $this->Hostname,
			'SpamRating' => $this->SpamRating
		), 'Posts');

	// update statistics table, no error detection here
	if ($ok) UpdateStat('NewPosts', 1);
	return $ok;
}


function SetAttachFile($AttachFile, $AttachFileName = '')
{
	global $attach_path;

	$AttachFile = trim($AttachFile);
	$AttachFileName = trim($AttachFileName);

	if ($AttachFile == '' && $this->AttachFile == '') return true;
	if ($AttachFile != '' && AttachFileName == '') return false;

	$id = $this->ID;
	if ($AttachFile == '')
	{
		// remove image file from disk, too (if it exists, anyway)
		if (file_exists($attach_path . $this->AttachFile))
			if (!unlink($attach_path . $this->AttachFile)) return false;
	}
	$this->AttachFile = $AttachFile;
	$this->AttachFileName = $AttachFileName;
	$this->AttachDLCount = 0;

	if (!$this->db->ChangeRecord(array(
			'AttachFile' => $AttachFile,
			'AttachFileName' => $AttachFileName,
			'AttachDLCount' => 0
		), 'ID=' . $id, 'Posts'))
		return false;

	// Update thread's HasAttach flag
	$thread = new IThread;
	$thread->Load($this->Thread);
	if ($thread->HasAttach() && $AttachFile != '') return true;   // nothing to do here

	$opt = $thread->GetOptions();
	if ($AttachFile != '')
	{
		// new attachment, add the flag
		$opt |= 16;
	}
	else
	{
		// test all other posts in this thread for attachments
		if ($this->db->FastQuery1st('Posts', 'count(*)', 'Thread=' . $this->Thread . ' AND AttachFile<>""') == 0)
		{
			// last attachment removed, clear the flag
			$opt &= ~16;
		}
	}
	$thread->SetOptions($opt);   // no error detection here

	return true;
}

function IncDLCount()
{
	global $db;

	$this->AttachDLCount++;

	$pre = $db->tblprefix;
	return $db->Exec("UPDATE {$pre}Posts SET AttachDLCount=AttachDLCount+1 WHERE ID=" . $this->ID);
}

function Change($id, $UserName, $Subject, $Msg, $Options, $EditUser = 0, $SpamRating)
{
	if (!$this->Load($id)) return false;
	global $LoginUserID;

	$UserName = trim($UserName);
	$Subject = trim($Subject);
	$Msg = trim($Msg);

	$this->User = $LoginUserID;
	$this->UserName = $UserName;
	$this->Subject = $Subject;
	$this->Msg = $Msg;
	$this->Options = intval($Options);
	$this->SpamRating = intval($SpamRating);
	if ($EditUser == -1)
	{
		$this->EditUser = 0;
		$this->EditDate = 0;
		$this->EditCount = 0;
	}
	elseif ($EditUser > 0)
	{
		$this->EditUser = intval($EditUser);
		$this->EditDate = time();
		$this->EditCount++;
	}

	$arr = array('Subject' => $this->Subject,
		'Msg' => $this->Msg,
		'Options' => $this->Options,
		'SpamRating' => $this->SpamRating);
	if ($this->User > 0)
		$arr['UserName'] = $UserName;
	if ($EditUser != 0)
		$arr = array_merge($arr, array('EditUser' => $this->EditUser,
			'EditDate' => $this->EditDate,
			'EditCount' => $this->EditCount));

	return $this->db->ChangeRecord($arr, 'ID=' . $id, 'Posts');
}


function SetUser($User = false, $UserName = false, $EditUser = false)
{
	$arr = array();

	if ($User !== false)
	{
		$this->User = $User;
		$arr['User'] = $User;
	}
	if ($UserName !== false)
	{
		if (isset($arr['User'])) $UserName = '';   // Set UserName to '' if a User ID is given!
		$this->UserName = $UserName;
		$arr['UserName'] = $UserName;
	}
	if ($EditUser !== false)
	{
		$this->EditUser = $EditUser;
		$arr['EditUser'] = $EditUser;
	}
	if (!$arr) return true;

	return $this->db->ChangeRecord($arr, 'ID=' . $this->ID, 'Posts');
}


// Move a set of posts to another thread
//
function SetThreadArray($Thread, $PostIDs = false)
{
	if ($PostIDs === false) $PostIDs = array($this->ID);
	if (!is_array($PostIDs)) return false;

	$arr['Thread'] = $Thread;
	$IDs = join(',', $PostIDs);

	return $this->db->ChangeRecord($arr, 'ID IN (' . $IDs . ')', 'Posts');
}


// Remove (this) post
// auto_del_thread = true: remove thread if this was the last post in it
//
function Remove($id = 0, $auto_del_thread = true)
{
	if (!$id) $id = $this->ID;
	$r = 1;

	$db = $this->db;

	// TODO: what happens to the posts that reply to this post?

	// if this was the only post in this thread, also remove the thread
	// lazy '&&' evaluation! only count posts it we should delete the thread then, too
	if ($auto_del_thread && $this->Count('Thread=' . $this->Thread) <= 1)
	{
		$thread = new IThread;
		$thread->Remove($this->Thread);
		$r = 2;
	}

	// unlink attachment file
	$this->SetAttachFile('');

	if (!$db->RemoveRecord('ID=' . $id, 'Posts'))
		return false;
	else
	{
		// update statistics table, no error detection here
		UpdateStat('NewPosts', -1);
		return $r;
	}
}

}  // class

?>