<?php
// BlackBoard - PHP Internet Newsboard System
// Copyright 2003-4 by Yves Goergen
// Homepage: http://blackboard.unclassified.de
// See docs/LICENSE.txt for distribution/license details
//
// search.inc.php
// Search form

@header('Pragma: no-cache');
@header('Cache-Control: no-cache');
@header('Expires: ' . gmdate('D, d M Y H:i:s GMT'));   // now

require_once($libpath . 'common_post.lib.php');

if ($_REQUEST['use_result'])
{
	$_REQUEST['Query'] = $_SESSION['search_Query'];
	$_REQUEST['ResultView'] = $_SESSION['search_ResultView'];
	$_REQUEST['Forum'] = $_SESSION['search_Forum'];
	$_REQUEST['InSubject'] = $_SESSION['search_InSubject'];
	$_REQUEST['InMessage'] = $_SESSION['search_InMessage'];
	$_REQUEST['InUser'] = $_SESSION['search_InUser'];
	$_REQUEST['Sort'] = $_SESSION['search_Sort'];
	$_REQUEST['DateFrom'] = $_SESSION['search_DateFrom'];
	$_REQUEST['DateUntil'] = $_SESSION['search_DateUntil'];
}

// Import request variables
$page = intval($_GET['page']);
if ($page < 1) $page = 1;

$topforum = intval($_REQUEST['Forum']);

if ($_REQUEST['ResultView'] != 1) $_REQUEST['ResultView'] = 2;
if ($_REQUEST['Sort'] != 1) $_REQUEST['Sort'] = 2;

// alias 'active threads since last login'
if ($LoginUserID > 0 && $_REQUEST['DateFrom'] == -3)
{
	$_REQUEST['DateFrom'] = $LoginUser->GetLastLogout();

	$_REQUEST['Sort'] = 2;
	$_REQUEST['title'] = 'login';
}

$error = false;


// Begin page
BeginHTML($T['search']);

echo '<script type="text/javascript">' /*. '<![CDATA['*/;
include($libpath . 'editor.js.php');
echo /*']]>' .*/ '</script>';

if ($LoginUserID) $LoginUser->SetLastActivity(ULF_SEARCH);
else SetGuestLastForum(ULF_SEARCH);

if ($_GET['nodef'] != 1 && $_GET['where'] == '')
{
	// Show search definition form
	addlog('search_form');

	if (!isset($_REQUEST['Query'])) $_REQUEST['InMessage'] = 1;

	echo '<form action="' . $ME . '" method="get">';
	echo sid(4);
	echo '<input type="hidden" name="req" value="search" />';
	echo '<table cellspacing="' . $TABLE['search']['space'] . '" cellpadding="' . $TABLE['search']['pad'] . '" border="' . $TABLE['search']['border'] . '" width="100%">';
	echo '<tr><td class="search_head_left">' . $T['search_posts'] . '</td>';
	echo '<td class="search_head_right">&nbsp;</td></tr>';

	echo '<tr valign="top">';
	echo '<td class="search">' . $T['find_what'] . ' <input type="text" class="text" size="38" maxlength="200" name="Query" value="' . htmlquote($_REQUEST['Query']) . '" /></td>';
	echo '<td class="search">' . $T['display_as'] . ' <nobr><input type="radio" class="radio" name="ResultView" id="ResultView1" value="1"' . ($_REQUEST['ResultView'] == 1 ? ' checked="checked"' : '') . ' /><label for="ResultView1">' . $T['threads'] . '</label> <input type="radio" class="radio" name="ResultView" id="ResultView2" value="2"' . ($_REQUEST['ResultView'] != 1 ? ' checked="checked"' : '') . ' /><label for="ResultView2">' . $T['posts'] . '</label></nobr></td>';
	echo '</tr>';

	echo '<tr valign="top">';
	echo '<td class="search"><input type="checkbox" class="radio" name="InSubject" id="InSubject" value="1"' .
		($_REQUEST['InSubject'] == 1 ? ' checked="checked"' : '') .
		' /><label for="InSubject">' . $T['in_subject'] . '</label> <input type="checkbox" class="radio" name="InMessage" id="InMessage" value="1"' .
		($_REQUEST['InMessage'] == 1 ? ' checked="checked"' : '') .
		' /><label for="InMessage">' . $T['in_message'] . '</label> <input type="checkbox" class="radio" name="InUser" id="InUser" value="1"' .
		($_REQUEST['InUser'] == 1 ? ' checked="checked"' : '') .
		' /><label for="InUser">' . $T['username'] . '</label> <input type="submit" class="button" value="' . $T['search'] . '" /></td>';
	echo '<td class="search">' . $T['sorting'] . ' <nobr><input type="radio" class="radio" name="Sort" id="Sort1" value="1"' .
		($_REQUEST['Sort'] != 2 ? ' checked="checked"' : '') .
		' /><label for="Sort1">' . $T['ascending'] . '</label> <input type="radio" class="radio" name="Sort" id="Sort2" value="2"' .
		($_REQUEST['Sort'] == 2 ? ' checked="checked"' : '') .
		' /><label for="Sort2">' . $T['descending'] . '</label></nobr></td>';
	echo '</tr>';

	echo '<tr valign="top">';
	echo '<td class="search">' . $T['date'] . ' ' . $T['date_from'] . ' <input type="text" class="text" size="10" maxlength="11" name="DateFrom" value="' . htmlquote($_REQUEST['DateFrom']) .
		'" /> ' . $T['date_until'] . ' <input type="text" class="text" size="10" maxlength="11" name="DateUntil" value="' . htmlquote($_REQUEST['DateUntil']) .
		'" /> <small>' . $T['search_date_format'] . '</small></td>';
	echo '<td class="search">' . $T['search_in_forum'] . ' <select class="text" name="Forum">';
	echo '<option value="0"' . ($topforum == 0 ? ' selected="selected"' : '') . '>' . $T['all_forums'] . '</option>';
	$output = '';
	ListForumsRec($topforum);
	echo $output;
	echo '</select></td>';
	echo '</tr>';

	echo '<tr valign="top">';
	echo '<td class="search" colspan="3"><small>' . $T['search_tip'] . '</small></td>';
	echo '</tr>';

	echo '</table>';
	echo '<br />';
	echo '</form>';
}

if ($_REQUEST['Query'] != '' || $_REQUEST['DateFrom'] != '' || $_REQUEST['DateUntil'] != '' || $_REQUEST['where'] != '')
{
	// There seems to be some work to do

	if ($_GET['nodef'] != 1 && $_GET['where'] == '')
	{
		addlog('search_query ' . $_REQUEST['Query']);
	}

	$post = new IPost;
	$thread = new IThread;

	$query = '';        // SQL query
	$title = '';        // title to display
	$get = '';          // GET parameters to pass other pages of the list
	$markread = false;  // Offer 'mark all forums as read' link
	$pre = $db->tblprefix;

	/*if ($_REQUEST['where'] != '')
	{
		// query is already composed
		$query = $_REQUEST['where'];
		$get = $_REQUEST['where'];
	}
	else*/
	if ($_REQUEST['DateFrom'] == -1)
	{
		if ($LoginUserID)
		{
			// search unread Threads
			$db->Exec("SELECT {$pre}Threads.ID FROM {$pre}Threads LEFT JOIN {$pre}ThreadWatch ON {$pre}Threads.ID = {$pre}ThreadWatch.Thread AND {$pre}ThreadWatch.User = $LoginUserID WHERE {$pre}Threads.LastPostDate > {$pre}ThreadWatch.LastRead OR {$pre}ThreadWatch.LastRead IS NULL");
			$ids = array();
			while ($record = $db->GetRecord()) array_push($ids, $record[0]);

			$ids_str = join(',', $ids);
			$query .= "{$pre}Threads.ID IN ($ids_str)";

			$title = $T['unread_topics'] . ':';
			#$get = "nodef=1&DateFrom=-1&ResultView=1";
			$markread = true;
		}
		else
		{
			$error .= $T['err_only_for_users'] . '<br />';
		}
	}
	elseif ($_REQUEST['DateFrom'] == -2)
	{
		if ($LoginUserID)
		{
			// search current surveys
			$query = "{$pre}Threads.Options & 4 AND {$pre}Threads.Date >= " . (time() - 3600 * 24 * rc('poll_current_days')) . " AND ({$pre}Threads.PollTimeout >= " . time() . " OR {$pre}Threads.PollTimeout = 0)";
			// last _ days, see config + poll has not ended yet

			$title = $T['current_polls'] . ':';
			#$get = "nodef=1&DateFrom=-2&ResultView=1";
		}
		else
		{
			// TODO: handle last visit cookie for guests HERE...
			$error .= $T['err_only_for_users'] . '<br />';
		}
	}
	else
	{
		// do normal query
		if ($_REQUEST['InSubject'] || $_REQUEST['InMessage'])
		{
			$highlight = array();
			$words = explode_quoted(' ', $_REQUEST['Query']);

			$n = 0;
			foreach ($words as $word)
			{
				if ($word != '')
				{
					$not = false;

					// link every segment correctly
					if ($query != '') $query .= ' ';
					if ($n) $query .= 'AND ';

					// process + and - word modifiers
					$in_subject = '';
					$in_message = '';
					if ($word{0} == '-')
					{
						$not = true;
						$in_subject .= 'NOT ';
						$in_message .= 'NOT ';
						$word = substr($word, 1);
					}

					// case-insensitive search
					$in_subject .= "({$pre}Posts.Subject LIKE \"%" . db_encode($word) . '%")';
					$in_message .= "({$pre}Posts.Msg LIKE \"%" . db_encode($word) . '%")';
					// this doesn't work:
					#$in_subject .= "(SOUNDEX({$pre}Posts.Subject) = SOUNDEX(\"" . db_encode($word) . '"))';
					#$in_message .= "(SOUNDEX({$pre}Posts.Msg) = SOUNDEX(\"" . db_encode($word) . '"))';

					$query .= '(';
					if ($_REQUEST['InSubject']) $query .= $in_subject;
					if ($_REQUEST['InSubject'] && $_REQUEST['InMessage']) $query .= ($not ? ' AND ' : ' OR ');
					if ($_REQUEST['InMessage']) $query .= $in_message;
					$query .= ')';

					if (!$not) $highlight[] = $word;

					$n++;
				}
			}
		}

		$in_user = '';
		if ($_REQUEST['InUser'])
		{
			// find any UserID containing this word -> only single-word search here! (Query string is interpreted as 1 word)
			$user = new IUser;
			if (substr($_REQUEST['Query'], 0, 1) == '!')
			{
				$user->Load(intval(substr($_REQUEST['Query'], 1)));
				$in_user = "({$pre}Posts.User = " . $user->GetID() . ')';
				$username = $user->GetName();
			}
			elseif (substr($_REQUEST['Query'], 0, 1) == '*')
			{
				$a = $user->GetListArray("Name LIKE \"%" . db_encode(substr($_REQUEST['Query'], 1)) . "%\"");
				$in_user = "({$pre}Posts.User IN (" . join(',', $a) . ") OR {$pre}Posts.UserName LIKE \"%" . db_encode(substr($_REQUEST['Query'], 1)) . "%\")";
				$username = $_REQUEST['Query'];
			}
			else
			{
				$id = $user->FindByName($_REQUEST['Query']);
				$in_user = "({$pre}Posts.User = $id OR {$pre}Posts.UserName LIKE \"" . db_encode($_REQUEST['Query']) . "\")";
				$username = $_REQUEST['Query'];
			}

			if ($query != '') $query .= ' AND ';
			$query .= $in_user;
			$title = $T['all_posts_by'] . ': ' . t2h($username);
		}

		if ($_REQUEST['DateFrom'] != '')
		{
			if ($query != '') $query .= ' AND ';

			$query .= "({$pre}Posts.Date >= ";

			$a = explode('.', $_REQUEST['DateFrom']);
			if (sizeof($a) == 1)
				$query .= $a[0];   // if there's no . it must be a unix timestamp
			else
				$query .= mktime(0, 0, 0, $a[1], $a[0], $a[2]);

			$query .= ')';

			if (intval($_REQUEST['title']) > 0) $title = $T['current_topics_of_last_'] . $_REQUEST['title'] . $T['_days'] . ':';
			if ($_REQUEST['title'] == 'login') $title = $T['current_topics_since_last_login'] . ':';
		}

		if ($_REQUEST['DateUntil'] != '')
		{
			if ($query != '') $query .= ' AND ';

			$query .= "({$pre}Posts.Date < ";

			$a = explode('.', $_REQUEST['DateUntil']);
			if (sizeof($a) == 1)
				$query .= $a[0];   // if there's no . it must be a unix timestamp
			else
				$query .= mktime(0, 0, 0, $a[1], $a[0], $a[2]);

			$query .= ')';
		}

		if ($topforum > 0)
		{
			// Find all forums from selected on
			GetForumsRec($topforum);
			array_push($forums, $topforum);
			if ($query != '') $query .= ' AND ';
			$query .= "{$pre}Threads.Forum IN (" . join(',', $forums) . ')';
		}
		if ($topforum < 0)
		{
			// Restrict search to one thread
			if ($query != '') $query .= ' AND ';
			$query .= "{$pre}Threads.ID = " . -$topforum;
		}
	}

	if (!$error)
	{
		$query = "SELECT " .
				($_REQUEST['ResultView'] == 1 ?
					"{$pre}Threads.ID, {$pre}Threads.Forum" :
					"{$pre}Posts.ID, {$pre}Threads.ID, {$pre}Threads.Forum") .
				' ' .
			"FROM {$pre}Posts LEFT JOIN {$pre}Threads ON {$pre}Posts.Thread = {$pre}Threads.ID " .
			"WHERE " . $query . ' ' .
			($_REQUEST['ResultView'] == 1 ? "GROUP BY {$pre}Threads.ID" : '');

		#echo "<small><b>SQL Query:</b> " . t2h($query) . "</small><br />";

		$db->Exec($query);
		$ids = array();
		while ($record = $db->GetRecord())
		{
			if ($_REQUEST['ResultView'] == 1 /*threads*/ && CheckRights('viewforum', $record[1], $record[0]))
				array_push($ids, $record[0]);
			elseif ($_REQUEST['ResultView'] == 2 /*posts*/ && CheckRights('viewforum', $record[2], $record[1]))
				array_push($ids, $record[0]);
		}

		$ids_str = join(',', $ids);

		$_SESSION['search_Query'] = $_REQUEST['Query'];
		$_SESSION['search_ResultView'] = $_REQUEST['ResultView'];
		$_SESSION['search_Forum'] = $_REQUEST['Forum'];
		$_SESSION['search_InSubject'] = $_REQUEST['InSubject'];
		$_SESSION['search_InMessage'] = $_REQUEST['InMessage'];
		$_SESSION['search_InUser'] = $_REQUEST['InUser'];
		$_SESSION['search_Sort'] = $_REQUEST['Sort'];
		$_SESSION['search_DateFrom'] = $_REQUEST['DateFrom'];
		$_SESSION['search_DateUntil'] = $_REQUEST['DateUntil'];

		$_SESSION['search_ids'] = $ids_str;
		$_SESSION['search_idcount'] = sizeof($ids);
		$_SESSION['search_markread'] = $markread;
		$_SESSION['search_title'] = $title;
		$_SESSION['search_highlight'] = $highlight;

		$_REQUEST['use_result'] = 1;
	}
}

if ($_REQUEST['use_result'] && !$error)
{
	$ids_str = $_SESSION['search_ids'];
	$idcount = $_SESSION['search_idcount'];
	$markread = $_SESSION['search_markread'];
	$title = $_SESSION['search_title'];
	$highlight = $_SESSION['search_highlight'];

	if ($ids_str != '') $query = 'ID IN (' . $ids_str . ')';
	else                $query = 'FALSE';              // force search to fail

	/*if ($get == '')
		$get = (isset($_GET['nodef']) ? "nodef=" . $_GET['nodef'] . "&" : "") .
			(isset($_GET['title']) ? "title=" . $_GET['title'] . "&" : "") .
			"Query=" . $_REQUEST['Query'] . "&InSubject=" . $_REQUEST['InSubject'] . "&InMessage=" . $_REQUEST['InMessage'] . "&InUser=" . $_REQUEST['InUser'] .
			"&ResultView=" . $_REQUEST['ResultView'] . "&Case=" . $_REQUEST['Case'] . "&DateFrom=" . $_REQUEST['DateFrom'] . "&DateUntil=" . $_REQUEST['DateUntil'] . "&Sort=" . $_REQUEST['Sort'];*/

	$get = 'use_result=1';
	if ($_GET['nodef'] == 1) $get .= '&nodef=1';

	echo '<p><b>'. $T['search_result'] . '</b> (' . $idcount . ')</p>';

	if ($title != '')
	{
		echo '<p>' . $title . '</p>';
		addlog('search_title ' . $title);
	}

	if ($_REQUEST['ResultView'] == 1)
	{
		// list Threads
		$markread &= ListThreads($query . ' AND NOT (Options & 8)', $page, 0, $get,
			/*order*/ 'LastPostDate' . ($_REQUEST['Sort'] == 1 ? '' : ' DESC'),
			'', false);
	}
	else
	{
		// list Posts
		ListPosts($query, $page, $get,
			/*order*/ 'Date' . ($_REQUEST['Sort'] == 1 ? '' : ' DESC'),
			false, $highlight, $idcount);
	}

	if ($markread)
	{
		echo '<p class="actionbar"><a href="' . $MODULE['main'] . PD . 'id=' . $parent . '&amp;allforumsread=1' . sid() . '">' . $T['mark_all_forums_read'] . '</a></p>';
	}
	echo '<p>';

	JumpForumBox(0);
	echo '</p>';
}

if ($error)
{
	echo '<p class="error">' . $error . '</p>';
}

UpdateStat('PageHits', 1);

EndHTML();
?>
