<?php
// BlackBoard - PHP Internet Newsboard System
// Copyright 2003-4 by Yves Goergen
// Homepage: http://blackboard.unclassified.de
// See docs/LICENSE.txt for distribution/license details
//
// stat.inc.php
// Show some board statistics


// Import request variables
$page = intval($_GET['page']);
if ($page < -1 || $page == 0) $page = 1;


$pre = $db->tblprefix;

$forum = new IForum;
$thread = new IThread;
$post = new IPost;
$user = new IUser;


// table sizes etc.
//
function table_status()
{
	global $db;

	$db->Exec('SHOW TABLE STATUS');
	$out = array();
	do
	{
		$record = @mysql_fetch_array($db->result);
		if ($record) array_push($out, $record);
	} while ($record);
	return $out;
}

// table size, depends on table_status()
//
function table_size($table, $ts = false)
{
	if ($ts === false) $ts = table_status();
	if ($ts === false) return false;

	foreach ($ts as $a)
	{
		if ($a['Name'] == $table) return $a['Data_length'] + $a['Index_length'];
	}
	return false;
}

// sums up all table sizes of MY tables
//
function my_tables_size()
{
	global $db;

	$ts = table_status();
	$size = 0;
	$pre = $db->tblprefix;

	$size += table_size($pre . 'ACL', $ts);
	$size += table_size($pre . 'ForumWatch', $ts);
	$size += table_size($pre . 'Forums', $ts);
	$size += table_size($pre . 'GroupMembers', $ts);
	$size += table_size($pre . 'GroupNames', $ts);
	$size += table_size($pre . 'Guests', $ts);
	$size += table_size($pre . 'MessageRead', $ts);
	$size += table_size($pre . 'Messages', $ts);
	$size += table_size($pre . 'PollUsers', $ts);
	$size += table_size($pre . 'PollVotes', $ts);
	$size += table_size($pre . 'Posts', $ts);
	$size += table_size($pre . 'Stat', $ts);
	$size += table_size($pre . 'ThreadWatch', $ts);
	$size += table_size($pre . 'Threads', $ts);
	$size += table_size($pre . 'UserCategoryState', $ts);
	$size += table_size($pre . 'Users', $ts);

	return $size;
}

function get_dir_size($mycwd = '')
{
	@$handle = opendir($mycwd);
	if ($handle === false) return 0;

	$size = 0;
	while ($file = readdir($handle))
	{
		if ($file != '.' && $file != '..' && !is_dir($mycwd . $file))
		{
			$size += @filesize($mycwd . $file);
		}
	}
	closedir($handle);

	return $size;
}


// Show some diagrams
//
function ShowStatDiagrams($page = 1)
{
	global $TABLE, $IMG, $db, $T, $ME;

	echo '<table cellspacing="' . $TABLE['cp']['space'] . '" cellpadding="' . $TABLE['cp']['pad'] . '" border="' . $TABLE['cp']['border'] . '" width="100%">';
	echo '<colgroup>';
	echo '<col width="100" />';
	echo '<col />';
	echo '<col />';
	echo '<col />';
	echo '<col />';
	echo '</colgroup>';

	echo '<tr valign="top">';
	echo '<td class="list_cp_head_left" width="100">' . $T['date'] . '</td>';
	echo '<td class="list_cp_head_0" width="21%">' . $T['stat_new_threads'] . '</td>';
	echo '<td class="list_cp_head_0" width="21%">' . $T['stat_new_posts'] . '</td>';
	echo '<td class="list_cp_head_0" width="26%">' . $T['stat_online_users'] . '</td>';
	echo '<td class="list_cp_head_0" width="17%">' . $T['stat_pagehits'] . '</td>';
	echo '<td class="list_cp_head_right" width="15%">' . $T['stat_regs'] . '</td>';
	echo '</tr>';

	$factor = rc('small_layout') ? 0.7 : 1;

	$width1 = 110 * $factor;
	$width2 = $width1;
	$width3 = 110 * $factor;
	$width4 = 70 * $factor;
	$width5 = 60 * $factor;

	$days_per_page = 14;

	# ---------- PAGE SELECTION ----------
	$day_count = $db->FastQuery1st('Stat', 'COUNT(*)');
	if (!$days_per_page)
		$page_count = 1;
	elseif ($day_count > $days_per_page)
		$page_count = ceil($day_count / $days_per_page);
	else
		$page_count = 1;

	if ($page > $page_count) $page = $page_count;
	if ($page == -1) $page = $page_count;

	if ($page_count > 1)
	{
		$boundary = 3;   // pages to show at the boundaries (begin/end)
		$middle = 2;     // pages to show around current page in the middle

		$page_str = '<table cellspacing="0" cellpadding="0" width="100%" class="actiontable"><tr>';
		$page_str .= '<td class="actionbar_r"><img ' . $IMG['page'] . ' /> ' . $T['page'] . ':&nbsp;';
		if ($page > 1)
			$page_str .= '<a href="' . $ME . PD . 'page=' . ($page - 1) . sid() . '">&nbsp;&#xAB;&nbsp;' . $T['prev_page2'] . '&nbsp;&nbsp;</a>';
		$state = 0;
		for ($n = 1; $n <= $page_count; $n++)
		{
			// show pages if they were the only one replaced by '...'
			$med_left = ($n == $boundary + 1 && $n == $page - $middle - 1);
			$med_right = ($n == $page + $middle + 1 && $n == $page_count - ($boundary - 1) - 1);

			if ($n <= $boundary || $med_left ||  abs($page - $n) <= $middle || $med_right || $n > $page_count - $boundary)
			{
				if ($n == $page)
					$page_str .= '&nbsp;<b>' . $n . '</b>&nbsp;';
				else
					$page_str .= '<a href="' . $ME . PD . 'page=' . $n . sid() . '">&nbsp;' . $n . '&nbsp;</a>';
			}
			else
			{
				if ($n < $page && $state < 1) { $page_str .= '...'; $state = 1; }
				if ($n > $page && $state < 2) { $page_str .= '...'; $state = 2; }
			}
		}
		if ($page < $page_count)
			$page_str .= '<a href="' . $ME . PD . 'page=' . ($page + 1) . $get . sid() . '">&nbsp;&nbsp;' . $T['next_page2'] . '&nbsp;&#xBB;&nbsp;</a>';
		$page_str .= '</td></tr></table>';
	}

	$max = $db->FastQuery('Stat', 'MAX(NewThreads), MAX(NewPosts), MAX(OnlineUsers + OnlineGuests), MAX(PageHits), MAX(NewUsers)');

	if ($days_per_page)
		$limit = (($page - 1) * $days_per_page) . ',' . $days_per_page;
	else
		$limit = '';
	$a = $db->FastQueryArray('Stat', '*', '', 'Date DESC', $limit);
	foreach ($a as $b)
	{
		echo '<tr>';

		if (date('w', $b['Date']) == 0 || date('w', $b['Date']) == 6)
		{
			$b1 = '<b>';
			$b2 = '</b>';
		}
		else
		{
			$b1 = '';
			$b2 = '';
		}
		echo '<td class="list_cp_l"><nobr>' . FormatTime($b['Date'], 1, ', ', /*tz_done*/ true) . ', ' . $b1 . bb_date('D', $b['Date']) . $b2 . ' &nbsp;</nobr></td>';

		echo '<td class="list_cp_l">';
		if ($b['NewThreads'] > 0 && $max[0])
		{
			echo '<img ' . $IMG['graph1'] . ' width="' . round($b['NewThreads'] / $max[0] * $width1) . '" height="10" />' .
				'<img ' . $IMG['graph1c'] . ' width="2" height="10" />';
		}
		echo ' <small>' . $b['NewThreads'] . '</small>';
		echo '</td>';

		echo '<td class="list_cp_l">';
		if ($b['NewPosts'] > 0 && $max[1])
		{
			echo '<img ' . $IMG['graph1'] . ' width="' . round($b['NewPosts'] / $max[1] * $width2) . '" height="10" />' .
				'<img ' . $IMG['graph1c'] . ' width="2" height="10" />';
		}
		echo ' <small>' . $b['NewPosts'] . '</small>';
		echo '</td>';

		echo '<td class="list_cp_l">';
		if (($b['OnlineUsers'] > 0 || $b['OnlineGuests'] > 0) && $max[2])
		{
			$w1 = round($b['OnlineUsers'] / $max[2] * $width3);
			$w2 = round($b['OnlineGuests'] / $max[2] * $width3);

			if ($b['OnlineUsers'] && $b['OnlineGuests'])
			{
				$w1--;
				$w2--;
			}

			if ($b['OnlineUsers']) echo '<img ' . $IMG['graph1'] . ' width="' . $w1 . '" height="10" />';
			if ($b['OnlineUsers'] && $b['OnlineGuests']) echo '<img ' . $IMG['graph1b'] . ' width="2" height="10" />';
			if ($b['OnlineUsers'] && !$b['OnlineGuests']) echo '<img ' . $IMG['graph1c'] . ' width="2" height="10" />';
			if ($b['OnlineGuests']) echo '<img ' . $IMG['graph0'] . ' width="' . $w2 . '" height="10" />';
			if ($b['OnlineGuests']) echo '<img ' . $IMG['graph0c'] . ' width="2" height="10" />';
		}
		echo ' <small>' . $b['OnlineUsers'] . '+' . $b['OnlineGuests'] . '</small>';
		echo '</td>';

		echo '<td class="list_cp_l">';
		if ($b['PageHits'] > 0 && $max[3])
		{
			echo '<img ' . $IMG['graph1'] . ' width="' . round($b['PageHits'] / $max[3] * $width4) . '" height="10" />' .
				'<img ' . $IMG['graph1c'] . ' width="2" height="10" />';
		}
		echo ' <small>' . $b['PageHits'] . '</small>';
		echo '</td>';

		echo '<td class="list_cp_l">';
		if ($b['NewUsers'] > 0 && $max[4])
		{
			echo '<img ' . $IMG['graph1'] . ' width="' . round($b['NewUsers'] / $max[4] * $width5) . '" height="10" />' .
				'<img ' . $IMG['graph1c'] . ' width="2" height="10" />';
		}
		echo ' <small>' . $b['NewUsers'] . '</small>';
		echo '</td>';

		echo '</tr>';

	}
	echo '</table>';

	if ($page_str) echo $page_str;
}


// Begin page
//
BeginHTML($T['statistics']);

if (!CheckRights('showstat'))
{
	echo '<p class="error">' . $T['err_access_denied'] . '</p>';
	errorlog('Access denied');
}
else
{
	UpdateStat('PageHits', 1);

	// Collect overall statistic values
	//
	$forum_count = $forum->Count('NOT (Flags & 1) AND NOT (Flags & 2)');
	$thread_count = $thread->Count();
	$post_count = $post->Count();
	$post_guests = $post->Count('User = 0');
	$poll_count = $thread->Count('Options & 4');

	$db->Exec("SELECT COUNT(*) FROM {$pre}PollUsers");
	$record = $db->GetRecord();
	$poll_votes = $record[0];

	$user_count = $user->Count();

	$db->Exec("SELECT count(*) FROM {$pre}Users LEFT JOIN {$pre}GroupMembers ON {$pre}Users.ID = {$pre}GroupMembers.User " .
		"WHERE {$pre}Users.ActivateKey != '' AND {$pre}GroupMembers.User IS NULL");
	$rec = $db->GetRecord();
	if ($rec === false)
		$not_valid_count = 0;
	else
		$not_valid_count = $rec[0];

	$database_size = my_tables_size();

	// don't count the same folder 3 times!
	$upload_folder_size = get_dir_size($avatar_path);
	if ($photo_path != $avatar_path) $upload_folder_size += get_dir_size($photo_path);
	if ($attach_path != $photo_path && $attach_path != $avatar_path) $upload_folder_size += get_dir_size($attach_path);


	// Display actual page content
	addlog('view_stat');
	if ($LoginUserID) $LoginUser->SetLastActivity(ULF_STAT);
	else SetGuestLastForum(ULF_STAT);

	ShowStatDiagrams($page);

	echo '<br />';

	echo '<table cellspacing="' . $TABLE['cp']['space'] . '" cellpadding="' . $TABLE['cp']['pad'] . '" border="' . $TABLE['cp']['border'] . '" width="100%">';
	echo '<colgroup>';
	echo '<col width="25%" />';
	echo '<col width="30%" />';
	echo '<col width="25%" />';
	echo '<col width="20%" />';
	echo '</colgroup>';

	echo '<tr valign="top">';
	echo '<td class="list_cp_head_left" colspan="2" width="50%">' . $T['stat_forums_threads_posts'] . '</td>';
	echo '<td class="list_cp_head_right" colspan="2" width="50%">' . $T['stat_users'] . '</td>';
	echo '</tr>';

	echo '<tr valign="top">';
	echo '<td class="list_cp_n" width="25%">' . $T['num_of_forums'] . ':</td><td class="list_cp_n">' . $forum_count . '</td>';
	echo '<td class="list_cp_x" width="30%">' . $T['registered_users'] . ':</td><td class="list_cp_n">' . $user_count . '</td>';
	echo '</tr>';

	echo '<tr valign="top">';
	echo '<td class="list_cp_n" width="25%">' . $T['num_of_threads'] . ':</td><td class="list_cp_n">' . $thread_count . ' &nbsp; (' .
		($forum_count > 0 ? format_number($thread_count / $forum_count, 1) : 0) .
		' ' . $T['threads_per_forum'] . ')</td>';
	echo '<td class="list_cp_x" width="20%">' . $T['users_wait_validation'] . ':</td><td class="list_cp_n">' . $not_valid_count . '</td>';
	echo '</tr>';

	echo '<tr valign="top">';
	echo '<td class="list_cp_n">' . $T['num_of_posts'] . ':</td><td class="list_cp_n">' . $post_count . ' &nbsp; (' .
		($thread_count > 0 ? format_number($post_count / $thread_count, 1) : 0) .
		' ' . $T['posts_per_thread'] . ')</td>';
	echo '<td class="list_cp_x">' . $T['posts_per_user'] . ':</td><td class="list_cp_n">' .
		($user_count > 0 ? format_number($post_count / $user_count, 1) : 0) .
		'</td>';
	echo '</tr>';

	echo '<tr valign="top">';
	echo '<td class="list_cp_n">' . $T['num_of_polls'] . ':</td><td class="list_cp_n">' . $poll_count . ' &nbsp; (' .
		($poll_count > 0 ? format_number($poll_votes / $poll_count, 1) : 0) .
		' ' . $T['votes_per_poll'] . ')</td>';
	echo '<td class="list_cp_x">' . $T['guest_posts'] . ':</td><td class="list_cp_n">' . $post_guests . ' &nbsp; (' .
		($post_count > 0 ? format_number($post_guests / $post_count * 100, 1) : 0) .
		'%)</td>';
	echo '</tr>';

	echo '<tr valign="top">';
	echo '<td class="list_cp_n">' . $T['database_size'] . ':</td><td class="list_cp_n">' . format_number($database_size, 1, 1024, ' ') . 'B</td>';
	echo '<td class="list_cp_x">' . $T['upload_folder_size'] . ':</td><td class="list_cp_n">' . format_number($upload_folder_size, 1, 1024, ' ') . 'B</td>';
	echo '</tr>';

	echo '</table>';

	echo '<br />';

	echo $T['top_10_threads'] . '<br />';
	ListThreads('LastPostDate >= ' . (time() - 14 * 24 * 3600), 1, 0, '', 'Views DESC', '10', false);
}

// PageHits is counted up on the top of this page!

EndHTML();
?>
