<?php
// BlackBoard - PHP Internet Newsboard System
// Copyright 2003-4 by Yves Goergen
// Homepage: http://blackboard.unclassified.de
// See docs/LICENSE.txt for distribution/license details
//
// thread.inc.php
// Show Posts in a Thread

require_once($libpath . 'common_post.lib.php');

// Import request variables
$threadid = intval($_REQUEST['id']);
if (isset($_GET['threadid'])) $threadid = intval($_GET['threadid']);   // for WBB1 compatibility
if ($threadid < 0) $threadid = 0;

$page = intval($_REQUEST['page']);
if ($page < -1 || $page == 0) $page = 1;


// Add watching method
//
if (isset($_GET['watch']) && $LoginUserID > 0)
{
	$thread = new IThread;
	if ($thread->Load($threadid))
	{
		$mode = intval($thread->IsWatched());
		$mode |= intval($_GET['watch']);
		$thread->SetWatched($mode);
	}
	addlog('watch_thread ' . $threadid . ' mode ' . $_GET['watch']);
	/* ForwardHTML($ME . PD . "id=$threadid&page=$page&nocount=1" . sid());
	exit(); */
}

// Remove watching method
//
if (isset($_GET['unwatch']) && $LoginUserID > 0)
{
	$thread = new IThread;
	if ($thread->Load($threadid))
	{
		$mode = intval($thread->IsWatched());
		$mode = $mode & ~intval($_GET['unwatch']);
		$thread->SetWatched($mode);
	}
	addlog('unwatch_thread ' . $threadid . ' mode ' . $_GET['unwatch']);
	if (intval($_GET['b2p']) > 0)   // go Back2Profile...
	{
		ForwardHTML($MODULE['cp'] . PD . 'id=' . $_GET['b2p'] . '&amp;item=3' . sid());
		exit();
	}
	if (intval($_GET['b2b']) > 0)   // go Back2Bookmarks...
	{
		ForwardHTML($MODULE['cp'] . PD . 'id=' . $_GET['b2b'] . '&amp;item=4' . sid());
		exit();
	}
	/* else
	{
		ForwardHTML($ME . PD . "id=$threadid&page=$page&nocount=1" . sid());
		exit();
	} */
}

// Split current thread
//
$splitmode = false;
if (isset($_REQUEST['split']))
{
	$thread = new IThread;
	$thread->Load($threadid);
	if (CheckRights('closethread', $thread->GetForum(), $thread->GetID()) &&
	    CheckRights('importantthread', $thread->GetForum(), $thread->GetID()))
	{
		if ($_REQUEST['split'] == 1)
		{
			$splitmode = true;
		}
		if ($_REQUEST['split'] == 2 &&
		    $_REQUEST['forumid'] > 0 &&
		    $_REQUEST['Subject'] != '' &&
		    is_array($_REQUEST['PostID']) &&
		    sizeof($_REQUEST['PostID']))
		{
			// Actually split the thread
			$post = new IPost;

			// Load the first post
			$post->Load($_REQUEST['PostID'][0]);

			$newthread = new IThread;
			if ($newthread->Add($_REQUEST['forumid'], '', $_REQUEST['Subject'], $opt, $post->GetDate()))
			{
				$newthreadid = $newthread->GetID();

				// Set some more of the new thread's parameters
				$newthread->SetUser($post->GetUser(), $post->GetUserName());
				$newthread->SetDesc($_REQUEST['Desc']);

				// move all selected posts to the new thread
				$post->SetThreadArray($newthreadid, $_REQUEST['PostID']);

				if ($post->Find('Thread=' . $newthreadid . ' AND AttachFile!=""', '', '1'))
				{
					$newthread->SetOptions(16);   // Add attachment marker if one post has an attachment
				}
				if (!$post->Find('Thread=' . $threadid . ' AND AttachFile!=""', '', '1'))
				{
					$thread->SetOptions($thread->GetOptions() & ~16);   // Remove attachment marker from old thread
				}

				// Load the last post
				$post->Load($_REQUEST['PostID'][sizeof($_REQUEST['PostID']) - 1]);
				$newthread->SetLastPostDate($post->GetDate());

				// Load the last post of the old thread and update LastPostDate
				$post->Find('Thread=' . $threadid, 'Date DESC', '1');
				$thread->SetLastPostDate($post->GetDate());

				// copy all ThreadWatchs to new thread (user read + notifications)
				$pre = $db->tblprefix;
				$db->Exec("INSERT INTO {$pre}ThreadWatch " .
					"SELECT $newthreadid AS Thread, User, Mode, LastRead, LastNotify " .
					"FROM {$pre}ThreadWatch " .
					"WHERE Thread=$threadid");

				// forward to the newly created thread
				addlog('split_thread ' . $threadid . ' to ' . $newthreadid);
				ForwardHTML($ME . PD . 'id=' . $newthreadid . sid());
				exit();
			}
			else
			{
				errorlog("error creating new thread for splitting of $threadid");
			}
		}
	}
}

// Close current thread
//
if (isset($_GET['close']))
{
	$thread = new IThread;
	$thread->Load($threadid);
	if (CheckRights('closethread', $thread->GetForum(), $thread->GetID()))
	{
		$thread->SetOptions(($thread->GetOptions() & ~1) | ($_GET['close'] == 1 ? 1 : 0) * 1);
		if ($_GET['close'] == 1)
			addlog('close_thread ' . $threadid);
		else
			addlog('unclose_thread ' . $threadid);
		ForwardHTML($ME . PD . 'id=' . $threadid . '&amp;page=' . $page . sid());
		exit();
	}
	unset($thread);
}

// Add a Vote
//
if ($_POST['action'] == 'vote' && $_POST['Vote'] > 0)
{
	$thread = new IThread;
	$thread->AddVote($threadid, $_POST['Vote']);

	addlog('add_vote ' . $_POST['Vote'] . ' for ' . $threadid);
	ForwardHTML($ME . PD . 'id=' . $threadid . '&amp;page=' . $page . sid());
	exit();
}

// Take User's Vote for this thread back (is possible)
//
if ($_GET['unvote'] == 1)
{
	$thread = new IThread;
	$thread->RemoveVote($threadid);

	addlog('remove_vote for ' . $threadid);
	ForwardHTML($ME . PD . 'id=' . $threadid . '&amp;page=' . $page . sid());
	exit();
}

// Download an attached file
//
if ($_GET['download'] > 0)
{
	$post = new IPost;
	if (!$post->Load($_GET['download'])) die($T['err_invalid_post_id']);

	$thread = new IThread;
	if (!$thread->Load($post->GetThread())) die($T['err_invalid_thread']);
	if (!CheckRights('downloadattach', $thread->GetForum(), $thread->GetID())) die($T['err_attach_no_permission']);

	if (!file_exists($attach_path . $post->GetAttachFile())) die($T['err_file_not_found']);
	addlog('download_post_attach ' . $post->GetID() . ' (' . $post->GetAttachFileName() . ')');

	$post->IncDLCount();

	$type = ($_GET['inline']) ? 'Inline' : 'Attachment';
	header('Content-Type: ' . get_mimetype($post->GetAttachFileName()));
	header('Content-Disposition: ' . $type . '; filename="' . $post->GetAttachFileName() . '"');

	readfile($attach_path . $post->GetAttachFile());
	exit();
}

// The following 3 functions are the same as in main.inc.php!

// Mark a Message read
//
if ($_GET['messageread'] > 0 && $LoginUserID > 0)
{
	$message = new IMessage;
	if ($message->Load($_GET['messageread']))
	{
		$message->SetRead();
	}
	addlog('message_read ' . $_GET['messageread']);
	#ForwardHTML($ME . PD . "id=$toplevel" . sid());
	#exit();
}

// Mark a Message unread
//
if ($_GET['messageunread'] > 0 && $LoginUserID > 0)
{
	$message = new IMessage;
	if ($message->Load($_GET['messageunread']))
	{
		$message->SetRead(false);
	}
	addlog('message_unread ' . $_GET['messageunread']);
	#ForwardHTML($ME . PD . "id=$toplevel" . sid());
	#exit();
}

// Mark a Message unread for all users
//
if ($_GET['messageallunread'] > 0)
{
	$message = new IMessage;
	$message->Load($_GET['messageallunread']);

	if (CheckRights('editmessage', $message->GetForum()))
	{
		$message->RemoveAllReads($_GET['messageallunread']);

		addlog('message_all_unread ' . $_GET['messageallunread']);
		#ForwardHTML($ME . PD . "id=$toplevel" . sid());
		#exit();
	}
}


$thread = new IThread;

// if user doesn't have access to this forum (or it doesn't exist) STOP here
$ok = true;
if (!$thread->Load($threadid)) $ok = false;
if (!CheckRights('viewforum', $thread->GetForum(), $threadid)) $ok = false;

if (!$ok)
{
	BeginHTML($T[thread_view]);
	echo '<p class="error">' . $T['err_invalid_thread'] . '</p>';
	EndHTML();
	#if ($CFG['code_before_exit']) eval($CFG['code_before_exit']);
	exit();
}

// Begin page
BeginHTML(t2h($thread->GetSubject()));

echo '<script type="text/javascript">' /*. '<![CDATA['*/;
include($libpath . 'editor.js.php');
echo /*']]>' .*/ '</script>';
echo '<script type="text/javascript" src="' . $libpath . 'editor.js"></script>';

ShowPath($thread->GetForum(), $thread->GetSubject(), $thread->GetDesc(), $threadid, true);
if ($LoginUserID) $LoginUser->SetLastActivity($thread->GetForum());
else SetGuestLastForum($thread->GetForum());

if (!$splitmode)
{
	ListMessages($thread->GetForum(), $threadid, $page);

	addlog('view_thread ' . $threadid . ' page ' . $page . ($_GET['nocount'] == 1 ? ' nocount' : '') . ' (' . $thread->GetSubject() . ')');
	ListPosts($threadid, $page);

	echo '<p><table cellspacing="0" cellpadding="0" width="100%"><tr valign="top"><td>';
	// left column: forum links
	if (rc('show_goto_forum'))
		JumpForumBox($thread->GetForum());
	else
		ShowPath($thread->GetForum(), $thread->GetSubject(), $thread->GetDesc(), $threadid);
	echo '</td><td align="right">';
	// right column: searchbox
	if (rc('show_search_forum')) SearchTextbox(-$threadid);
	echo '</td></tr></table></p>';

	if (($LoginUserID > 0) &&
		($LoginUser->GetFlags() & 16) &&
		($threadid > 0 && CheckRights('writeforum', $thread->GetForum())) &&
		($page == $page_count || $page == -1))
	{
		echo '<br />';

		echo '<form action="' . $MODULE['post'] . sid(2) . '" method="post" name="form" enctype="multipart/form-data">';
		echo '<input type="hidden" name="action" value="add" />';
		echo '<input type="hidden" name="forum" value="' . $thread->GetForum() . '" />';
		echo '<input type="hidden" name="thread" value="' . $threadid . '" />';
		echo '<input type="hidden" name="CloseThread" value="' . ($thread->IsClosed() ? '1' : '0') . '" />';
		echo '<input type="hidden" name="ImportantThread" value="' . ($thread->IsImportant() ? '1' : '0') . '" />';

		echo '<table cellspacing="' .$TABLE['post']['space'] . '" cellpadding="' . $TABLE['post']['pad'] . '" border="' . $TABLE['post']['border'] . '" width="100%"' . $TABLE['post']['fixed'] . '>';
		echo '<colgroup>';
		echo '<col width="120" />';
		echo '<col width="470" />';
		echo '<col />';
		echo '</colgroup>';

		echo '<tr valign="top">';
		echo '<td class="edit_post_head_left" colspan="2">' . $T['compose_post'] . '</td>';
		echo '<td class="edit_post_head_right">&nbsp;</td>';
		echo '</tr>';

		# SUBJECT
		echo '<tr>';
		echo '<td class="edit_post"><i>' . $T['subject'] . ':</i></td>';
		echo '<td class="edit_post" colspan="2">';
		echo '<input type="text" class="text" name="Subject" size="71" maxlength="150" />';
		echo '</td>';
		echo '</tr>';

		# MESSAGE
		echo '<tr valign="top">';
		echo '<td class="edit_post">' . $T['text'] . ':</td>';
		echo '<td class="edit_post">';
		echo '<textarea class="text" name="Msg" cols="70" rows="8" onkeydown="return text_keydown(this)"></textarea>';
		echo '</td>';
		echo '<td class="edit_post">&nbsp;</td>';
		echo '</tr>';

		# SUBMIT / PREVIEW CONTROLS
		echo '<tr valign="top">';
		echo '<td class="edit_post">&nbsp;</td>';
		echo '<td class="edit_post" colspan="2">';
		echo '<input type="submit" class="button" name="save" value="' . $T['save'] . '" accesskey="' . $T['save_key'] . '" onclick="disableObj(\'document.form.save\');" /> <small>' . $T['save_key_name'] . '</small> ';
		echo '<input type="submit" class="button" name="preview" value="' . $T['preview'] . '" accesskey="' . $T['preview_key'] . '" onclick="disableObj(\'document.form.save\');" /> <small>' . $T['preview_key_name'] . '</small> ';
		echo '</td>';
		echo '</tr>';

		# is user already watching this thread?
		$mode = $thread->IsWatched($threadid);
		if (!$mode) $mode = $LoginUser->GetDefaultNotify();

		if ($LoginUser->GetEMail() != '' && $mode & 1) echo '<input type="hidden" name="NotifyEMail" value="1" />';
		if ($LoginUser->GetJabber() != '' && $CFG['enable_jabber'] && $mode & 4) echo '<input type="hidden" name="NotifyJabber" value="1" />';
		if ($LoginUser->GetICQ() != '' && $CFG['enable_icq'] && $mode & 2) echo '<input type="hidden" name="NotifyICQ" value="1" />';

		echo '</table>';
		echo '</form>';
	}
}
else   // $splitmode == true
{
	// List posts of this thread in a shortened way to select them for splitting
	$post = new IPost;
	$user = new IUser;

	$newThreadSubject = '[' . $thread->GetSubject() . ']';
	$displayLimitLength = 400;

	echo '<form action="' . $ME . sid(2) . '" method="post">';
	echo '<input type="hidden" name="id" value="' . $threadid . '" />';
	echo '<input type="hidden" name="split" value="2" />';
	echo '<input type="hidden" name="id" value="' . $threadid . '" />';
	echo '<input type="hidden" name="forumid" value="' . $thread->GetForum() . '" />';

	echo '<p>';
	echo str_replace('%n', $displayLimitLength, $T['split_note']);
	echo '</p>';

	// Input data for new thread
	echo '<p>';
	echo '<table cellspacing="0" cellpadding="0">';

	echo '<tr><td>' . $T['subject'] . ': &nbsp;</td><td><input type="text" class="text" name="Subject" size="30" value="' . htmlquote($newThreadSubject) . '" /></td></tr>';
	echo '<tr><td>' . $T['description'] . ': &nbsp;</td><td><input type="text" class="text" name="Desc" size="50" /></td></tr>';
	echo '</table>';
	echo '</p>';

	echo '<p>';
	echo '<table cellspacing="' . $TABLE['post']['space'] . '" cellpadding="' . $TABLE['post']['pad'] . '" border="' . $TABLE['post']['border'] . '" width="100%">';

	$count = 0;
	$abbc_cfg['auto_close_tags'] = true;

	// copy of PostDelimiter()
	echo '<tr><td class="list_post_new_topline" colspan="2">';
	if ($TABLE['post']['line'] == 1) echo '<hr />';
	else echo '<img ' . $IMG['empty'] . ' width="1" height="1" />';
	echo '</td></tr>';

	if ($post->Find('Thread=' . $threadid, 'Date')) do
	{
		// Display post information
		echo '<tr><td class="list_post_new_unameinfo_' . ($count % 2) . '">';

		echo FriendlyDate($post->GetDate(), 1, 3) . ' ' . $T['by'] . ' ';
		$userid = $post->GetUser();
		if ($user->Load($userid))
		{
			echo '<b>' . t2h($user->GetName()) . '</b>' . GetUserStatusText($userid, ' <small>(%s)</small>', true, false);
		}
		else
		{
			echo '<b>' . t2h($post->GetUserName()) . '</b>' . GetUserStatusText($userid, ' <small>(%s)</small>', true, false);
		}
		echo '</td>';

		echo '<td class="list_post_new_date_' . ($count % 2) . '" align="right">&nbsp;';
		// Show a direct link to the post in its thread context
		echo MakePostLink($post, 0, 0, true) . '<img ' . $IMG['goto_post'] . ' /> ' . $T['goto_post'] . '</a>';
		// Show split-off checkbox from the second post on
		if ($count)
		{
			echo ' &nbsp; <input type="checkbox" class="radio" name="PostID[]" id="PostID_' . $post->GetID() . '" value="' . $post->GetID() . '" /><label for="PostID_' . $post->GetID() . '">' . $T['split_post'] . '</label><br />';
		}
		echo '</td></tr>';

		if ($post->GetSubject())
		{
			echo '<tr><td class="list_post_new_subject_' . ($count % 2) . '" colspan="2">';
			echo $T['subject'] . ': ' . t2h($post->GetSubject()) . '<br />';
			echo '</td></tr>';
		}

		echo '<tr><td class="list_post_new_message_' . ($count % 2) . '" colspan="2">';
		echo abbc_proc(str_limit($post->GetMsg(), $displayLimitLength)) . '<br />';
		echo '</td></tr>';

		$found_next = $post->FindNext();

		// copy of PostDelimiter()
		if ($found_next)
			echo '<tr><td class="list_post_new_delimiter" colspan="2">';
		else
			echo '<tr><td class="list_post_new_endline" colspan="2">';
		if ($TABLE['post']['line'] == 1) echo '<hr />';
		else echo '<img ' . $IMG['empty'] . ' width="1" height="1" />';
		echo '</td></tr>';

		$count++;
	}
	while ($found_next);

	echo '</table><br />';

	if ($count > 1)
	{
		echo '<input type="submit" class="button" value="' . $T['split_thread'] . '" />';
	}

	echo '</p>';
	echo '</form>';

	$abbc_cfg['auto_close_tags'] = false;
}

UpdateStat('PageHits', 1);

EndHTML();
?>
