<?php
// BlackBoard - PHP Internet Newsboard System
// Copyright 2003-4 by Yves Goergen
// Homepage: http://blackboard.unclassified.de
// See docs/LICENSE.txt for distribution/license details

#
#  host/browser info
#  collect data from http variables of the web server
#
#  fills the following variables
#
#    host_referer  = HTTP_REFERER
#    host_ip       = REMOTE_ADDR
#    host_lang     = HTTP_ACCEPT_LANGUAGE
#    host_browser  =
#      IE:               2  3  4                5.0 5.1 5.5  6
#      NN:                  3  4.0 4.5 4.6 4.7               6.0 6.1 6.2 7.0
#      OPERA:               3  4                5 5.0 5.1    6 6.0 6.1   7.0 7.1 7.2 7.5
#      MOZ:     1.0 1.1 1.2 1.3 1.4 1.5 1.6 1.7 1.8
#      FB:      0.x 1.0
#      GECKO
#      KONQUER: 1        2  3
#      TEXT
#
#      IE-MEDIA, NN-MEDIA
#      SEARCH, SPAMBOT
#      DOWNLOAD
#      PHP, FRONTPAGE
#
#    host_bver     = (see above)
#    host_os       = W95, W98, WME, NT4 W2K WXP | NT, WIN, LIN, UNIX, MAC, OS2
#    host_os_class = WIN, UNIX, MAC, OS2
#
#    host_isbrowser= true|false  (only for real browsers)
#    host_isaol    = true|false  (AOL user?)
#

$raw_ua = $_SERVER['HTTP_USER_AGENT'];

$host_referer = (isset($_SERVER['HTTP_REFERER']) ? $_SERVER['HTTP_REFERER'] : "");
$host_ip = $_SERVER['REMOTE_ADDR'];
$host_browser = "";
$host_bver = "";
$host_os = "";

$host_isbrowser = true;
$host_isaol = false;

$raw_lang = explode(',', $_SERVER['HTTP_ACCEPT_LANGUAGE']);
$raw_lang2 = array();
foreach ($raw_lang as $lang)
{
	$raw_lang3 = explode(';', $lang);
	array_push($raw_lang2, $raw_lang3[0]);
}
$host_lang = str_replace(' ', '', join(',', $raw_lang2));
unset($raw_lang);
unset($raw_lang2);

if (!isset($host_username)) $host_username = '';

if (stristr($raw_ua, 'Opera 3')) { $host_browser = 'OP'; $host_bver = '3.0'; }
elseif (stristr($raw_ua, 'Opera 4')) { $host_browser = 'OP'; $host_bver = '4.0'; }
elseif (stristr($raw_ua, 'Opera 5')) { $host_browser = 'OP'; $host_bver = '5.0'; }
elseif (stristr($raw_ua, 'Opera/5.0')) { $host_browser = 'OP'; $host_bver = '5.0'; }
elseif (stristr($raw_ua, 'Opera/5.1')) { $host_browser = 'OP'; $host_bver = '5.1'; }
elseif (stristr($raw_ua, 'Opera 6')) { $host_browser = 'OP'; $host_bver = '6.0'; }
elseif (stristr($raw_ua, 'Opera/6.0')) { $host_browser = 'OP'; $host_bver = '6.0'; }
elseif (stristr($raw_ua, 'Opera/6.1')) { $host_browser = 'OP'; $host_bver = '6.1'; }
elseif (stristr($raw_ua, 'Opera 7')) { $host_browser = 'OP'; $host_bver = '7.0'; }
elseif (stristr($raw_ua, 'Opera/7.0')) { $host_browser = 'OP'; $host_bver = '7.0'; }
elseif (stristr($raw_ua, 'Opera/7.1')) { $host_browser = 'OP'; $host_bver = '7.1'; }
elseif (stristr($raw_ua, 'Opera/7.2')) { $host_browser = 'OP'; $host_bver = '7.2'; }
elseif (stristr($raw_ua, 'Opera/7.5')) { $host_browser = 'OP'; $host_bver = '7.5'; }
elseif (stristr($raw_ua, 'MSIE 2')) { $host_browser = 'IE'; $host_bver = '2.0'; }
elseif (stristr($raw_ua, 'MSIE 3')) { $host_browser = 'IE'; $host_bver = '3.0'; }
elseif (stristr($raw_ua, 'MSIE 4')) { $host_browser = 'IE'; $host_bver = '4.0'; }
elseif (stristr($raw_ua, 'MSIE 5.0')) { $host_browser = 'IE'; $host_bver = '5.0'; }
elseif (stristr($raw_ua, 'MSIE 5.1')) { $host_browser = 'IE'; $host_bver = '5.1'; }
elseif (stristr($raw_ua, 'MSIE 5.5')) { $host_browser = 'IE'; $host_bver = '5.5'; }
elseif (stristr($raw_ua, 'MSIE 5')) { $host_browser = 'IE'; $host_bver = '5'; }
elseif (stristr($raw_ua, 'MSIE 6')) { $host_browser = 'IE'; $host_bver = '6.0'; }
elseif (stristr($raw_ua, 'Firebird/0.1')) { $host_browser = 'FB'; $host_bver = '0.1'; }
elseif (stristr($raw_ua, 'Firebird/0.2')) { $host_browser = 'FB'; $host_bver = '0.2'; }
elseif (stristr($raw_ua, 'Firebird/0.3')) { $host_browser = 'FB'; $host_bver = '0.3'; }
elseif (stristr($raw_ua, 'Firebird/0.4')) { $host_browser = 'FB'; $host_bver = '0.4'; }
elseif (stristr($raw_ua, 'Firebird/0.5')) { $host_browser = 'FB'; $host_bver = '0.5'; }
elseif (stristr($raw_ua, 'Firebird/0.6')) { $host_browser = 'FB'; $host_bver = '0.6'; }
elseif (stristr($raw_ua, 'Firebird/0.7')) { $host_browser = 'FB'; $host_bver = '0.7'; }
elseif (stristr($raw_ua, 'Firefox/0.8')) { $host_browser = 'FB'; $host_bver = '0.8'; }
elseif (stristr($raw_ua, 'Firefox/0.9')) { $host_browser = 'FB'; $host_bver = '0.9'; }
elseif (stristr($raw_ua, 'Firefox/1.0')) { $host_browser = 'FB'; $host_bver = '1.0'; }
elseif (stristr($raw_ua, 'mozilla/3')) { $host_browser = 'NN'; $host_bver = '3.0'; }
elseif (stristr($raw_ua, 'mozilla/4.0')) { $host_browser = 'NN'; $host_bver = '4.0'; }
elseif (stristr($raw_ua, 'mozilla/4.5')) { $host_browser = 'NN'; $host_bver = '4.5'; }
elseif (stristr($raw_ua, 'mozilla/4.6')) { $host_browser = 'NN'; $host_bver = '4.6'; }
elseif (stristr($raw_ua, 'mozilla/4.7')) { $host_browser = 'NN'; $host_bver = '4.7'; }
elseif (stristr($raw_ua, 'netscape6/6.0')) { $host_browser = 'NN'; $host_bver = '6.0'; }
elseif (stristr($raw_ua, 'netscape6/6.1')) { $host_browser = 'NN'; $host_bver = '6.1'; }
elseif (stristr($raw_ua, 'netscape6/6.2')) { $host_browser = 'NN'; $host_bver = '6.2'; }
elseif (stristr($raw_ua, 'Netscape/7.0')) { $host_browser = 'NN'; $host_bver = '7.0'; }
elseif (stristr($raw_ua, 'Gecko/'))
{
	if (stristr($raw_ua, 'rv:1.0')) { $host_browser = 'MOZ'; $host_bver = '1.0'; }
	elseif (stristr($raw_ua, 'rv:1.1')) { $host_browser = 'MOZ'; $host_bver = '1.1'; }
	elseif (stristr($raw_ua, 'rv:1.2')) { $host_browser = 'MOZ'; $host_bver = '1.2'; }
	elseif (stristr($raw_ua, 'rv:1.3')) { $host_browser = 'MOZ'; $host_bver = '1.3'; }
	elseif (stristr($raw_ua, 'rv:1.4')) { $host_browser = 'MOZ'; $host_bver = '1.4'; }
	elseif (stristr($raw_ua, 'rv:1.5')) { $host_browser = 'MOZ'; $host_bver = '1.5'; }
	elseif (stristr($raw_ua, 'rv:1.6')) { $host_browser = 'MOZ'; $host_bver = '1.6'; }
	elseif (stristr($raw_ua, 'rv:1.7')) { $host_browser = 'MOZ'; $host_bver = '1.7'; }
	elseif (stristr($raw_ua, 'rv:1.8')) { $host_browser = 'MOZ'; $host_bver = '1.8'; }
	elseif (stristr($raw_ua, 'rv:1.9')) { $host_browser = 'MOZ'; $host_bver = '1.9'; }
	else { $host_browser = 'GECKO'; $host_bver = ''; }
}
elseif (stristr($raw_ua, 'Konqueror/1')) { $host_browser = 'KON'; $host_bver = '1.0'; $host_os = 'LIN'; }
elseif (stristr($raw_ua, 'Konqueror/2')) { $host_browser = 'KON'; $host_bver = '2.0'; $host_os = 'LIN'; }
elseif (stristr($raw_ua, 'Konqueror/3')) { $host_browser = 'KON'; $host_bver = '3.0'; $host_os = 'LIN'; }
elseif (stristr($raw_ua, 'Konqueror')) { $host_browser = 'KON'; $host_bver = ''; $host_os = 'LIN'; }

elseif (stristr($raw_ua, 'Lynx/')) { $host_browser = 'TEXT'; $host_bver = ''; $host_os = ''; }
elseif (stristr($raw_ua, 'Links/')) { $host_browser = 'TEXT'; $host_bver = ''; $host_os = ''; }
elseif (stristr($raw_ua, 'ELinks/')) { $host_browser = 'TEXT'; $host_bver = ''; $host_os = ''; }
elseif (stristr($raw_ua, 'w3m/')) { $host_browser = 'TEXT'; $host_bver = ''; $host_os = ''; }

elseif (stristr($raw_ua, 'contype')) { $host_browser = 'IE-MEDIA'; $host_bver = ''; }
elseif (stristr($raw_ua, 'NSPlayer')) { $host_browser = 'NN-MEDIA'; $host_bver = ''; }

elseif (stristr($raw_ua, 'Slurp')) { $host_browser = 'SEARCH'; $host_bver = ''; }
elseif (stristr($raw_ua, 'Fireball')) { $host_browser = 'SEARCH'; $host_bver = ''; }
elseif (stristr($raw_ua, 'Google')) { $host_browser = 'SEARCH'; $host_bver = ''; }
elseif (stristr($raw_ua, 'robot')) { $host_browser = 'SEARCH'; $host_bver = ''; }
elseif (stristr($raw_ua, 'Infoseek')) { $host_browser = 'SEARCH'; $host_bver = ''; }
elseif (stristr($raw_ua, 'Lycos')) { $host_browser = 'SEARCH'; $host_bver = ''; }
elseif (stristr($raw_ua, 'Scooter')) { $host_browser = 'SEARCH'; $host_bver = ''; }
elseif (stristr($raw_ua, 'WebCrawler')) { $host_browser = 'SEARCH'; $host_bver = ''; }
elseif (stristr($raw_ua, 'Mercator')) { $host_browser = 'SEARCH'; $host_bver = ''; }
elseif (stristr($raw_ua, 'Spider')) { $host_browser = 'SEARCH'; $host_bver = ''; }
elseif (stristr($raw_ua, 'ZyBorg/')) { $host_browser = 'SEARCH'; $host_bver = ''; }
elseif (stristr($raw_ua, 'Ask Jeeves')) { $host_browser = 'SEARCH'; $host_bver = ''; }
elseif (stristr($raw_ua, 'WebReaper')) { $host_browser = 'SEARCH'; $host_bver = ''; }
elseif (stristr($raw_ua, 'gigabaz/')) { $host_browser = 'SEARCH'; $host_bver = ''; }
elseif (stristr($raw_ua, 'WiseCrawler')) { $host_browser = 'SEARCH'; $host_bver = ''; }
elseif (stristr($raw_ua, 'Wget/')) { $host_browser = 'SEARCH'; $host_bver = ''; }
elseif (stristr($raw_ua, 'LinkWalker')) { $host_browser = 'SEARCH'; $host_bver = ''; }
elseif (stristr($raw_ua, 'psbot/')) { $host_browser = 'SEARCH'; $host_bver = ''; }
elseif (stristr($raw_ua, 'ia_archiver')) { $host_browser = 'SEARCH'; $host_bver = ''; }
elseif (stristr($raw_ua, 'Python-urllib/')) { $host_browser = 'SEARCH'; $host_bver = ''; }
elseif (stristr($raw_ua, 'Gigabot/')) { $host_browser = 'SEARCH'; $host_bver = ''; }
elseif (stristr($raw_ua, 'Firefly/')) { $host_browser = 'SEARCH'; $host_bver = ''; }

elseif (stristr($raw_ua, 'Indy Library')) { $host_browser = 'SPAMBOT'; $host_bver = ''; }

elseif (stristr($raw_ua, 'DA 4')) { $host_browser = 'DOWNLOAD'; $host_bver = ''; }
elseif (stristr($raw_ua, 'NetAnts/')) { $host_browser = 'DOWNLOAD'; $host_bver = ''; }
elseif (stristr($raw_ua, 'Mass Downloader/')) { $host_browser = 'DOWNLOAD'; $host_bver = ''; }
elseif (stristr($raw_ua, 'GetRight/')) { $host_browser = 'DOWNLOAD'; $host_bver = ''; }

elseif (stristr($raw_ua, 'PHP/')) { $host_browser = 'PHP'; $host_bver = ''; }
elseif (stristr($raw_ua, 'FrontPage')) { $host_browser = 'FRONTPAGE'; $host_bver = ''; }
else { $host_browser = '?UA'; $host_bver = ''; }

if (stristr($raw_ua, 'Windows 95')) { $host_os = 'W95'; $host_os_class = 'WIN'; }
elseif (stristr($raw_ua, 'Win95')) { $host_os = 'W95'; $host_os_class = 'WIN'; }
elseif (stristr($raw_ua, 'Windows 98')) { $host_os = 'W98'; $host_os_class = 'WIN'; }
elseif (stristr($raw_ua, 'Win98')) { $host_os = 'W95'; $host_os_class = 'WIN'; }
elseif (stristr($raw_ua, 'Windows ME')) { $host_os = 'WME'; $host_os_class = 'WIN'; }
elseif (stristr($raw_ua, 'Windows NT 4')) { $host_os = 'NT4'; $host_os_class = 'WIN'; }
elseif (stristr($raw_ua, 'Windows NT 5.0')) { $host_os = 'W2K'; $host_os_class = 'WIN'; }
elseif (stristr($raw_ua, 'Windows NT 5.1')) { $host_os = 'WXP'; $host_os_class = 'WIN'; }
elseif (stristr($raw_ua, 'WinNT')) { $host_os = 'NT'; $host_os_class = 'WIN'; }
elseif (stristr($raw_ua, 'Windows-NT')) { $host_os = 'NT'; $host_os_class = 'WIN'; }
elseif (stristr($raw_ua, 'Win')) { $host_os = 'WIN'; $host_os_class = 'WIN'; }
elseif (stristr($raw_ua, 'Linux')) { $host_os = 'LIN'; $host_os_class = 'UNIX'; }
elseif (stristr($raw_ua, 'Unix')) { $host_os = 'UNIX'; $host_os_class = 'UNIX'; }
elseif (stristr($raw_ua, 'Mac')) { $host_os = 'MAC'; $host_os_class = 'MAC'; }
elseif (stristr($raw_ua, 'SunOS')) { $host_os = 'SUN'; $host_os_class = 'UNIX'; }
elseif (stristr($raw_ua, 'OS/2')) { $host_os = 'OS2'; $host_os_class = 'OS2'; }
else { $host_os = '?OS'; $host_os_class = '?OS'; }

if (stristr($raw_ua, 'AOL ')) $host_aol = true;

#echo "$raw_ua<br />$host_browser, v.$host_bver, OS $host_os";

unset($raw_ua);

if (($host_browser == 'SEARCH') ||
    ($host_browser == 'SPAMBOT') ||
    ($host_browser == 'DOWNLOAD') ||
    ($host_browser == 'PHP') ||
    ($host_browser == 'FRONTPAGE')) $host_isbrowser = false;

?>
