<?php
// BlackBoard - PHP Internet Newsboard System
// Copyright 2003-4 by Yves Goergen
// Homepage: http://blackboard.unclassified.de
// See docs/LICENSE.txt for distribution/license details
//
// users.inc.php
// User list


// Import request variables
$adduser = ($_GET['adduser'] == 1);

$sort = $_GET['sort'];
switch ($sort)
{
	case 'id': break;
	case 'name': break;
	case 'regdate': break;
	case 'posts': break;
	default: $sort = 'posts';
}

$page = $_GET['page'];
if (!is_numeric($page) || $page < 1) $page = 1;

$team = ($_GET['team'] == 1);
$online = ($_GET['online'] == 1);
if ($team && $online) $team = false;   // allow only one of them to be true

$first = $_GET['first'];
if (strlen($first) != 1 || ($first < 'A' || $first > 'Z') && $first != '-') $first = false;

$selgroup = intval($_GET['showgroup']);   // very simple variable get here, more checks are performed where needed
$invgroup = ($_GET['invgroup'] == 1 ? 1 : 0);


$error = false;

// Add new user manually from the userlist
//
if ($_POST['action'] == 'adduser' && CheckRights('adduser'))
{
	$user = new IUser;

	$name = trim($_POST['Name']);
	$password = trim($_POST['Password']);
	$email = trim($_POST['EMail']);

	if ($name == '' || $password == '' || $email == '')
	{
		$error .= $T['err_form_not_complete_adduser'] . '<br />';
	}

	// e-mail vaild?
	if (!is_mailaddr($email))
	{
		$error .= $T['err_invalid_email'] . '<br />';
	}

	// username available?
	if ($user->FindByName($name))
	{
		$error .= $T['err_username_assigned'] . '<br />';
	}

	if (!$error)
	{
		$user = new IUser;
		if (!$user->Add($_POST['Name'], $_POST['Password'], $_POST['EMail']))
			$error .= $T['err_user_not_created'] . ' (' . t2h($user->db->LastError()) . ')<br />';
		else
			addlog('add_user ' . $_POST['Name']);
		unset($user);
	}
}


// Add User <form>
//
// show_cnt = number of additional columns
//
function AddUser($show_cnt)
{
	global $ME, $TABLE, $T, $IMG;

	$cols = $show_cnt;
	if (!$show_cnt) $cols++;

	echo '<form action="' . $ME . sid(2) . '" method="post"><tr valign="top">';

	echo '<td class="list_edituser" colspan="' . $cols . '">';
	echo '<input type="hidden" name="action" value="adduser" />';

	echo '<table cellspacing="' . $TABLE['user']['space'] . '" cellpadding="' . $TABLE['user']['pad'] . '" border="' . $TABLE['user']['border'] . '">';
	echo '<tr><td>' . $T['new_username'] . ':&nbsp;</td><td><input type="text" class="text" name="Name" size="30" maxlength="40" /></td></tr>';
	echo '<tr><td>' . $T['password'] . ':&nbsp;</td><td><input type="password" class="text" name="Password" size="20" maxlength="40" /></td></tr>';
	echo '<tr><td>' . $T['email_address'] . ':</td><td><input type="text" class="text" name="EMail" size="30" maxlength="100" /></td></tr>';
	echo '</table>';

	echo '</td>';

	echo '<td class="list_edituser" align="right">';
	echo '<input type="submit" class="button" value="' . $T['save'] . '" /><br />';
	echo '<img ' . $IMG['empty'] . ' width="1" height="18" /><a href="' . $ME . sid(2) . '">' . $T['cancel'] . '</a>';
	echo '</td>';
	echo '</tr></form>';
}

// List users
//
// sort = Sort criterium (see top of this file)
// adduser = 0,1: Show Add User form
// page = 1+: Page of list
// first = filter by first char of name
//
function ListUsers($sort, $adduser, $page, $first)
{
	global $MODULE, $ME, $IMG, $TABLE, $db, $T, $invgroup;

	$users_per_page = rc('users_per_page');

	if ($first == '-') $where = "NOT (LEFT(Name,1) BETWEEN 'A' AND 'Z') AND NOT (LEFT(Name,1) BETWEEN 'a' AND 'z')";
	elseif ($first) $where = 'Name LIKE "' . $first . '%"';
	else $where = '';

	if (CheckRights('setusergroups'))
	{
		$groupnames = GetGroupNames(false);
		$selgroup = intval($_GET['showgroup']);
		if ($selgroup > 0 && !array_key_exists($selgroup, $groupnames)) $selgroup = 0;

		echo '<p><form name="form" action="' . $ME . '" method="get">';
		echo sid(4);
		echo '<input type="hidden" name="req" value="users" />';
		echo '<input type="hidden" name="sort" value="' . $sort . '" />';
		echo '<input type="hidden" name="first" value="' . $first . '" />';
		echo $T['show_usergroup'] . ': <select name="showgroup" onchange="document.form.submit();">';
		echo '<option value="0"' . (!$selgroup ? ' selected="selected"' : '') . '>(' . $T['all'] . ')</option>';
		echo '<option value="-1"' . ($selgroup == -1 ? ' selected="selected"' : '') . '>(' . $T['none'] . ')</option>';
		foreach ($groupnames as $id => $name)
		{
			echo '<option value="' . $id . '"' . ($selgroup == $id ? ' selected="selected"' : '') . '>' . $groupnames[$id] . '</option>';
		}
		echo '</select> &nbsp; ';
		echo '<input type="checkbox" class="radio" name="invgroup" id="InvGroup" value="1"' . ($invgroup && $selgroup ? ' checked="checked"' : '') . ' onclick="document.form.submit();" /><label for="InvGroup">' . $T['invert_selection'] . '</label></form></p>';
	}
	else
	{
		$selgroup = 0;
	}
	if ($selgroup) $selgroup_str = '&amp;showgroup=' . $selgroup; else $selgroup_str = '';
	if ($invgroup) $selgroup_str .= '&amp;invgroup=1';

	$user = new IUser;

	# ---------- PAGE SELECTION ----------
	$user_count = $user->CountWithGroup($where, $selgroup, $invgroup);
	if (!$user_count && !$adduser)
	{
		echo '<p class="list_user_head_0" align="center">' . $T['no_users_found'] . '</p>';
		return false;
	}

	if (!$users_per_page)
		$page_count = 1;
	elseif ($user_count > $users_per_page)
		$page_count = ceil($user_count / $users_per_page);
	else
		$page_count = 1;

	if ($page > $page_count) $page = $page_count;
	if ($page == -1) $page = $page_count;

	if ($page_count > 1)
	{
		$boundary = 3;   // pages to show at the boundaries (begin/end)
		$middle = 2;     // pages to show around current page in the middle

		$page_str = '<td class="actionbar_l"><img ' . $IMG['page'] . ' /> ' . $T['page'] . ':&nbsp;';
		if ($page > 1)
			$page_str .= '<a href="' . $ME . PD . 'sort=' . $sort . '&amp;first=' . $first . '&amp;page=' . ($page - 1) . $selgroup_str . sid() . '">&nbsp;&#xAB;&nbsp;' . $T['prev_page2'] . '&nbsp;&nbsp;</a>';
		$state = 0;
		for ($n = 1; $n <= $page_count; $n++)
		{
			// show pages if they were the only one replaced by '...'
			$med_left = ($n == $boundary + 1 && $n == $page - $middle - 1);
			$med_right = ($n == $page + $middle + 1 && $n == $page_count - ($boundary - 1) - 1);

			if ($n <= $boundary || $med_left ||  abs($page - $n) <= $middle || $med_right || $n > $page_count - $boundary)
			{
				if ($n == $page)
					$page_str .= '&nbsp;<b>' . $n . '</b>&nbsp;';
				else
					$page_str .= '<a href="' . $ME . PD . 'sort=' . $sort . '&amp;first=' . $first . '&amp;page=' . $n . $selgroup_str . sid() . '">&nbsp;' . $n . '&nbsp;</a>';
			}
			else
			{
				if ($n < $page && $state < 1) { $page_str .= '...'; $state = 1; }
				if ($n > $page && $state < 2) { $page_str .= '...'; $state = 2; }
			}
		}
		if ($page < $page_count)
			$page_str .= '<a href="' . $ME . PD . 'sort=' . $sort . '&amp;first=' . $first . '&amp;page=' . ($page + 1) . $selgroup_str . sid() . '">&nbsp;&nbsp;' . $T['next_page2'] . '&nbsp;&#xBB;&nbsp;</a>';
		$page_str .= '</td>';
	}

	# ---------- USER ACTIONS ----------
	$x = '';
	$order = 'Name';
	switch ($sort)
	{
		case 'name':
			$order = 'Name';
			break;
		case 'id':
			$order = 'ID';
			break;
		case 'regdate':
			$order = 'RegDate';
			break;
		case 'posts':
			$order = 'posts DESC, RegDate';
			break;
	}
	$x .= $user_count . ' ' . $T['users'] . ' &nbsp; <img ' . $IMG['sort'] . ' /> ' . $T['sorting'] . ': ';

	if ($sort == 'name')
		$x .= $T['name'];
	else
		$x .= '<a href="' . $ME . PD . 'sort=name&amp;first=' . $first . $selgroup_str . sid() . '">' . $T['name'] . '</a>';

	if ($sort == 'regdate')
		$x .= ' | ' . $T['regdate'];
	else
		$x .= ' | <a href="' . $ME . PD . 'sort=regdate&amp;first=' . $first . $selgroup_str . sid() . '">' . $T['regdate'] . '</a>';

	if ($sort == 'posts')
		$x .= ' | ' . $T['posts'];
	else
		$x .= ' | <a href="' . $ME . PD . 'sort=posts&amp;first=' . $first . $selgroup_str . sid() . '">' . $T['posts'] . '</a>';

	if ($sort == 'id')
		$x .= ' | ID';


	if (CheckRights('adduser'))
	{
		if ($x != '') $x .= ' &nbsp; &nbsp; ';
		$x .= '<a href="' . $ME . PD . 'adduser=1&amp;first=' . $first . $selgroup_str . sid() . '"><img ' . $IMG['add'] . ' /> ' . $T['new_user'] . '</a>';
	}

	# ---------- COMPOSITION OF PAGES AND ACTIONS ----------
	if ($page_count > 1 || $x != '')
	{
		$actionbar = '<table cellspacing="0" cellpadding="0" width="100%" class="actiontable">';
		$actionbar .= '<tr>';
		if ($page_count > 1) $actionbar .= $page_str;
		if ($x != '') $actionbar .= '<td class="actionbar_r" align="right">' . $x . '</td>';
		$actionbar .= '</tr></table>';
	}
	else
		$actionbar = '';

	echo $actionbar;

	$show_regdate = rc('ulist_regdate');
	$show_contact = rc('ulist_contact');
	$show_location = rc('ulist_location');
	$show_posts = rc('ulist_posts');
	$show_lastpost = rc('ulist_lastpost');
	$show_any = $show_regdate || $show_contact || $show_location || $show_posts || $show_lastpost;

	$show_cnt = 0;
	if ($show_regdate) $show_cnt++;
	if ($show_contact) $show_cnt += 7;
	if ($show_location) $show_cnt++;
	if ($show_posts) $show_cnt++;
	if ($show_lastpost) $show_cnt++;

	if ($show_posts) CountUserPosts();

	echo '<table cellspacing="' . $TABLE['user']['space'] . '" cellpadding="' . $TABLE['user']['pad'] . '" border="' . $TABLE['user']['border'] . '" width="100%">';
	echo '<colgroup>';
	echo '<col' . ($TABLE['user']['col_name'] ? ' width="' . $TABLE['user']['col_name'] . '"' : '') . ' />';
	if ($show_regdate) echo '<col' . ($TABLE['user']['col_regdate'] ? ' width="' . $TABLE['user']['col_regdate'] . '"' : '') . ' />';
	if ($show_contact)
	{
		echo '<col />';
		echo '<col />';
		echo '<col />';
		echo '<col />';
		echo '<col />';
		echo '<col />';
		echo '<col />';
	}
	if ($show_location) echo '<col />';
	if ($show_posts) echo '<col' . ($TABLE['user']['col_posts'] ? ' width="' . $TABLE['user']['col_posts'] . '"' : '') . ' align="center" />';
	if ($show_lastpost) echo '<col' . ($TABLE['user']['col_lastpost'] ? ' width="' . $TABLE['user']['col_lastpost'] . '"' : '') . ' />';
	if (!$show_any) echo '<col width="20%" />';
	echo '</colgroup>';

	$rightmost = 'lastpost';
	if (!$show_lastpost && $rightmost == 'lastpost') $rightmost = 'posts';
	if (!$show_posts && $rightmost == 'posts') $rightmost = 'location';
	if (!$show_location && $rightmost == 'location') $rightmost = 'contact';
	if (!$show_contact && $rightmost == 'contact') $rightmost = 'regdate';
	if (!$show_regdate && $rightmost == 'regdate') $rightmost = '';

	echo '<tr>';
	echo '<td class="list_user_head_left"><nobr>' . $T['username'] . ($sort == 'name' ? ' <img ' . $IMG['up'] . ' />' : '') . '</nobr></td>';
	if ($show_regdate) echo '<td class="list_user_head_' . ($rightmost == 'regdate' ? 'right' : '0') . '"><nobr>' . $T['registered_on'] . ($sort == 'regdate' ? ' <img ' . $IMG['up'] . ' />' : '') . '</nobr></td>';
	if ($show_contact) echo '<td class="list_user_head_' . ($rightmost == 'contact' ? 'right' : '0') . '" colspan="7"><nobr>' . $T['contact'] . '</nobr></td>';
	if ($show_location) echo '<td class="list_user_head_' . ($rightmost == 'location' ? 'right' : '0') . '"><nobr>' . $T['location'] . '</nobr></td>';
	if ($show_posts) echo '<td class="list_user_head_' . ($rightmost == 'posts' ? 'right' : '0') . '" align="center"><nobr>' . $T['posts'] . ($sort == 'posts' ? ' <img ' . $IMG['down'] . ' />' : '') . '</nobr></td>';
	if ($show_lastpost) echo '<td class="list_user_head_' . ($rightmost == 'lastpost' ? 'right' : '0') . '"><nobr>' . $T['last_post'] . '</nobr></td>';
	if (!$show_any) echo '<td class="list_user_head_right" width="20%">&nbsp;</td>';
	echo '</tr>';

	if ($users_per_page)
		$limit = (($page - 1) * $users_per_page) . ',' . $users_per_page;
	else
		$limit = '';

	if ($first) $where_sql = 'WHERE ' . $where . ' ';
	else $where_sql = '';

	$pre = $db->tblprefix;
	if ($selgroup == -1)
	{
		$group_join = "LEFT JOIN {$pre}GroupMembers ON {$pre}Users.ID = {$pre}GroupMembers.User ";
		if ($where_sql == '') $where_sql .= 'WHERE '; else $where_sql .= 'AND ';
		$where_sql .= "{$pre}GroupMembers.Group IS " . ($invgroup ? 'NOT ' : '') . 'NULL ';
	}
	elseif ($selgroup > 0 && !$invgroup)
		$group_join = "JOIN {$pre}GroupMembers ON {$pre}Users.ID = {$pre}GroupMembers.User " .
			"AND {$pre}GroupMembers.Group = $selgroup ";
	elseif ($selgroup > 0 && $invgroup)
	{
		$group_join = "LEFT JOIN {$pre}GroupMembers ON {$pre}Users.ID = {$pre}GroupMembers.User " .
			"AND {$pre}GroupMembers.Group = $selgroup ";
		$where_sql .= ($where_sql ? ' AND ' : 'WHERE ') . "{$pre}GroupMembers.Group IS NULL ";
	}
	else
		$group_join = '';

	$db->Exec("SELECT {$pre}Users.*, COUNT({$pre}Posts.ID) AS posts " .
		"FROM {$pre}Users " .
			$group_join .
			"LEFT JOIN {$pre}Posts ON {$pre}Users.ID = {$pre}Posts.User " .
		$where_sql .
		"GROUP BY {$pre}Users.ID " .
		"ORDER BY $order " .
		"LIMIT $limit");
	$users = array();
	while ($record = $db->GetRecord())
	{
		array_push($users, $record);
	}

	$n = 0;
	foreach ($users as $user_rec)
	{
		$user->LoadFromRecord($user_rec);

		echo '<tr>';

		echo '<td class="list_user">';
		echo GetUserOnlineImg($user->GetOnline()) . ' ';
		echo MakeUserLink($user->GetID(), $user->GetName(), true);
		if ($user->GetGender() != '')
			echo ' ' . GetGenderImage($user->GetGender());
		echo GetUserStatusText($user->GetID(), ' <small>(%s)</small>', true, true);
		if (CheckRights('editprofile'))
			echo '&nbsp; <a href="' . $MODULE['cp'] . PD . 'id=' . $user->GetID() . '&amp;item=1' . sid() . '"><img ' . $IMG['edit'] . ' title="' . $T['change'] . '" /></a>';
		echo '</td>';

		if ($show_regdate)
		{
			echo '<td class="list_user"><nobr>';
			echo FormatTime($user->GetRegDate(), 1);
			echo '</nobr></td>';
		}

		if ($show_contact)
		{
			echo '<td class="list_user">';
			if ($user->GetEMail() != '')
				echo '<nobr><a href="' . $MODULE['cp'] . PD . 'id=' . $user->GetID() . '&amp;action=email' . sid() . '"><img ' . $IMG['email'] . ' title="' . $T['e_mail'] . '" /></a></nobr>';
			else
				echo '&nbsp;';
			echo '</td>';

			echo '<td class="list_user">';
			if ($user->GetRealJabber() != '')
				echo '<img ' . $IMG['jabber'] . ' title="' . $T['jabber'] . ': ' . maskmail(htmlquote($user->GetRealJabber())) . '" />';
			else
				echo '&nbsp;';
			echo '</td>';

			echo '<td class="list_user">';
			if ($user->GetICQ() != '')
				echo '<a href="http://web.icq.com/wwp/' . urlencode($user->GetICQ()) . '" target="_blank"><img ' . $IMG['icq'] . ' title="' . $T['icq'] . ': ' . htmlquote($user->GetICQ()) . '" /></a>';
			else
				echo '&nbsp;';
			echo '</td>';

			echo '<td class="list_user">';
			if ($user->GetAIM() != '')
				echo '<img ' . $IMG['aim'] . ' title="' . $T['aim'] . ': ' . htmlquote($user->GetAIM()) . '" />';
			else
				echo '&nbsp;';
			echo '</td>';

			echo '<td class="list_user">';
			if ($user->GetYIM() != '')
				echo '<img ' . $IMG['yim'] . ' title="' . $T['yim'] . ': ' . htmlquote($user->GetYIM()) . '" />';
			else
				echo '&nbsp;';
			echo '</td>';

			echo '<td class="list_user">';
			if ($user->GetMSN() != '')
				echo '<img ' . $IMG['msn'] . ' title="' . $T['msn'] . ': ' . maskmail(htmlquote($user->GetMSN())) . '" />';
			else
				echo '&nbsp;';
			echo '</td>';

			echo '<td class="list_user">';
			if ($user->GetHomepage() != '')
				echo '<nobr><a href="' . $MODULE['derefer'] . PD . 'url=' . urlencode($user->GetHomepage()) . '" target="_blank"><img ' . $IMG['homepage'] . ' title="' . $T['homepage'] . '" /></a></nobr>';
			else
				echo '&nbsp;';
			echo '</td>';
		}

		if ($show_location)
		{
			echo '<td class="list_user">';
			if (rc('location_link'))
				echo '<a href="' . $MODULE['derefer'] . PD . 'url=' . urlencode(str_replace('%s', urlencode($user->GetLocation()), rc('location_link'))) . '" target="_blank">';
			echo t2h($user->GetLocation());
			if (rc('location_link'))
				echo '</a>';
			echo '&nbsp;</td>';
		}

		if ($show_posts)
		{
			echo '<td class="list_user" align="center">';
			$posts = GetPostsByUser($user->GetID());
			if ($posts > 0)
				echo '<a href="' . $MODULE['search'] . PD . 'nodef=1&amp;Query=!' . $user->GetID() . '&amp;ResultView=2&amp;InUser=1&amp;Sort=1' . sid() . '">';
			echo $posts;
			if ($posts > 0)
				echo '</a>';
			echo '</td>';
		}

		if ($show_lastpost)
		{
			echo '<td class="list_user">';
			$record = GetLastPost('User=' . $user->GetID());
			if ($record)
			{
				echo '<nobr>' . MakePostLink($record) . ' ';
				echo FriendlyDate($record['Date'], 1, 3) . '</nobr>';
			}
			else
			{
				echo '&nbsp;';
			}
			echo '</td>';
		}

		if (!$show_any) echo '<td class="list_user">&nbsp;</td>';

		echo '</tr>';

		$n++;
	}  // foreach $users

	if ($adduser && CheckRights('adduser')) AddUser($show_cnt);

	echo '</table>';

	if ($n >= 15) echo $actionbar;
}


// Show Op Team
//
function ShowTeam()
{
	function ListUsersByGroup($gid, $gname)
	{
		global $IMG, $TABLE, $T, $MODULE;

		$members = GetGroupMembers($gid);
		if (!$members) return false;
		$mstr = join(',', $members);

		echo '<p><table cellspacing="' . $TABLE['user']['space'] . '" cellpadding="' . $TABLE['user']['pad'] . '" border="' . $TABLE['user']['border'] . '" width="100%">';
		echo '<colgroup>';
		echo '<col width="' . $TABLE['user']['col_team_avatar'] . '" align="center" />';
		echo '<col />';
		echo '<col width="30" />';
		echo '</colgroup>';

		echo '<tr><td class="list_user_head_left" align="left" colspan="2">' . t2h($gname) . '</td>';
		echo '<td class="list_user_head_right">&nbsp;</td></tr>';

		$user = new IUser;
		if ($user->GetList('ID IN (' . $mstr . ')', 'Name')) do
		{
			echo '<tr>';

			echo '<td class="list_user">';
			if ($user->GetAvatar() != '' && rc('avatars_enabled'))
				echo '<img src="' . avatar_url($user) . '"' . avatar_size($user, false) . ' alt="' . $T['avatar'] . '" />';
			echo '&nbsp;</td>';

			echo '<td class="list_user">';
			echo GetUserOnlineImg($user->GetOnline()) . ' ';
			echo MakeUserLink($user->GetID(), $user->GetName(), true);
			echo '<br /><br /><small>' . $T['member'] . ' ' . FriendlyDate($user->GetRegDate(), 2, 1, true, 1) . '</small><br />';

			if ($user->GetEMail() != '')
				echo MakeUserLink($user->GetID(), '<img ' . $IMG['email'] . ' title="' . $T['e_mail'] . '" />', false, true, false) . ' &nbsp; ';

			if ($user->GetRealJabber() != '')
				echo '<img ' . $IMG['jabber'] . ' title="' . $T['jabber'] . ': ' . maskmail(htmlquote($user->GetRealJabber())) . '" /> &nbsp; ';

			if ($user->GetICQ() != '')
				echo '<a href="http://web.icq.com/wwp/' . urlencode($user->GetICQ()) . '" target="_blank"><img ' . $IMG['icq'] . ' title="' . $T['icq'] . ': ' . htmlquote($user->GetICQ()) . '" /></a> &nbsp; ';

			if ($user->GetAIM() != '')
				echo '<img ' . $IMG['aim'] . ' title="' . $T['aim'] . ': ' . htmlquote($user->GetAIM()) . '" /> &nbsp; ';

			if ($user->GetYIM() != '')
				echo '<img ' . $IMG['yim'] . ' title="' . $T['yim'] . ': ' . htmlquote($user->GetYIM()) . '" /> &nbsp; ';

			if ($user->GetMSN() != '')
				echo '<img ' . $IMG['msn'] . ' title="' . $T['msn'] . ': ' . maskmail(htmlquote($user->GetMSN())) . '" /> &nbsp; ';

			if ($user->GetHomepage() != '')
				echo '<a href="' . $MODULE['derefer'] . PD . 'url=' . urlencode($user->GetHomepage()) . '" target="_blank"><img ' . $IMG['homepage'] . ' title="' . $T['homepage'] . '" /></a> &nbsp; ';
			echo '<br /><br />';

			echo $T['location'] . ': ' . $user->GetLocation() . '<br />';

			echo $T['posts'] . ': ';
			$posts = GetPostsByUser($user->GetID());
			if ($posts > 0)
				echo '<a href="' . $MODULE['search'] . PD . 'nodef=1&amp;Query=!' . $user->GetID() . '&amp;ResultView=2&amp;InUser=1&amp;Sort=1' . sid() . '">';
			echo $posts;
			if ($posts > 0)
				echo '</a>';
			echo ' &nbsp; ';

			$record = GetLastPost('User=' . $user->GetID());
			if ($record)
			{
				echo '<small>(';
				echo MakePostLink($record) . ' ';
				echo FriendlyDate($record['Date'], 1, 3);
				echo ')</small>';
			}
			echo '</td>';

			echo '<td class="list_user">&nbsp;</td>';

			echo '</tr>';
		}
		while ($user->GetNext());

		echo '</table></p>';
	}

	global $ME, $IMG, $TABLE, $T, $MODULE;

	CountUserPosts();
	$groupnames = GetGroupNames(true);

	$selgroup = intval($_GET['showgroup']);
	if (!array_key_exists($selgroup, $groupnames) || $selgroup <= 3) $selgroup = 0;

	if (CheckRights('showuserlist') && sizeof($groupnames) > 2)
	{
		echo '<p><form name="form" action="' . $ME . PD . sid(2) . '" method="get">';
		echo sid(4);
		echo '<input type="hidden" name="req" value="users" />';
		echo '<input type="hidden" name="team" value="1" />';
		echo $T['show_usergroup'] . ': <select name="showgroup" onchange="document.form.submit();">';
		echo '<option value="0"' . (!$selgroup ? ' selected="selected"' : '') . '>' . $groupnames[3] . ' ' . $T['and'] . ' ' . $groupnames[2] . '</option>';
		foreach ($groupnames as $id => $name)
		{
			if ($id > 3)
				echo '<option value="' . $id . '"' . ($selgroup == $id ? ' selected="selected"' : '') . '>' . $groupnames[$id] . '</option>';
		}
		echo '</select></form></p>';
	}
	else
	{
		$selgroup = 0;   // Only display admin/global_mods groups, if user has no rights to view the userlist, i.e. a guest
	}

	if (!$selgroup)
	{
		ListUsersByGroup(3, $groupnames[3]);
		ListUsersByGroup(2, $groupnames[2]);
	}
	else
	{
		ListUsersByGroup($selgroup, $groupnames[$selgroup]);
	}

}


// List online users
//
function ListOnlineUsers()
{
	global $MODULE, $ME, $IMG, $TABLE, $db, $T;

	if (!rc('enable_trace_users'))
	{
		echo '<p class="error">' . $T['err_trace_users_disabled'] . '</p>';
		return;
	}

	$user = new IUser;
	$forum = new IForum;

	echo '<table cellspacing="' . $TABLE['user']['space'] . '" cellpadding="' . $TABLE['user']['pad'] . '" border="' . $TABLE['user']['border'] . '" width="100%">';
	echo '<colgroup>';
	echo '<col width="' . $TABLE['user']['col_online_name'] . '" />';
	echo '<col />';
	echo '</colgroup>';

	echo '<tr>';
	echo '<td class="list_user_head_left">' . $T['username'] . '</td>';
	echo '<td class="list_user_head_right">' . $T['last_activity2'] . '</td>';
	echo '</tr>';

	# update this time interval in lib/user.lib.php, GetOnline(), too
	# here, it's a bit greater to see who was there some more time ago
	$users = $user->GetListArray('LastActivity >= ' . (time() - 10 * 60), 'LastActivity DESC');
	if (is_array($users))
		$cu = sizeof($users);   // count users
	else
		$cu = 0;

	$guests = $db->FastQueryArray('Guests', '*', 'LastActivity >= ' . (time() - 10 * 60), 'LastActivity DESC');
	if (is_array($guests))
		$cg = sizeof($guests);   // count geusts
	else
		$cg = 0;

	// pu=pos users, pg=pos guests
	for ($pu = 0, $pg = 0; $pu < $cu || $pg < $cg; )
	{
		echo '<tr valign="top">';

		echo '<td class="list_user">';

		// who comes next, user or guest?
		//
		$user->Load($users[$pu]);
		if ($user->GetLastActivity() >= $guests[$pg]['LastActivity'])
		{
			// user
			echo GetUserOnlineImg($user->GetOnline()) . ' ';
			echo MakeUserLink($user->GetID(), $user->GetName(), true);
			if ($user->GetGender() != '')
				echo ' ' . GetGenderImage($user->GetGender());
			echo GetUserStatusText($user->GetID(), ' <small>(%s)</small>', true, true);

			$lastactivity = $user->GetLastActivity();
			$lastforum = $user->GetLastForum();

			$pu++;
		}
		else
		{
			// guest
			echo strtoupper(str_limit($guests[$pg]['Session'], 6));
			echo GetUserStatusText(0, ' <small>(%s)</small>', false, true);

			$lastactivity = $guests[$pg]['LastActivity'];
			$lastforum = $guests[$pg]['LastForum'];

			$pg++;
		}
		echo '</td>';

		echo '<td class="list_user">';
		if ($lastforum == 0)
		{
			echo $T['overview'];
		}
		elseif ($lastforum > 0)
		{
			if ($forum->Load($lastforum))
			{
				echo '<a href="' . $MODULE['main'] . PD . 'id=' . $forum->GetID() . '">' . t2h($forum->GetName()) . '</a>';
			}
			else
			{
				echo $T['forum'] . ' ' . $lastforum;
			}
		}
		else
		{
			if ($lastforum == ULF_HELP) echo $T['help'];
			elseif ($lastforum == ULF_CONFIG) echo $T['config'];
			elseif ($lastforum == ULF_PROFILE) echo $T['user_profile'];
			elseif ($lastforum == ULF_SEARCH) echo $T['search'];
			elseif ($lastforum == ULF_STAT) echo $T['statistics'];
			elseif ($lastforum == ULF_USERS) echo $T['userlist'];
			else echo '[' . $lastforum . ']';
		}

		$secs = time() - $lastactivity;
		$mins = 0;
		while ($secs >= 60)
		{
			$mins++;
			$secs -= 60;
		}
		if ($secs > 1) $secs = $secs . ' ' . $T['seconds'];
		elseif ($secs == 1) $secs = $secs . ' ' . $T['second'];
		else $secs = '';
		if ($mins > 1) $mins = $mins . ' ' . $T['minutes'] . ' ';
		elseif ($mins == 1) $mins = $mins . ' ' . $T['minute'] . ' ';
		else $mins = '';
		if ($secs == '' && $mins == '') $secs = '0 ' . $T['seconds'];
		echo ' &nbsp; <small>' . str_replace('%s', $mins . $secs, $T['x_ago']) . '</small>';

		echo '</td>';
		echo '</tr>';
	}

	echo '</table>';

	echo '<script type="text/javascript">' /*. '<![CDATA['*/;
	#echo 'window.setTimeout("location.reload();", 10000);';   // this causes all images to be reloaded, too :(
	echo 'window.setTimeout("location.href=\"' . $MODULE['users'] . h2t(PD) . 'online=1' . sid() . '\";", 10000);';
	echo /*']]>' .*/ '</script>';
}


BeginHTML($T['userlist']);

if ($error)
{
	echo '<p class="error">' . $error . '</p>';
	errorlog($error);
}

if ($LoginUserID) $LoginUser->SetLastActivity(ULF_USERS);
else SetGuestLastForum(ULF_USERS);

if (!CheckRights('showuserlist'))
{
	addlog('show_team');
	ShowTeam();
}
else
{
	if ($selgroup) $selgroup_str = '&amp;showgroup=' . $selgroup; else $selgroup_str = '';
	if ($invgroup) $selgroup_str .= '&amp;invgroup=1';

	echo '<div class="path">';
	if (!$team && !$online)
		echo $T['userlist'];
	else
		echo '<a href="' . $MODULE['users'] . sid(2) . '">' . $T['userlist'] . '</a>';
	if ($team)
		echo ' | ' . $T['op_team'];
	else
		echo ' | <a href="' . $MODULE['users'] . PD . 'team=1' . sid() . '">' . $T['op_team'] . '</a>';
	if (rc('enable_trace_users'))
	{
		if ($online)
			echo ' | ' . $T['online_users'];
		else
			echo ' | <a href="' . $MODULE['users'] . PD . 'online=1' . sid() . '">' . $T['online_users'] . '</a>';
	}

	if (!$team && !$online)
	{
		echo ' &nbsp; &nbsp; ' . $T['filter'] . ':&nbsp;';

		// Filter by 1st character
		for ($a = ord('A'); $a <= ord('Z'); $a++)
		{
			if ($first == chr($a))
				echo '&nbsp;' . chr($a) . '&nbsp;';
			else
				echo '<a href="' . $ME . PD . 'sort=' . $sort . '&amp;first=' . chr($a) . $selgroup_str . sid() . '">&nbsp;' . chr($a) . '&nbsp;</a>';
		}
		if ($first == '-')
			echo '&nbsp;?&nbsp;';
		else
			echo '<a href="' . $ME . PD . 'sort=' . $sort . '&amp;first=-' . $selgroup_str . sid() . '">&nbsp;?&nbsp;</a>';
		echo '<a href="' . $ME . PD . 'sort=' . $sort . '&amp;first=' . $selgroup_str . sid() . '">&nbsp;' . $T['all'] . '&nbsp;</a>';
	}
	echo '</div>';

	if ($team)
	{
		addlog('show_team');
		ShowTeam();
	}
	elseif ($online)
	{
		addlog('show_online_users');
		if (!CheckRights('showonlineusers'))
		{
			errorlog('Access denied');
			echo '<p class="error">' . $T['err_access_denied'] . '</p>';
		}
		else
		{
			ListOnlineUsers();
		}
	}
	else
	{
		addlog('show_users by ' . $sort . ' page ' . $page . ' first ' . $first);
		ListUsers($sort, $adduser, $page, $first);
	}
}

UpdateStat('PageHits', 1);

EndHTML();
?>
