<?php
// BlackBoard - PHP Internet Newsboard System
// Copyright 2003-4 by Yves Goergen
// Homepage: http://blackboard.unclassified.de
// See docs/LICENSE.txt for distribution/license details
//
// import_phpbb2.php
// Database import module
//
// TYPE: phpBB 2.0.x
// The TYPE: description will be used to list this module in the installation

// See http://phpbb.de/doku/doku2.php for phpBB database specs

// Disable this file in productive environment!
if (file_exists('lock.conf')) exit();

// Import request variables
$step = intval($_REQUEST['step']);
if (!$step) $step = 1;

$INSTALLING = true;
if (!defined('PUBLIC_LIB')) require_once('bb_lib/public.lib.php');
$ME = 'import_phpbb2.php';

require_once($libpath . 'common.lib.php');
require($libpath . 'lang/' . $LANG . '_more.php');

@set_time_limit(0);


//  convert html font sizes to pixel sizes (px)
//
function transl_bbc($txt, $smilies = true)
{
	// remove all those funny numbers from the BBCode tags

	#$txt = preg_replace('/(\[\/?(?:b|i|u|code|img|list|\*)):[^\]]+\]/i', '$1]', $txt);
	$txt = preg_replace('/(\[\/?(?:b|i|u|code|img|color|size|list|\*)(?:=[^:]*)?):[^\]]+\]/i', '$1]', $txt);
	$txt = preg_replace('/(\[\/?(?:quote)):[^\]=]+((?:=[^\]]*)?\])/i', '$1$2', $txt);

	$txt = preg_replace('/\[email=/i', '[mail=', $txt);
	$txt = preg_replace('/\[email\]/i', '[mail]', $txt);
	$txt = preg_replace('/\[\/email\]/i', '[/mail]', $txt);

	if ($smilies)

	{
		$txt = str_replace('&amp;', '&', $txt);
		$txt = str_replace('&lt;', '<', $txt);
		$txt = str_replace('&gt;', '>', $txt);
		$txt = str_replace('&nbsp;', ' ', $txt);
		$txt = str_replace('&nbsp', ' ', $txt);

		$txt = str_replace(' :D ', ' :-D ', $txt);
		$txt = str_replace(' :oops: ', ' :red: ', $txt);
		$txt = str_replace(' 8) ', ' :cool: ', $txt);
		$txt = str_replace(' :cry: ', ' :\'( ', $txt);
		$txt = str_replace(' :shock: ', ' 8-( ', $txt);
		$txt = str_replace(' :? ', ' 8-( ', $txt);
		$txt = str_replace(' :roll: ', ' :rolleyes: ', $txt);
		$txt = str_replace(' :wink: ', ' ;-) ', $txt);
		$txt = str_replace(' :| ', ' :-/ ', $txt);
		$txt = str_replace(' :P ', ' :-p ', $txt);
	}

	return $txt;
}

function transl_lang($lang)
{
	switch ($lang)
	{
		case 'german': return 'de';
	}
	return '';
}

function group_to_status($group)
{
	// you may need to change this to your group definitions (see groups table)
	//
	switch ($group)
	{
		case 2: return 3;   // admins -> admin
	}
	return 1;
}



if ($step == 1)
{
	BeginHTML($T['installation']);

	echo '<form action="' . $ME . '?step=2' . sid() . '" method="post">';
	echo '<p>Please enter the database name and table prefix of the phpBB\'s tables. This database must be located on the primary database server and be accessible with the same username and password.</p>';

	echo '<p><table>';
	echo '<tr><td>' . $T['db_name'] . ':</td><td><input type="text" class="text" name="dbname" value="' . htmlquote($db->dbname) . '" size="20" /></td></tr>';
	echo '<tr><td>' . $T['db_prefix'] . ':</td><td><input type="text" class="text" name="tblprefix" value="phpbb_" size="20" /> (Example: for table names like "phpbb_posts", enter "phpbb_")</td></tr>';
	echo '<tr><td>Path to avatar files:</td><td><input type="text" class="text" name="avpath" value="<phpbb_root>/images/avatars" size="40" /></td></tr>';
	echo '</table></p>';

	echo '<p><b>Note:</b> The import process is split up into several steps that are linked with HTML forwards. Each step may take a considerable amount of time. Please don\'t stop the browser, reload the page or click on any of the links as long as the page is still loading or the installation will fail. (You can restart the entire thing again then.)</p>';

	echo '<p><input type="submit" class="button" value="' . $T['inst_continue'] . '" /></p>';
	echo '</form>';

	EndHTML();
}

// Save form variables from step 1 into session variables to keep them for later steps
if ($step == 2)
{
	$_SESSION['import_dbname'] = $_REQUEST['dbname'];
	$_SESSION['import_tblprefix'] = $_REQUEST['tblprefix'];
	$av_in_path = $_REQUEST['avpath'];   // path to current avatar files (with "/")
	if (substr($av_in_path, strlen($av_in_path) - 1) != '/') $av_in_path .= '/';
	$_SESSION['import_avpath'] = $av_in_path;
}

// Initialisation for all operative steps
if ($step >= 2)
{
	// Open source database
	$db0 = new IDatabase;
	$db0->server = $db->server;
	$db0->user = $db->user;
	$db0->password = $db->password;
	$db0->dbname = $_SESSION['import_dbname'];
	$db0->tblprefix = $_SESSION['import_tblprefix'];
	$db0->Open() or die('source database open error: ' . t2h($db0->LastError()));

	$av_in_path = $_SESSION['import_avpath'];   // path to current avatar files (with "/")
}

if ($step == 2)
{
	// First we have to create all necessary tables.

	// Keep this in sync with the install.php main installer!
	// DO NOT ADD ANY RECORDS HERE (except for some ACL things),
	// because this will lead to duplicate key errors!

	$db->RemoveTable('Forums') or die('remove error: ' . $db->LastError());
	$db->CreateTable('Forums',
					 '`ID` int unsigned not null, ' .             # ID
					 '`Sort` int not null, ' .                    # Order of display
					 '`Parent` int unsigned not null, ' .         # Parent forum (may be category)
					 '`Name` varchar(100) not null, ' .           # Display name
					 '`Flags` int not null, ' .                   # Category/WebLink
					 '`Description` text not null, ' .            # Displayed text
					 '`Link` varchar(255) not null, ' .           # WebLink
					 'primary key (ID)'
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('Threads') or die('remove error');
	$db->CreateTable('Threads',
					 '`ID` int unsigned not null, ' .         # ID
					 '`Forum` int unsigned not null, ' .      # What forum if this thread in
					 '`LastPostDate` int not null, ' .        # Date of currently last post (used for display order)
					 '`Subject` varchar(150) not null, ' .    # Displayed subject
					 '`Desc` varchar(150) not null, ' .       # Description
					 '`Date` int not null, ' .                # Date of creation
					 '`User` int unsigned not null, ' .       # User who created this thread
					 '`UserName` varchar(40) not null, ' .    # User name (if guest)
					 '`Views` int unsigned not null, ' .      # Number of visitors here
					 '`Options` int unsigned not null, ' .    # Options (see thread.lib)
					 '`Question` varchar(150) not null, ' .   # Question to be voted about (if poll)
					 '`PollTimeout` int not null, ' .         # Time when this poll should end. 1 if it has been ended manually, 0 = infinite
					 '`LastVoted` int not null, ' .           # Date of last vote (currently unused)
					 'primary key (ID),' .
					 'KEY LastPostDate (LastPostDate)'
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('Posts') or die('remove error');
	$db->CreateTable('Posts',
					 '`ID` int unsigned not null, ' .          # ID
					 '`Thread` int unsigned not null, ' .      # What thread is this post in?
					 '`ReplyTo` int unsigned not null, ' .     # What post is replied by this post to?
					 '`Date` int not null, ' .                 # Date of creation
					 '`EditUser` int unsigned not null, ' .    # User of last modification
					 '`EditDate` int not null, ' .             # Date of last modification
					 '`EditCount` smallint unsigned not null, ' . # Number of modifications
					 '`User` int unsigned not null, ' .        # User who created this post
					 '`UserName` varchar(40) not null, ' .     # User name (if guest)
					 '`Subject` varchar(150) not null, ' .     # Displayed subject, optional
					 '`Msg` text not null, ' .                 # Message body
					 '`Options` int unsigned not null, ' .     # Post options, defined in common library
					 '`AttachFile` varchar(40) not null, ' .   # Attachment, local filename
					 '`AttachFileName` varchar(100) not null, ' . # Attachment, public filename
					 '`AttachDLCount` int unsigned not null, ' . # Attachment, download counter
					 '`IP` varchar(15) not null, ' .           # Creator's IP
					 '`Hostname` varchar(150) not null, ' .    # Creator's Hostname
					 '`SpamRating` int not null, ' .           # SpamRating
					 'primary key (ID), ' .
					 'KEY Thread (Thread), ' .
					 'KEY Date (Date), ' .
					 'KEY User (User)'
		) or die('create error: ' . $db->LastError());
	$extra = '';
	$db->RemoveTable('Users') or die('remove error');
	$db->CreateTable('Users',
					 '`ID` int unsigned not null, ' .          # ID
					 '`Name` varchar(40) not null, ' .         # Displayed username
					 '`Password` varchar(40) not null, ' .     # MD5-encrypted password
					 '`RegDate` int not null, ' .              # Date of registration
					 '`RegEMail` varchar(100) not null, ' .    # E-Mail at registration time
					 '`DefaultNotify` tinyint unsigned not null, ' . # Default notification
					 '`EMail` varchar(100) not null, ' .       # Current E-Mail
					 '`Jabber` varchar(50) not null, ' .       # Jabber Messenger
					 '`ICQ` varchar(15) not null, ' .          # ICQ
					 '`AIM` varchar(30) not null, ' .          # AOL Instant Messenger
					 '`YIM` varchar(30) not null, ' .          # Yahoo! Instant Messenger
					 '`MSN` varchar(50) not null, ' .          # MSN Messenger
					 '`LastActivity` int not null, ' .         # Date/time of last board activity
					 '`LastForum` int not null, ' .            # Forum the user was last seen in | special action
					 '`LastLogin` int not null, ' .            # Date/time of last login
					 '`LastLogout` int not null, ' .           # Date/time of last 'logout'
					 '`Signature` text not null, ' .           # User's signature
					 '`BirthDay` tinyint unsigned not null, ' . # Day of birthday
					 '`BirthMonth` tinyint unsigned not null, ' . # Month of birthday
					 '`BirthYear` smallint unsigned not null, ' . # Year of birthday
					 '`About` text not null, ' .               # Some text describing the user, displayed in the user's profile
					 '`Title` varchar(40) not null, ' .        # User Title
					 '`Location` varchar(50) not null, ' .     # User's location
					 '`Homepage` varchar(150) not null, ' .    # Homepage
					 '`Gender` char(1) not null, ' .           # Gender. m: male, f: female
					 '`Avatar` varchar(150) not null, ' .      # Avatar file/URL
					 '`AvatarX` smallint not null, ' .         # Avatar image X size
					 '`AvatarY` smallint not null, ' .         # Avatar image Y size
					 '`Photo` varchar(150) not null, ' .       # Photo file/URL
					 $extra .                                  # any extra fields generated above
					 '`ActivateKey` varchar(50) not null, ' .  # Activation Key sent by E-Mail
					 '`RecommendedBy` int unsigned not null, ' . # User was recommended by another user(id)
					 '`Design` tinyint not null default -1, ' . # User's design choose (-1 for forum default)
					 '`ThreadIcons` tinyint not null, ' .      # Show icons/text for Thread actions, 0:icons, 1:text, 2:both
					 '`Flags` int unsigned not null, ' .       # some other flags
					 '`Timezone` tinyint NOT NULL default 99, ' . # timezone in 1/4 hours, relative to UTC. (99 is default)
					 '`TimezoneDS` tinyint NOT NULL default -1, ' . # daylight saving time? (-1 default)
					 '`EditControls` int unsigned NOT NULL, ' .
					 '`ThreadsPerPage` smallint NOT NULL default -1, ' .
					 '`ThreadSort` smallint NOT NULL default -1, ' .
					 '`ThreadTime` smallint NOT NULL default -1, ' .
					 '`Favourites` text NOT NULL, ' .
					 '`Language` varchar(6) NOT NULL, ' .
					 '`DateFormat` varchar(20) NOT NULL, ' .
					 'primary key (ID),' .
					 'KEY LastActivity (LastActivity)'
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('PollVotes') or die('remove error');
	$db->CreateTable('PollVotes',
					 '`ID` int unsigned not null, ' .         # ID
					 '`Thread` int unsigned not null, ' .     # Thread this poll belongs to
					 '`Sort` tinyint not null, ' .            # Order of display
					 '`Title` varchar(100) not null, ' .      # Displayed voting option
					 '`Votes` int unsigned not null, ' .      # Number of votes for this option
					 'primary key (ID)'
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('PollUsers') or die('remove error');
	$db->CreateTable('PollUsers',
					 '`Thread` int unsigned not null, ' .     # Thread we're talking about
					 '`User` int unsigned not null, ' .       # User that has already voted in above thread
					 '`VoteNum` int unsigned not null, ' .    # User's vote, saved to change this later
					 'primary key (Thread, User)'
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('Messages') or die('remove error');
	$db->CreateTable('Messages',
					 '`ID` int unsigned not null, ' .         # ID
					 '`Forum` int not null, ' .               # What forum if this message belongs to (0 for any)
					 '`Date` int not null, ' .                # Date of creation
					 '`User` int unsigned not null, ' .       # User who created this message
					 '`Subject` varchar(150) not null, ' .    # Displayed subject
					 '`Msg` text not null, ' .                # Message body
					 '`Options` int unsigned not null, ' .    # several Flags...
					 'primary key (ID)'
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('MessageRead') or die('remove error');
	$db->CreateTable('MessageRead',
					 '`Msg` int unsigned not null, ' .    # Message we're talking about
					 '`User` int unsigned not null'       # User that already read above message
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('ThreadWatch') or die('remove error');
	$db->CreateTable('ThreadWatch',
					 '`Thread` int unsigned not null, ' .      # Thread we're talking about
					 '`User` int unsigned not null, ' .        # User that is watching above thread
					 '`Mode` tinyint unsigned not null, ' .    # Mode of notification. 1: E-Mail, 2: ICQ, 3: both
					 '`LastRead` int not null, ' .             # Timestamp of last read time
					 '`LastNotify` int not null, ' .           # Timestamp of last new-post notification
					 'PRIMARY KEY (Thread, User), ' .
					 'KEY Thread (Thread), ' .
					 'KEY User (User)'
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('ForumWatch') or die('remove error');
	$db->CreateTable('ForumWatch',
					 '`Forum` int unsigned not null, ' .       # Forum we're talking about
					 '`User` int unsigned not null, ' .        # User that is watching above thread
					 '`Mode` tinyint unsigned not null, ' .    # Mode of notification. 1: E-Mail, 2: ICQ, 3: both, 4: Jabber...
					 '`Flags` tinyint unsigned not null, ' .   # More flags. 1: recursive
					 '`LastVisited` int not null, ' .          # Timestamp of last visit time
					 '`LastNotify` int not null, ' .           # Timestamp of last new-thread notification
					 'PRIMARY KEY (Forum, User), ' .
					 'KEY Forum (Forum), ' .
					 'KEY User (User)'
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('UserCategoryState') or die('remove error');
	$db->CreateTable('UserCategoryState',
					 '`Forum` int unsigned not null, ' .     # Forum (category) we're talking about
					 '`User` int unsigned not null, ' .      # User that has set the state
					 '`State` tinyint unsigned not null, ' . # State = 0: Collapsed, 1: Expanded
					 'primary key (Forum, User)'
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('Guests') or die('remove error');
	$db->CreateTable('Guests',
					 '`Session` varchar(80) not null, ' .    # Guest user's PHP session ID
					 '`LastActivity` int not null, ' .       # Last update of record
					 '`LastForum` int unsigned not null'     # Last forum of guest
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('Stat') or die('remove error');
	$db->CreateTable('Stat',
					 '`Date` int not null, ' .               # Day of record
					 '`NewThreads` int not null, ' .         # New threads created on this day
					 '`NewPosts` int not null, ' .           # New posts send on this day
					 '`OnlineUsers` int not null, ' .        # Number of users online on this day
					 '`OnlineGuests` int not null, ' .       # Number of guests online on this day
					 '`PageHits` int not null, ' .           # Number of (almost total) page hits on this day
					 '`NewUsers` int not null'               # Registrations on this day
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('ACL') or die('remove error');
	$db->CreateTable('ACL',
					 '`ID` int unsigned not null, ' .           # unique ID
					 '`User` int unsigned not null, ' .         # user ID
					 '`Group` int unsigned not null, ' .        # group ID
					 '`Action` smallint unsigned not null, ' .  # action ID
					 '`Thread` int unsigned not null, ' .       # thread ID
					 '`Forum` int unsigned not null, ' .        # forum ID
					 '`Grant` int not null, ' .                 # grant this right? | some other numeric value for it
					 '`Enabled` bool not null, ' .              # use this entry?
					 'primary key (ID), ' .
					 'UNIQUE INDEX (User, `Group`, Action, Thread, Forum)'
		) or die('create error: ' . $db->LastError());

	$db->SetTable('ACL');
	$db->AddRecord(array('ID' => 1,
						 'User' => 0,
						 'Group' => 0,
						 'Action' => 33,   // viewforum
						 'Thread' => 0,
						 'Forum' => 0,
						 'Grant' => 1,
						 'Enabled' => 1
		)) or die('add error: ' . $db->LastError());
	$db->AddRecord(array('ID' => 2,
						 'User' => 0,
						 'Group' => 1,
						 'Action' => 82,   // user rights
						 'Thread' => 0,
						 'Forum' => 0,
						 'Grant' => 1,
						 'Enabled' => 1
		)) or die('add error: ' . $db->LastError());
	$db->AddRecord(array('ID' => 3,
						 'User' => 0,
						 'Group' => 2,
						 'Action' => 83,   // mod rights
						 'Thread' => 0,
						 'Forum' => 0,
						 'Grant' => 1,
						 'Enabled' => 1
		)) or die('add error: ' . $db->LastError());
	$db->AddRecord(array('ID' => 4,
						 'User' => 0,
						 'Group' => 3,
						 'Action' => 84,   // admin rights
						 'Thread' => 0,
						 'Forum' => 0,
						 'Grant' => 1,
						 'Enabled' => 1
		)) or die('add error: ' . $db->LastError());
	$db->RemoveTable('GroupMembers') or die('remove error');
	$db->CreateTable('GroupMembers',
					 '`Group` int unsigned not null, ' .   # group ID
					 '`User` int unsigned not null, ' .    # user ID
					 'primary key (`Group`, User)'
		) or die('create error: ' . $db->LastError());
	$db->RemoveTable('GroupNames') or die('remove error');
	$db->CreateTable('GroupNames',
					 '`ID` int unsigned not null, ' .         # group ID
					 '`Name` varchar(50) not null, ' .        # group name
					 '`ShowInTeam` tinyint(1) not null, ' .   # show in the team list
					 'primary key (ID)'
		) or die('create error: ' . $db->LastError());

	$db->SetTable('GroupNames');
	$db->AddRecord(array('ID' => 1,
						 'Name' => $T['inst_grp_users'],
						 'ShowInTeam' => 0
		)) or die('add error: ' . $db->LastError());
	$db->AddRecord(array('ID' => 2,
						 'Name' => $T['inst_grp_gmods'],
						 'ShowInTeam' => 1
		)) or die('add error: ' . $db->LastError());
	$db->AddRecord(array('ID' => 3,
						 'Name' => $T['inst_grp_admins'],
						 'ShowInTeam' => 1
		)) or die('add error: ' . $db->LastError());

	// ------------------------------------------------------------ FORUMS

	// categroies and forums IDs cannot be the same here!

	// so we append the cat IDs after the forums IDs number space
	$fmax = $db0->FastQuery1st('forums', 'MAX(forum_id)');

	$db->SetTable('Forums');
	$arr = $db0->FastQueryArray('categories');
	if ($arr) foreach($arr as $a)
	{
		$db->AddRecord(array('ID' => $a['cat_id'] + $fmax + 1,
							 'Sort' => $a['cat_order'],
							 'Parent' => 0,
							 'Name' => $a['cat_title'],
							 'Flags' => 1
			)) or die('[forums] add error: ' . $db->LastError());
	}

	$arr = $db0->FastQueryArray('forums');
	if ($arr) foreach($arr as $a)
	{
		$db->AddRecord(array('ID' => $a['forum_id'],
							 'Sort' => $a['forum_order'],
							 'Parent' => $a['cat_id'] + $fmax + 1,
							 'Name' => $a['forum_name'],
							 'Flags' => 0,
							 'Description' => transl_bbc($a['forum_desc'])
			)) or die('[forums] add error: ' . $db->LastError());
	}

	// ------------------------------------------------------------ THREADS

	$db->SetTable('Threads');
	$arr = $db0->FastQueryArray('topics');
	if ($arr) foreach($arr as $a)
	{
		$timeout = 0;
		$question = '';

		// is this a poll?
		// TODO: use an SQL JOIN for this
		$vote = $db0->FastQuery('vote_desc', '*', 'topic_id=' . $a['topic_id']);
		if ($vote)
		{
			if ($vote['vote_length'])   // number of seconds, 0 = infinite
				$timeout = $a['topic_time'] + $vote['vote_length'];
			$question = $vote['vote_text'];
		}

		$options = 0;
		if ($a['topic_status'] & 1) $options |= 1;   // closed
		if ($a['topic_status'] & 2) $options |= 8;   // moved
		if ($a['topic_type'] & 1) $options |= 2;   // important
		if ($a['topic_type'] & 2) $options |= 2;   // actually... announcement... TODO
		if ($vote) $options |= 4;   // poll

		if ($a['topic_status'] & 2)   // moved
		{
			$question = $a['topic_moved_id'];
			$timeout = time() + 14 * 24 * 3600;   // show "moved" link for 14 days
		}

		$db->AddRecord(array('ID' => $a['topic_id'],
							 'Forum' => $a['forum_id'],
							 'LastPostDate' => 0,  #$a['timelastreply'],  // this is not always correct, we do it ourselves later
							 'Subject' => transl_bbc($a['topic_title']),
							 'Date' => $a['topic_time'],
							 'User' => max(0, $a['topic_poster']),   // must be >= 0
							 'UserName' => '',
							 'Views' => $a['topic_views'],
							 'Options' => $options,
							 'Question' => $question,
							 'PollTimeout' => $timeout
			)) or die('[threads] add error: ' . $db->LastError());
	}

	ForwardHTML($ME . '?step=3' . sid());
}

if ($step == 3)
{
	// ------------------------------------------------------------ POSTS

	$db->SetTable('Posts');
	$arr = $db0->FastQueryArray('posts');
	if ($arr) foreach($arr as $a)
	{
		$text = $db0->FastQuery('posts_text', '*', 'post_id=' . $a['post_id']);
		// TODO: use an SQL JOIN for this

		$ip_a = preg_match('/^(..)(..)(..)(..)$/', $a['ip'], $m);
		$ip = chr(hexdec($m[1])) . '.' . chr(hexdec($m[2])) . '.' . chr(hexdec($m[3])) . '.' . chr(hexdec($m[4]));

		$db->AddRecord(array('ID' => $a['post_id'],
							 'Thread' => $a['topic_id'],
							 'ReplyTo' => 0,
							 'Date' => $a['post_time'],
							 'EditUser' => 0,
							 'EditDate' => $a['post_edit_time'],
							 'EditCount' => $a['post_edit_count'],
							 'User' => $a['poster_id'],
							 'UserName' => $a['post_username'],
							 'Subject' => transl_bbc($text['post_subject']),
							 'Msg' => transl_bbc($text['post_text'], $a['enable_smilies']),
							 'Options' => ($a['enable_smilies'] ? 0 : 1),
							 'IP' => $ip,
							 'Hostname' => '',
							 'SpamRating' => 0
			)) or die('[posts] add error: ' . $db->LastError());
	}

	ForwardHTML($ME . '?step=4' . sid());
}

if ($step == 4)
{
	// ------------------------------------------------------------ USERS

	function avatar_file($oldname, $user)
	{
		if (!$oldname) return '';   // no avatar set for this user

		global $avatar_path, $av_in_path;

		preg_match('/\.([^.]+)$/', $oldname, $m);

		$name0 = $oldname;
		$name1 = 'avatar_' . $user . '.' . $m[1];

		@copy($av_in_path . $name0, $avatar_path . $name1);

		return $name1;
	}

	$arr = $db0->FastQueryArray('users');
	if ($arr) foreach($arr as $a)
	{
		if ($a['user_id'] < 0) continue;

		$db->AddRecord(array('ID' => $a['user_id'],
							 'Name' => $a['username'],
							 'Password' => $a['user_password'],
							 'RegDate' => $a['user_regdate'],
							 'RegEMail' => $a['user_email'],
							 'DefaultNotify' => ($a['user_notify'] ? 1 : 0),
							 'EMail' => $a['user_email'],
							 'ICQ' => $a['user_icq'],
							 'AIM' => $a['user_aim'],
							 'YIM' => $a['user_yim'],
							 'MSN' => $a['user_msnm'],
							 'LastActivity' => $a['user_lastvisit'],
							 'LastForum' => 0,
							 'Signature' => transl_bbc($a['user_sig']),
							 'Location' => $a['user_from'],
							 'Homepage' => $a['user_website'],
							 'Avatar' =>
							 	($a['user_avatar_type'] == 1 ?
							 		avatar_file($a['user_avatar'], $a['user_id']) :   // local file
							 		$a['user_avatar']),                               // remote URL or no avatar
							 'ActivateKey' => '',
							 'Flags' => 2 + 4 + 32 + 128 + (rc('new_layout') ? 256 : 0),
							 'Language' => transl_lang($a['user_lang']),
							 'Timezone' => $a['user_timezone'] * 4
			), 'Users') or die('[users] add error: ' . $db->LastError());

		if ($a['user_active'])
		{
			$group = $db0->FastQuery('user_group', '*', 'user_id=' . $a['user_id']);
			$status = group_to_status($group['group_id']);
			if ($status > 0)
				$db->AddRecord(array('User' => $a['user_id'],
									 'Group' => 1
					), 'GroupMembers') or die('[group members] add error: ' . $db->LastError());
			if ($status > 1)
				$db->AddRecord(array('User' => $a['user_id'],
									 'Group' => $status
					), 'GroupMembers') or die('[group members] add error: ' . $db->LastError());
		}
	}

	// ------------------------------------------------------------ POLL VOTES

	$i = 1;
	$db->SetTable('PollVotes');
	$arr = $db0->FastQueryArray('vote_results');
	if ($arr) foreach($arr as $a)
	{
		$vote = $db0->FastQuery('vote_desc', '*', 'vote_id=' . $a['vote_id']);
		$db->AddRecord(array('ID' => $i++,
							 'Thread' => $vote['topic_id'],
							 'Sort' => 0,
							 'Title' => $a['vote_option_text'],
							 'Votes' => $a['vote_result']
			)) or die('[poll votes] add error: ' . $db->LastError());
	}

	// ------------------------------------------------------------ POLL USERS

	$db->SetTable('PollUsers');
	$arr = $db0->FastQueryArray('vote_voters');
	if ($arr) foreach($arr as $a)
	{
		$vote = $db0->FastQuery('vote_desc', '*', 'vote_id=' . $a['vote_id']);
		$db->AddRecord(array('Thread' => $vote['topic_id'],
							 'User' => $a['vote_user_id'],
							 'VoteNum' => 0
			)) or die('[poll users] add error: ' . $db->LastError());
	}

	// ------------------------------------------------------------ THREADWATCH

	$db->SetTable('ThreadWatch');
	$arr = $db0->FastQueryArray('topics_watch');
	if ($arr) foreach($arr as $a)
	{
		$db->AddRecord(array('Thread' => $a['topic_id'],
							 'User' => $a['user_id'],
							 'Mode' => 1   // always notify via e-mail
			)) or die('[thread watch] add error: ' . $db->LastError());
	}

	ForwardHTML($ME . '?step=5' . sid());
}

if ($step == 5)
{
	// ------------------------------------------------------------ CONFIG

	$CONFFILE['forum_title'] = $db0->FastQuery1st('config', 'config_value', 'config_name="sitename"');

	$server_name = $db0->FastQuery1st('config', 'config_value', 'config_name="server_name"');

	/*
	$server_port = $db0->FastQuery1st('config', 'config_value', 'config_name="server_port"');
	$script_path = $db0->FastQuery1st('config', 'config_value', 'config_name="script_path"');
	$http = ($server_port == 443 ? 'https://' : 'http://');
	if ($server_port != 80 && $server_port != 443)
		$server_port = ':' . $server_port;
	else
		$server_port = '';
	$home_url = $http . $server_name . $server_port . $script_path;
	$CONFFILE['home_url'] = $home_url;
	*/

	$CONFFILE['smtp_server'] = $db0->FastQuery1st('config', 'config_value', 'config_name="smtp_host"');
	$CONFFILE['smtp_sender'] = $db0->FastQuery1st('config', 'config_value', 'config_name="board_email"');
	$CONFFILE['smtp_user'] = $db0->FastQuery1st('config', 'config_value', 'config_name="smtp_username"');
	$CONFFILE['smtp_pass'] = $db0->FastQuery1st('config', 'config_value', 'config_name="smtp_password"');

	$CONFFILE['new_user_validation'] = intval($db0->FastQuery1st('config', 'config_value', 'config_name="require_activation"')) + 1;

	$CONFFILE['threads_per_page'] = $db0->FastQuery1st('config', 'config_value', 'config_name="topics_per_page"');
	$CONFFILE['posts_per_page'] = $db0->FastQuery1st('config', 'config_value', 'config_name="posts_per_page"');
	$CONFFILE['hot_thread_posts'] = $db0->FastQuery1st('config', 'config_value', 'config_name="hot_threshold"');

	$av_remote = $db0->FastQuery1st('config', 'config_value', 'config_name="allow_avatar_remote"');

	$av_upload = $db0->FastQuery1st('config', 'config_value', 'config_name="allow_avatar_upload"');
	$av_size = $db0->FastQuery1st('config', 'config_value', 'config_name="avatar_filesize"');

	if (!$av_remote && (!$av_upload || !$av_size)) $avatars = 0;
	else $avatars = 1;
	$CONFFILE['avatars_enabled'] = $avatars;
	$CONFFILE['avatar_x'] = $db0->FastQuery1st('config', 'config_value', 'config_name="avatar_max_width"');
	$CONFFILE['avatar_y'] =	$db0->FastQuery1st('config', 'config_value', 'config_name="avatar_max_height"');
	$CONFFILE['avatar_bytes'] =	$av_size;

	if ($db0->FastQuery1st('config', 'config_value', 'config_name="allow_sig"'))

		$CONFFILE['max_sig_len'] = $db0->FastQuery1st('config', 'config_value', 'config_name="max_sig_chars"');
	else
		$CONFFILE['max_sig_len'] = 0;

	$CONFFILE['tz_offset'] = $db0->FastQuery1st('config', 'config_value', 'config_name="board_timezone"') * 4;
	#$CONFFILE['prog_id'] = $db0->FastQuery1st('config', 'config_value', 'config_name="cookie_name"');

	if (!rebuild_conffile() && !rc('nowrite')) die($T['err_write_conffile']);

	ForwardHTML($ME . '?step=6' . sid());
}

if ($step == 6)
{
	BeginHTML($T['installation']);
	echo '<p>';
	echo 'Conversion finished. ' . $T['inst_check_db_integrity'] . '<br />';

	// Set correct LastPostDate for all threads
	$thread = new IThread;
	$arr = $db->FastQueryArray('Threads');
	if ($arr) foreach($arr as $a)
	{
		$record = GetLastPost(intval($a['ID']));
		$thread->SetLastPostDate($record['Date'], $a['ID']);
	}

	// Add thread-has-attachment flags
	$thread = new IThread;
	$post = new IPost;
	if ($thread->Find()) do
	{
		$found = $post->Find('AttachFile<>""', '', 1);

		$opt = $thread->GetOptions();
		$opt = ($opt & ~16) | (($found ? 1 : 0) * 16);
		$thread->SetOptions($opt);   // no error detection here
	}
	while ($thread->FindNext());

	// Store correct avatar image dimensions
	$user = new IUser;
	if ($user->GetList()) do
	{
		if ($user->GetAvatar() != '')
		{
			$is = @getimagesize((strpos($user->GetAvatar(), ':') ? '' : $avatar_path) . $user->GetAvatar());
			if (is_array($is))
			{
				$newx = $is[0];
				$newy = $is[1];
				if (!$db->ChangeRecord(array('AvatarX' => $newx, 'AvatarY' => $newy), 'ID=' . $user->GetID(), 'Users'))
				{
					echo 'Warning: Database error: ' . t2h($db->LastError()) . '<br />';
				}
			}
		}
	}
	while ($user->GetNext());

	echo '<b>' . $T['inst_done'] . '</b></p>';

	echo '<p>Import process finished. Not all information from the board software may have been copied, please check the new board configuration and all access rights (user groups, forum access rights, ACL).</p>';

	echo '<p>You may need to convert all data stored in the database to UTF-8 unicode character encoding, if this is enabled for your BlackBoard installation. You can find a basic conversion tool in the docs/tools/ directory of the release archive. Copy it to the installation PHP files and call it via your browser. If you already copied the file, this link may work: <a href="_convert_utf8.php' . sid() . '">Convert to UTF-8</a> <i>(First remove the lock.conf file again!)</i></p>';

	if (!rc('nowrite')) touch('lock.conf');
	echo '<p>' . $T['inst_lock'] . '</p>';

	echo '<p><a href="' . $MODULE['main'] . sid(2) . '">' . $T['inst_go_overview'] . '</a></p>';
	EndHTML();
}

?>
