<?php
// BlackBoard - PHP Internet Newsboard System
// Copyright 2003-4 by Yves Goergen
// Homepage: http://blackboard.unclassified.de
// See docs/LICENSE.txt for distribution/license details
//
// install.php
// Standard database installation

// Disable this file in productive environment!
if (file_exists('lock.conf')) exit();


// Import request variables
$step = intval($_REQUEST['step']);
if (!$step) $step = 1;
if ($step < 1 || $step > 4) die('Invalid step parameter');

$type = intval($_REQUEST['SetupType']);

// we don't have/need a database connection in the first steps
$NODB = ($step < 3);

$INSTALLING = true;
if (!defined('PUBLIC_LIB')) require_once('bb_lib/public.lib.php');
$ME = 'install.php';

require_once($libpath . 'common.lib.php');
require($libpath . 'lang/' . $LANG . '_more.php');


// Guests' language selection
//
if (isset($_GET['set_lang']))
{
	if ($_GET['set_lang'] != '')
	{
		setcookie('pref_language', $_GET['set_lang'], time() + 3600 * 24 * 365);
	}
	else
	{
		setcookie('pref_language');
		unset($pref_language);
	}
	$_SESSION['pref_language'] = $_GET['set_lang'];
	ForwardHTML($ME . sid(0));
	exit();
}


// Step 2 has to be done before the page is displayed because it writes the configuration file
// -- not for uninstallation
//
if ($step == 2)
{
	$CONFFILE['forum_title'] = $_POST['ForumTitle'];
	$CONFFILE['home_url'] = $_POST['HomeURL'];

	$CONFFILE['db_server'] = $_POST['DbServer'];
	$CONFFILE['db_user'] = $_POST['DbUser'];
	if (($_POST['DbPass'] == '' || trim($_POST['DbPass']) != '')) $CONFFILE['db_pass'] = base64_encode($_POST['DbPass']);
	$CONFFILE['db_name'] = $_POST['DbName'];
	$CONFFILE['db_prefix'] = $_POST['DbPrefix'];

	#$CONFFILE['prog_id'] = $_POST['ProgID'];
	$CONFFILE['prog_id'] = 'bb-' . rand(100, 999);

	if ($type == 1 ||   // NEW INSTALL
	    $type == 2 ||   // UPGRADE
	    $type == 3)     // IMPORT
	{
		$fwd = true;
	}
	else
	{
		$fwd = false;
	}

	// Stop installation process here and go back to the first page,
	// if we don't already know that we cannot write to files on disk
	if (!rebuild_conffile() && !rc('nowrite'))
	{
		echo '<p class="error">' . $T['err_write_conffile'] . '</p>';
		$step = 1;
	}
	else if ($fwd)
	{
		ForwardHTML($ME . '?step=3&amp;SetupType=' . $type . sid());
		exit();
	}
}


// Begin page
BeginHTML($T['installation']);

if ($step == 1)
{
	$width = 200;
	$nowrite = rc('nowrite');

	// Check correct nowrite setting
	if ((!($fp1 = @fopen($conf_filename, 'a')) || !($fp2 = @fopen($conf_tempname, 'w'))) &&
		!$nowrite)
	{
		echo '<p class="error">' . $T['inst_warn_nowrite'] . '</p>';
		EndHTML();
		exit();
	}
	@fclose($fp1);
	@fclose($fp2);
	@unlink($conf_tempname);

	echo '<div class="path">' . $T['select_language'] . ': ';
	echo '<a href="' . $ME . '?set_lang=' . sid() . '">' . $T['default'] . '</a>';
	foreach ($CFG['languages'] as $lang) echo '&nbsp; <a href="' . $ME . '?set_lang=' . $lang . sid() . '">' . t2h($CFG['language_names'][$lang]) . ' (' . t2h($lang) . ')</a>';
	echo '</div>';

	echo '<form action="' . $ME . '?step=2' . sid() . '" method="post">';

	echo '<p><b>' . $T['inst_welcome'] . '</b></p>';

	echo '<p>' . $T['inst_assistant'] . '</p>';

	if ($nowrite)
		echo '<p class="error">' . $T['inst_nowrite_warning'] . '</p>';

	echo '<p>';
	echo '<table cellspacing="' . $TABLE['cp']['space'] . '" cellpadding="' . $TABLE['cp']['pad'] . '" border="' . $TABLE['cp']['border'] . '" width="100%">';
	echo '<colgroup>';
	echo '<col width="' . $width . '" />';
	echo '<col />';
	echo '</colgroup>';

	$guessType = 0;
	if (!rc('db_user')) $guessType = 1;   // no DB username set -> guess new installation
	if (rc('db_user')) $guessType = 2;

	echo '<tr valign="top"><td class="list_cp_n">' . $T['inst_type'] . '</td>';
	echo '<td class="list_cp_n"><input type="radio" class="radio" name="SetupType" id="SetupType1" value="1"' . ($guessType == 1 ? ' checked="checked"' : '') . ' /><label for="SetupType1">' . $T['inst_type_new'] . '</label><br /><small>' . $T['inst_type_new_note'] . '</small></td></tr>';

	echo '<tr valign="top"><td class="list_cp_n">&nbsp;</td>';
	echo '<td class="list_cp_n"><input type="radio" class="radio" name="SetupType" id="SetupType2" value="2"' . ($guessType == 2 ? ' checked="checked"' : '') . ' /><label for="SetupType2">' . $T['inst_type_update'] . '</label><br /><small>' . $T['inst_type_update_note'] . '</small></td></tr>';

	echo '<tr valign="top"><td class="list_cp_n">&nbsp;</td>';
	echo '<td class="list_cp_n"><input type="radio" class="radio" name="SetupType" id="SetupType3" value="3"' . ($guessType == 3 ? ' checked="checked"' : '') . ' /><label for="SetupType3">' . $T['inst_type_import'] . '</label><br /><small>' . $T['inst_type_import_note'] . '</small></td></tr>';

	echo '<tr valign="top"><td class="list_cp_l">&nbsp;</td>';
	echo '<td class="list_cp_l"><input type="radio" class="radio" name="SetupType" id="SetupType9" value="9"' . ($guessType == 9 ? ' checked="checked"' : '') . ' /><label for="SetupType9">' . $T['inst_type_uninstall'] . '</label><br /><small>' . $T['inst_type_uninstall_note'] . '</small></td></tr>';

	echo '<tr valign="top"><td class="list_cp_n">' . $T['forum_title'] . '</td>';
	echo '<td class="list_cp_n"><input type="text" class="text" name="ForumTitle" value="' . htmlquote(rc('forum_title')) . '" size="60" maxlength="100" /><br /><small>' . $T['forum_title_note'] . '</small></td></tr>';

	$home_url = rc('home_url');
	if (!$home_url)
	{
		// auto-determine self-URL
		$port = $_SERVER['SERVER_PORT'];
		$http = ($port == 443 ? 'https://' : 'http://');
		if ($port != 80 && $port != 443)
			$port = ':' . $port;
		else
			$port = '';

		$home_url = $http . $_SERVER['SERVER_NAME'] . $port . $_SERVER['REQUEST_URI'];

		// cut $ME from the end
		$pi = pathinfo($_SERVER['PHP_SELF']);
		if ($pos = strpos($home_url, $pi['basename']))
		{
			$home_url = substr($home_url, 0, $pos);
		}
	}
	echo '<tr valign="top"><td class="list_cp_l">' . $T['home_url'] . '</td>';
	echo '<td class="list_cp_l"><input type="text" class="text" name="HomeURL" value="' . htmlquote($home_url) . '" size="60" maxlength="150" /></td></tr>';

	echo '<tr valign="top"><td class="list_cp_n">' . $T['db_server'] . '</td>';
	echo '<td class="list_cp_n"><input type="text" class="text" name="DbServer" value="' . htmlquote(rc('db_server')) . '" size="40" maxlength="100" /></td></tr>';

	echo '<tr valign="top"><td class="list_cp_n">' . $T['db_user'] . '</td>';
	echo '<td class="list_cp_n"><input type="text" class="text" name="DbUser" value="' . htmlquote(rc('db_user')) . '" size="40" maxlength="40" /></td></tr>';

	echo '<tr valign="top"><td class="list_cp_n">' . $T['db_pass'] . '</td>';
	echo '<td class="list_cp_n"><input type="password" class="text" name="DbPass" value="' . (rc('db_pass') != '' ? '          ' : '') . '" size="40" maxlength="40" /></td></tr>';

	echo '<tr valign="top"><td class="list_cp_n">' . $T['db_name'] . '</td>';
	echo '<td class="list_cp_n"><input type="text" class="text" name="DbName" value="' . htmlquote(rc('db_name')) . '" size="40" maxlength="40" /></td></tr>';

	echo '<tr valign="top"><td class="list_cp_l">' . $T['db_prefix'] . '</td>';
	echo '<td class="list_cp_l"><input type="text" class="text" name="DbPrefix" value="' . htmlquote(rc('db_prefix')) . '" size="40" maxlength="40" /><br /><small>' . $T['db_prefix_note'] . '</small></td></tr>';

	/*
	echo '<tr valign="top"><td class="list_cp_l">' . $T['prog_id'] . '</td>';
	echo '<td class="list_cp_l"><input type="text" class="text" name="ProgID" value="' . htmlquote(rc('prog_id')) . '" size="20" maxlength="20" /><br /><small>' . $T['prog_id_note'] . '</small></td></tr>';
	*/

	echo '<tr valign="top"><td class="list_cp_n" colspan="2"><input type="submit" class="button" value="' . $T['inst_continue'] . '" /></td></tr>';

	echo '</table>';
	echo '</p>';

	echo '</form>';
}

if ($step == 2)
{
	if ($type == 9)   // UNINSTALL
	{
		echo '<p><b><a href="' . $ME . '?step=3&amp;SetupType=9' . sid() . '">' . $T['uninst_sure'] . '</a></b><br />';
		echo $T['uninst_note'] . '</p>';

		echo '<p>' . $T['inst_uninst_summary'] . '<br />';
		echo $T['db_server'] . ': ' . t2h(rc('db_server')) . '<br />';
		echo $T['db_user'] . ': ' . t2h(rc('db_user')) . '<br />';
		echo $T['db_prefix'] . ': ' . t2h(rc('db_prefix')) . '</p>';
	}
}

if ($step == 3)
{
	if ($type == 1)   // NEW INSTALL
	{
		echo '<p>';
		echo $T['inst_creat_tables'] . '<br />';

		// ------------------------------------------------------------ FORUMS

		$db->RemoveTable('Forums') or die('remove error: ' . $db->LastError());
		$db->CreateTable('Forums',
						 '`ID` int unsigned not null, ' .             # ID
						 '`Sort` int not null, ' .                    # Order of display
						 '`Parent` int unsigned not null, ' .         # Parent forum (may be category)
						 '`Name` varchar(100) not null, ' .           # Display name
						 '`Flags` int not null, ' .                   # Category/WebLink
						 '`Description` text not null, ' .            # Displayed text
						 '`Link` varchar(255) not null, ' .           # WebLink
						 'primary key (ID)'
			) or die('create error: ' . $db->LastError());

		/*$db->SetTable('Forums');
		$db->AddRecord(array('ID' => 1,
							 'Sort' => 0,
							 'Parent' => 0,
							 'Name' => 'Sample Category 1',
							 'Flags' => 1,
							 'Description' => 'Something to demonstrate categories'
			)) or die('add error: ' . $db->LastError());
		$db->AddRecord(array('ID' => 2,
							 'Sort' => 0,
							 'Parent' => 1,
							 'Name' => 'Demo Forum 2',
							 'Flags' => 0,
							 'Description' => 'First Forum here'
			)) or die('add error: ' . $db->LastError());*/


		// ------------------------------------------------------------ THREADS

		$db->RemoveTable('Threads') or die('remove error');
		$db->CreateTable('Threads',
						 '`ID` int unsigned not null, ' .         # ID
						 '`Forum` int unsigned not null, ' .      # What forum if this thread in
						 '`LastPostDate` int not null, ' .        # Date of currently last post (used for display order)
						 '`Subject` varchar(150) not null, ' .    # Displayed subject
						 '`Desc` varchar(150) not null, ' .       # Description
						 '`Date` int not null, ' .                # Date of creation
						 '`User` int unsigned not null, ' .       # User who created this thread
						 '`UserName` varchar(40) not null, ' .    # User name (if guest)
						 '`Views` int unsigned not null, ' .      # Number of visitors here
						 '`Options` int unsigned not null, ' .    # Options (see thread.lib)
						 '`Question` varchar(150) not null, ' .   # Question to be voted about (if poll)
						 '`PollTimeout` int not null, ' .         # Time when this poll should end. 1 if it has been ended manually, 0 = infinite
						 '`LastVoted` int not null, ' .           # Date of last vote (currently unused)
						 'primary key (ID),' .
						 'KEY LastPostDate (LastPostDate)'
			) or die('create error: ' . $db->LastError());

		/*$db->SetTable('Threads');
		$db->AddRecord(array('ID' => 1,
							 'Forum' => 2,
							 'LastPostDate' => time(),
							 'Subject' => 'Welcome to BlackBoard',
							 'Date' => time(),
							 'User' => 1,
							 'UserName' => '',
							 'Views' => 0,
							 'Options' => 0,
							 'Question' => '',
							 'PollTimeout' => 0
			)) or die('add error: ' . $db->LastError());*/


		// ------------------------------------------------------------ POSTS

		$db->RemoveTable('Posts') or die('remove error');
		$db->CreateTable('Posts',
						 '`ID` int unsigned not null, ' .          # ID
						 '`Thread` int unsigned not null, ' .      # What thread is this post in?
						 '`ReplyTo` int unsigned not null, ' .     # What post is replied by this post to?
						 '`Date` int not null, ' .                 # Date of creation
						 '`EditUser` int unsigned not null, ' .    # User of last modification
						 '`EditDate` int not null, ' .             # Date of last modification
						 '`EditCount` smallint unsigned not null, ' . # Number of modifications
						 '`User` int unsigned not null, ' .        # User who created this post
						 '`UserName` varchar(40) not null, ' .     # User name (if guest)
						 '`Subject` varchar(150) not null, ' .     # Displayed subject, optional
						 '`Msg` text not null, ' .                 # Message body
						 '`Options` int unsigned not null, ' .     # Post options, defined in common library
						 '`AttachFile` varchar(40) not null, ' .   # Attachment, local filename
						 '`AttachFileName` varchar(100) not null, ' . # Attachment, public filename
						 '`AttachDLCount` int unsigned not null, ' . # Attachment, download counter
						 '`IP` varchar(15) not null, ' .           # Creator's IP
						 '`Hostname` varchar(150) not null, ' .    # Creator's Hostname
						 '`SpamRating` int not null, ' .           # SpamRating
						 'primary key (ID), ' .
						 'KEY Thread (Thread), ' .
						 'KEY Date (Date), ' .
						 'KEY User (User)'
			) or die('create error: ' . $db->LastError());

		/*$db->SetTable('Posts');
		$db->AddRecord(array('ID' => 1,
							 'Thread' => 1,
							 'ReplyTo' => 0,
							 'Date' => time(),
							 'EditUser' => 0,
							 'EditDate' => 0,
							 'EditCount' => 0,
							 'User' => 1,
							 'UserName' => '',
							 'Subject' => 'Welcome to BlackBoard',
							 'Msg' => 'Message Body',
							 'Options' => 0,
							 'IP' => '0.0.0.0',
							 'Hostname' => '',
							 'SpamRating' => 0
			)) or die('add error: ' . $db->LastError());*/


		// ------------------------------------------------------------ USERS

		$extra = '';
		for ($n = 1; $n <= $extra_count; $n++)
		{
			$extra .= '`Extra{$n}` varchar(100) not null, ';
		}

		$db->RemoveTable('Users') or die('remove error');
		$db->CreateTable('Users',
						 '`ID` int unsigned not null, ' .          # ID
						 '`Name` varchar(40) not null, ' .         # Displayed username
						 '`Password` varchar(40) not null, ' .     # MD5-encrypted password
						 '`RegDate` int not null, ' .              # Date of registration
						 '`RegEMail` varchar(100) not null, ' .    # E-Mail at registration time
						 '`DefaultNotify` tinyint unsigned not null, ' . # Default notification
						 '`EMail` varchar(100) not null, ' .       # Current E-Mail
						 '`Jabber` varchar(50) not null, ' .       # Jabber Messenger
						 '`ICQ` varchar(15) not null, ' .          # ICQ
						 '`AIM` varchar(30) not null, ' .          # AOL Instant Messenger
						 '`YIM` varchar(30) not null, ' .          # Yahoo! Instant Messenger
						 '`MSN` varchar(50) not null, ' .          # MSN Messenger
						 '`LastActivity` int not null, ' .         # Date/time of last board activity
						 '`LastForum` int not null, ' .            # Forum the user was last seen in | special action
						 '`LastLogin` int not null, ' .            # Date/time of last login
						 '`LastLogout` int not null, ' .           # Date/time of last 'logout'
						 '`Signature` text not null, ' .           # User's signature
						 '`BirthDay` tinyint unsigned not null, ' . # Day of birthday
						 '`BirthMonth` tinyint unsigned not null, ' . # Month of birthday
						 '`BirthYear` smallint unsigned not null, ' . # Year of birthday
						 '`About` text not null, ' .               # Some text describing the user, displayed in the user's profile
						 '`Title` varchar(40) not null, ' .        # User Title
						 '`Location` varchar(50) not null, ' .     # User's location
						 '`Homepage` varchar(150) not null, ' .    # Homepage
						 '`Gender` char(1) not null, ' .           # Gender. m: male, f: female
						 '`Avatar` varchar(150) not null, ' .      # Avatar file/URL
						 '`AvatarX` smallint not null, ' .         # Avatar image X size
						 '`AvatarY` smallint not null, ' .         # Avatar image Y size
						 '`Photo` varchar(150) not null, ' .       # Photo file/URL
						 $extra .                                  # any extra fields generated above
						 '`ActivateKey` varchar(50) not null, ' .  # Activation Key sent by E-Mail
						 '`RecommendedBy` int unsigned not null, ' . # User was recommended by another user(id)
						 '`Design` tinyint not null default -1, ' . # User's design choose (-1 for forum default)
						 '`ThreadIcons` tinyint not null, ' .      # Show icons/text for Thread actions, 0:icons, 1:text, 2:both
						 '`Flags` int unsigned not null, ' .       # some other flags
						 '`Timezone` tinyint NOT NULL default 99, ' . # timezone in 1/4 hours, relative to UTC. (99 is default)
						 '`TimezoneDS` tinyint NOT NULL default -1, ' . # daylight saving time? (-1 default)
						 '`EditControls` int unsigned NOT NULL, ' .
						 '`ThreadsPerPage` smallint NOT NULL default -1, ' .
						 '`ThreadSort` smallint NOT NULL default -1, ' .
						 '`ThreadTime` smallint NOT NULL default -1, ' .
						 '`Favourites` text NOT NULL, ' .
						 '`Language` varchar(6) NOT NULL, ' .
						 '`DateFormat` varchar(20) NOT NULL, ' .
						 'primary key (ID),' .
						 'KEY LastActivity (LastActivity)'
			) or die('create error: ' . $db->LastError());

		$db->SetTable('Users');
		$db->AddRecord(array('ID' => 1,
							 'Name' => 'Admin',
							 'Password' => md5('admin'),
							 'RegDate' => time(),
							 'RegEMail' => 'admin@localhost',
							 'DefaultNotify' => 0,
							 'EMail' => 'admin@localhost',
							 'Jabber' => '',
							 'ICQ' => '',
							 'AIM' => '',
							 'YIM' => '',
							 'MSN' => '',
							 'LastActivity' => time(),
							 'LastForum' => 0,
							 'Signature' => '',
							 'BirthDay' => 0,
							 'BirthMonth' => 0,
							 'BirthYear' => 0,
							 'About' => '',
							 'Title' => '',
							 'Location' => '',
							 'Homepage' => '',
							 'Gender' => '',
							 'ActivateKey' => '',
							 'RecommendedBy' => '',
							 'Design' => -1,
							 'ThreadIcons' => 0,
							 'Flags' => 2 + 4 + 32 + 128 + (rc('new_layout') ? 256 : 0)
			)) or die('add error: ' . $db->LastError());


		// ------------------------------------------------------------ POLL VOTES

		$db->RemoveTable('PollVotes') or die('remove error');
		$db->CreateTable('PollVotes',
						 '`ID` int unsigned not null, ' .         # ID
						 '`Thread` int unsigned not null, ' .     # Thread this poll belongs to
						 '`Sort` tinyint not null, ' .            # Order of display
						 '`Title` varchar(100) not null, ' .      # Displayed voting option
						 '`Votes` int unsigned not null, ' .      # Number of votes for this option
						 'primary key (ID)'
			) or die('create error: ' . $db->LastError());


		// ------------------------------------------------------------ POLL USERS

		$db->RemoveTable('PollUsers') or die('remove error');
		$db->CreateTable('PollUsers',
						 '`Thread` int unsigned not null, ' .     # Thread we're talking about
						 '`User` int unsigned not null, ' .       # User that has already voted in above thread
						 '`VoteNum` int unsigned not null, ' .    # User's vote, saved to change this later
						 'primary key (Thread, User)'
			) or die('create error: ' . $db->LastError());


		// ------------------------------------------------------------ MESSAGES

		$db->RemoveTable('Messages') or die('remove error');
		$db->CreateTable('Messages',
						 '`ID` int unsigned not null, ' .         # ID
						 '`Forum` int not null, ' .               # What forum if this message belongs to (0 for any)
						 '`Date` int not null, ' .                # Date of creation
						 '`User` int unsigned not null, ' .       # User who created this message
						 '`Subject` varchar(150) not null, ' .    # Displayed subject
						 '`Msg` text not null, ' .                # Message body
						 '`Options` int unsigned not null, ' .    # several Flags...
						 'primary key (ID)'
			) or die('create error: ' . $db->LastError());


		// ------------------------------------------------------------ MESSAGE READ

		$db->RemoveTable('MessageRead') or die('remove error');
		$db->CreateTable('MessageRead',
						 '`Msg` int unsigned not null, ' .    # Message we're talking about
						 '`User` int unsigned not null'       # User that already read above message
			) or die('create error: ' . $db->LastError());


		// ------------------------------------------------------------ THREAD WATCH

		$db->RemoveTable('ThreadWatch') or die('remove error');
		$db->CreateTable('ThreadWatch',
						 '`Thread` int unsigned not null, ' .      # Thread we're talking about
						 '`User` int unsigned not null, ' .        # User that is watching above thread
						 '`Mode` tinyint unsigned not null, ' .    # Mode of notification. 1: E-Mail, 2: ICQ, 3: both
						 '`LastRead` int not null, ' .             # Timestamp of last read time
						 '`LastNotify` int not null, ' .           # Timestamp of last new-post notification
						 'PRIMARY KEY (Thread, User), ' .
						 'KEY Thread (Thread), ' .
						 'KEY User (User)'
			) or die('create error: ' . $db->LastError());


		// ------------------------------------------------------------ FORUM WATCH

		$db->RemoveTable('ForumWatch') or die('remove error');
		$db->CreateTable('ForumWatch',
						 '`Forum` int unsigned not null, ' .       # Forum we're talking about
						 '`User` int unsigned not null, ' .        # User that is watching above thread
						 '`Mode` tinyint unsigned not null, ' .    # Mode of notification. 1: E-Mail, 2: ICQ, 3: both, 4: Jabber...
						 '`Flags` tinyint unsigned not null, ' .   # More flags. 1: recursive
						 '`LastVisited` int not null, ' .          # Timestamp of last visit time
						 '`LastNotify` int not null, ' .           # Timestamp of last new-thread notification
						 'PRIMARY KEY (Forum, User), ' .
						 'KEY Forum (Forum), ' .
						 'KEY User (User)'
			) or die('create error: ' . $db->LastError());


		// ------------------------------------------------------------ USER CATEGORY STATES

		$db->RemoveTable('UserCategoryState') or die('remove error');
		$db->CreateTable('UserCategoryState',
						 '`Forum` int unsigned not null, ' .     # Forum (category) we're talking about
						 '`User` int unsigned not null, ' .      # User that has set the state
						 '`State` tinyint unsigned not null, ' . # State = 0: Collapsed, 1: Expanded
						 'primary key (Forum, User)'
			) or die('create error: ' . $db->LastError());


		// ------------------------------------------------------------ ONLINE GUESTS

		$db->RemoveTable('Guests') or die('remove error');
		$db->CreateTable('Guests',
						 '`Session` varchar(80) not null, ' .    # Guest user's PHP session ID
						 '`LastActivity` int not null, ' .       # Last update of record
						 '`LastForum` int unsigned not null'     # Last forum of guest
			) or die('create error: ' . $db->LastError());


		// ------------------------------------------------------------ STATISTICS

		$db->RemoveTable('Stat') or die('remove error');
		$db->CreateTable('Stat',
						 '`Date` int not null, ' .               # Day of record
						 '`NewThreads` int not null, ' .         # New threads created on this day
						 '`NewPosts` int not null, ' .           # New posts send on this day
						 '`OnlineUsers` int not null, ' .        # Number of users online on this day
						 '`OnlineGuests` int not null, ' .       # Number of guests online on this day
						 '`PageHits` int not null, ' .           # Number of (almost total) page hits on this day
						 '`NewUsers` int not null'               # Registrations on this day
			) or die('create error: ' . $db->LastError());

		$last_0h = getdate(convert_timezone(time()));
		$last_0h = mktime(0, 0, 0, $last_0h['mon'], $last_0h['mday'], $last_0h['year']);

		$db->SetTable('Stat');
		$db->AddRecord(array('Date' => $last_0h,
							 'NewThreads' => 1,
							 'NewPosts' => 1,
							 'OnlineUsers' => 0,
							 'OnlineGuests' => 0,
							 'PageHits' => 0,
							 'NewUsers' => 1
			)) or die('add error: ' . $db->LastError());


		// ------------------------------------------------------------ ACL

		$db->RemoveTable('ACL') or die('remove error');
		$db->CreateTable('ACL',
						 '`ID` int unsigned not null, ' .           # unique ID
						 '`User` int unsigned not null, ' .         # user ID
						 '`Group` int unsigned not null, ' .        # group ID
						 '`Action` smallint unsigned not null, ' .  # action ID
						 '`Thread` int unsigned not null, ' .       # thread ID
						 '`Forum` int unsigned not null, ' .        # forum ID
						 '`Grant` int not null, ' .                 # grant this right? | some other numeric value for it
						 '`Enabled` bool not null, ' .              # use this entry?
						 'primary key (ID), ' .
						 'UNIQUE INDEX (User, `Group`, Action, Thread, Forum)'
			) or die('create error: ' . $db->LastError());

		$db->SetTable('ACL');
		$db->AddRecord(array('ID' => 1,
							 'User' => 0,
							 'Group' => 0,
							 'Action' => 33,   // viewforum
							 'Thread' => 0,
							 'Forum' => 0,
							 'Grant' => 1,
							 'Enabled' => 1
			)) or die('add error: ' . $db->LastError());
		$db->AddRecord(array('ID' => 2,
							 'User' => 0,
							 'Group' => 1,
							 'Action' => 82,   // user rights
							 'Thread' => 0,
							 'Forum' => 0,
							 'Grant' => 1,
							 'Enabled' => 1
			)) or die('add error: ' . $db->LastError());
		$db->AddRecord(array('ID' => 3,
							 'User' => 0,
							 'Group' => 2,
							 'Action' => 83,   // mod rights
							 'Thread' => 0,
							 'Forum' => 0,
							 'Grant' => 1,
							 'Enabled' => 1
			)) or die('add error: ' . $db->LastError());
		$db->AddRecord(array('ID' => 4,
							 'User' => 0,
							 'Group' => 3,
							 'Action' => 84,   // admin rights
							 'Thread' => 0,
							 'Forum' => 0,
							 'Grant' => 1,
							 'Enabled' => 1
			)) or die('add error: ' . $db->LastError());


		// ------------------------------------------------------------ GROUP MEMBERS

		$db->RemoveTable('GroupMembers') or die('remove error');
		$db->CreateTable('GroupMembers',
						 '`Group` int unsigned not null, ' .   # group ID
						 '`User` int unsigned not null, ' .    # user ID
						 'primary key (`Group`, User)'
			) or die('create error: ' . $db->LastError());

		$db->SetTable('GroupMembers');
		$db->AddRecord(array('Group' => 1,
							 'User' => 1
			)) or die('add error: ' . $db->LastError());
		$db->AddRecord(array('Group' => 3,
							 'User' => 1
			)) or die('add error: ' . $db->LastError());


		// ------------------------------------------------------------ GROUP NAMES

		$db->RemoveTable('GroupNames') or die('remove error');
		$db->CreateTable('GroupNames',
						 '`ID` int unsigned not null, ' .         # group ID
						 '`Name` varchar(50) not null, ' .        # group name
						 '`ShowInTeam` tinyint(1) not null, ' .   # show in the team list
						 'primary key (ID)'
			) or die('create error: ' . $db->LastError());

		$db->SetTable('GroupNames');
		$db->AddRecord(array('ID' => 1,
							 'Name' => $T['inst_grp_users'],
							 'ShowInTeam' => 0
			)) or die('add error: ' . $db->LastError());
		$db->AddRecord(array('ID' => 2,
							 'Name' => $T['inst_grp_gmods'],
							 'ShowInTeam' => 1
			)) or die('add error: ' . $db->LastError());
		$db->AddRecord(array('ID' => 3,
							 'Name' => $T['inst_grp_admins'],
							 'ShowInTeam' => 1
			)) or die('add error: ' . $db->LastError());

		echo $T['inst_login'] . '<br />';

		$user = new IUser;
		if ($userid = $user->FindByName('Admin'))
		{
			if (create_session($userid, md5('admin'), $user->GetPassword(), $user->GetFlags() & 32))
			{
				$user->SetLastLogin();
			}
		}

		echo '<b>' . $T['inst_done'] . '</b>';
		echo '</p>';

		echo '<p class="info"><b>' . $T['inst_db_complete'] . '</b></p>';

		echo '<p>' . $T['inst_complete_note'] . '</p>';

		if (!rc('nowrite')) touch('lock.conf');
		echo '<p>' . $T['inst_lock'] . '</p>';

		echo '<p><a href="' . $MODULE['cp'] . PD . 'item=1' . sid() . '">' . $T['inst_go_cp'] . '</a></p>';
	} // if type = 1

	if ($type == 2)   // UPGRADE
	{
		echo '<p>';
		echo $T['inst_check_db_layout'] . '<br />';

		$cols = $db->ListTableCols('ForumWatch');
		if (!$cols)
		{
			$db->RemoveTable('ForumWatch') or die('remove table error: ' . t2h($db->LastError()));
			$db->CreateTable('ForumWatch',
							 '`Forum` int unsigned not null, ' .       # Forum we're talking about
							 '`User` int unsigned not null, ' .        # User that is watching above thread
							 '`Mode` tinyint unsigned not null, ' .    # Mode of notification. 1: E-Mail, 2: ICQ, 3: both, 4: Jabber...
							 '`Flags` tinyint unsigned not null, ' .   # More flags. 1: recursive
							 '`LastVisited` int not null, ' .          # Timestamp of last visit time
							 '`LastNotify` int not null, ' .           # Timestamp of last new-thread notification
							 'PRIMARY KEY (Forum, User), ' .
							 'KEY Forum (Forum), ' .
							 'KEY User (User)'
				) or die('create table error: ' . t2h($db->LastError()));
		}

		$cols = $db->ListTableCols('Forums');
		if (!$cols['Link'])
		{
			$db->AddField('Forums', 'Link', 'varchar(255) NOT NULL', 'Description') or die('add column error: ' . t2h($db->LastError()));
		}
		if ($cols['IsCategory'])
		{
			$db->AddField('Forums', 'Flags', 'int NOT NULL', 'Name') or die('add column error: ' . t2h($db->LastError()));
			$db->ChangeRecord(array('Flags' => 1), 'IsCategory', 'Forums') or die('update row error: ' . t2h($db->LastError()));
			$db->RemoveField('Forums', 'IsCategory') or die('remove column error: ' . t2h($db->LastError()));
		}
		if (strpos($cols['Description']['Type'], 'char') !== false)
		{
			$db->ChangeField('Forums', 'Description', 'Description', 'text NOT NULL') or die('alter column error: ' . t2h($db->LastError()));
		}

		$cols = $db->ListTableCols('Posts');
		if (strpos($cols['User']['Type'], 'unsigned') !== false)
		{
			$db->ChangeField('Posts', 'User', 'User', 'int NOT NULL') or die('alter column error: ' . t2h($db->LastError()));
		}

		$cols = $db->ListTableCols('Users');
		if (strpos($cols['Language']['Type'], '(5)') !== false)
		{
			$db->ChangeField('Users', 'Language', 'Language', 'varchar(6) NOT NULL') or die('alter column error: ' . t2h($db->LastError()));
		}

		$cols = $db->ListTableCols('GroupNames');
		if (!$cols['ShowInTeam'])
		{
			$db->AddField('GroupNames', 'ShowInTeam', 'tinyint(1) NOT NULL', 'Name') or die('add column error: ' . t2h($db->LastError()));
			$db->ChangeRecord(array('ShowInTeam' => 1), 'ID IN (2,3)', 'GroupNames') or die('update row error: ' . t2h($db->LastError()));
		}

		$acl = $db->FastQuery1st('ACL', 'COUNT(*)', 'Action IN (71,72, 73, 74)');
		if ($acl > 0)
		{
			$db->ChangeRecord('`Action` = `Action` + 10', 'Action IN (71,72,73,74)', 'ACL') or die('update row error: ' . t2h($db->LastError()));
		}

		$cols = $db->ListTableCols('Messages');
		if (strpos($cols['Forum']['Type'], 'unsigned') !== false)
		{
			$db->ChangeField('Messages', 'Forum', 'Forum', 'int NOT NULL') or die('alter column error: ' . t2h($db->LastError()));
		}

		echo $T['inst_check_db_integrity'] . '<br />';

		// Add thread-has-attachment flags
		$thread = new IThread;
		$post = new IPost;
		if ($thread->Find()) do
		{
			$found = $post->Find('AttachFile<>""', '', 1);

			$opt = $thread->GetOptions();
			$opt = ($opt & ~16) | (($found ? 1 : 0) * 16);
			$thread->SetOptions($opt);   // no error detection here
		}
		while ($thread->FindNext());

		echo '<b>' . $T['inst_done'] . '</b>';
		echo '</p>';

		if (!rc('nowrite')) touch('lock.conf');
		echo '<p>' . $T['inst_lock'] . '</p>';

		echo '<p><a href="' . $MODULE['cp'] . PD . 'item=1' . sid() . '">' . $T['inst_go_cp'] . '</a></p>';
	} // if type = 2

	if ($type == 3)   // IMPORT
	{
		echo '<p>' . $T['inst_import_note'] . '</p>';

		// scan local import module files
		$modules = array();
		$handle = @opendir('.');
		if ($handle !== false)
		{
			while ($file = readdir($handle))
				if (preg_match('/^import_[A-Za-z0-9\-]+\.php$/', $file))
				{
					$lines = file($file);
					foreach ($lines as $line)
					{
						if (preg_match('~^\s*//\s*TYPE:\s*(.*)$~i', $line, $m))
						{
							$modules[] = array('file' => $file, 'type' => $m[1]);
							break;
						}
					}
				}
			closedir($handle);
		}

		echo '<p>';
		if ($modules)
		{
			foreach ($modules as $mod)
			{
				echo '<a href="' . $mod['file'] . sid(0) . '">' . t2h($mod['type']) . '</a><br />';
			}
		}
		else
		{
			echo $T['inst_import_not_found'];
		}
		echo '</p>';
	} // if type = 3

	if ($type == 9)   // UNINSTALL
	{
		echo '<p>';

		echo $T['uninst_remove_tbl'] . ': Forums<br />';
		if (!$db->RemoveTable('Forums')) echo 'remove error: ' . $db->LastError();

		echo $T['uninst_remove_tbl'] . ': Threads<br />';
		if (!$db->RemoveTable('Threads')) echo 'remove error';

		echo $T['uninst_remove_tbl'] . ': Posts<br />';
		if (!$db->RemoveTable('Posts')) echo 'remove error';

		echo $T['uninst_remove_tbl'] . ': Users<br />';
		if (!$db->RemoveTable('Users')) echo 'remove error';

		echo $T['uninst_remove_tbl'] . ': PollVotes<br />';
		if (!$db->RemoveTable('PollVotes')) echo 'remove error';

		echo $T['uninst_remove_tbl'] . ': PollUsers<br />';
		if (!$db->RemoveTable('PollUsers')) echo 'remove error';

		echo $T['uninst_remove_tbl'] . ': Messages<br />';
		if (!$db->RemoveTable('Messages')) echo 'remove error';

		echo $T['uninst_remove_tbl'] . ': MessageRead<br />';
		if (!$db->RemoveTable('MessageRead')) echo 'remove error';

		echo $T['uninst_remove_tbl'] . ': ThreadWatch<br />';
		if (!$db->RemoveTable('ThreadWatch')) echo 'remove error';

		echo $T['uninst_remove_tbl'] . ': ForumWatch<br />';
		if (!$db->RemoveTable('ForumWatch')) echo 'remove error';

		echo $T['uninst_remove_tbl'] . ': UserCategoryState<br />';
		if (!$db->RemoveTable('UserCategoryState')) echo 'remove error';

		echo $T['uninst_remove_tbl'] . ': Guests<br />';
		if (!$db->RemoveTable('Guests')) echo 'remove error';

		echo $T['uninst_remove_tbl'] . ': Stat<br />';
		if (!$db->RemoveTable('Stat')) echo 'remove error';

		echo $T['uninst_remove_tbl'] . ': ACL<br />';
		if (!$db->RemoveTable('ACL')) echo 'remove error';

		echo $T['uninst_remove_tbl'] . ': GroupNames<br />';
		if (!$db->RemoveTable('GroupNames')) echo 'remove error';

		echo $T['uninst_remove_tbl'] . ': GroupMembers<br />';
		if (!$db->RemoveTable('GroupMembers')) echo 'remove error';

		echo '<br />';
		echo '<b>' . $T['uninst_complete'] . '</b>';
		echo '</p>';
	} // if type = 9
}

EndHTML();
?>
